#!/bin/sh

# This script is run by pppd after the link is established.
# It executes all the scripts available in /etc/ppp/ip-up.d directory,
# with the following parameters:
# $1 = interface name (e.g. ppp0)
# $2 = tty device
# $3 = speed
# $4 = local IP address
# $5 = remote IP address
# $6 = ipparam (user specified parameter, see man pppd)

LOGGER=/usr/bin/logger
STATEPATH=/var/state

BASEFILE="ROUTE..."

INTERFACE=$1
DEVICE=$2
SPEED=$3
LOCALIP=$4
REMOTEIP=$5
IPPARAM=$5

ROUTE_FILE=$STATEPATH/${BASEFILE}${INTERFACE}

if [ -f $ROUTE_FILE ]; then
  # デフォルトルートを削除
  route del default dev $INTERFACE

  # デフォルトルートを設定
  COUNT=0
  MAXCOUNT=`cat ${STATEPATH}/${BASEFILE}${INTERFACE} | wc | awk '{ print $1}'`

  while [ $COUNT -lt $MAXCOUNT ]; do
      VALUE=`lines -l $COUNT -f ${STATEPATH}/${BASEFILE}${INTERFACE}`
      [ $? -ne 0 ] && break
      GATEWAY=`echo $VALUE | awk '{print $2}'`
      METRIC=`echo $VALUE | awk '{print $5}'`
      IFACE=`echo $VALUE | awk '{print $8}'`
      route add default gw $GATEWAY metric $METRIC dev $IFACE
      COUNT=$(($COUNT+1))
  done

  if [ -f ${STATEPATH}/${BASEFILE}${INTERFACE} ]; then
      rm -f ${STATEPATH}/${BASEFILE}${INTERFACE}
  fi
fi

echo "ppid is $PPID"
kill $PPID
