#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx Web Application Server Module
#   Database Access Module
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
#
# Copyright (C) 2007-2008 Century Systems Co.,Ltd.
# Last Modified: 2009/05/25 13:03:47 kikuchi
#

import sqlalchemy
from sqlalchemy.orm import scoped_session, sessionmaker

import config

__all__ = ['Session', 'metadata']

if config.debug == True:
    dbfile = "/tmp/testdb.db"
else:
    dbfile = "/etc/MA_Conf.db"

print "dbconn: DebuggingMode = %s, dbfile = '%s'" % (str(config.debug), dbfile)


def create_engine():
    engine = sqlalchemy.create_engine("sqlite:///%s" % dbfile)

    return engine

engine = create_engine()
metadata = sqlalchemy.MetaData(engine)

Session = scoped_session(sessionmaker(autoflush = True,
                                      transactional = True,
                                      bind = engine))
