#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   /etc/ppp/peers/mgetty output module
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
#
# Copyright (C) 2008 Century Systems Co.,Ltd.
# Last Modified: 2010/05/10 15:14:16 kikuchi
#

from datetime import datetime

class masq(object):
    def __init__(self, searchList, append=None):
        params = searchList.get('params', {})
        fw_masqs = params.get('fw_masq', [])

        response = [
            u"#",
            u"# Shorewall version 4.0 - Sample Masq file for two-interface configuration.",
            u"# Copyright (C) 2006 by the Shorewall Team",
            u"#",
            u"# This library is free software; you can redistribute it and/or",
            u"# modify it under the terms of the GNU Lesser General Public",
            u"# License as published by the Free Software Foundation; either",
            u"# version 2.1 of the License, or (at your option) any later version."
            u"#",
            u"# See the file README.txt for further details.",
            u"#------------------------------------------------------------------------------",
            u"# For information about entries in this file, type \"man shorewall-masq\"",
            u"#",
            u"# For additional information, see http://shorewall.net/Documentation.htm#Masq",
            u"#",
            u"###############################################################################",
            u"#INTERFACE        SUBNET      ADDRESS     PROTO   PORT(S) IPSEC   MARK"]


        for fw_masq in fw_masqs:
            response.append(u"%-16s%s" % (fw_masq['dst_if'], fw_masq['src_if']))

        response.append(u"#LAST LINE -- ADD YOUR ENTRIES ABOVE THIS LINE -- DO NOT REMOVE")

        self.__response = response

    def respond(self):
        return u"%s\n" % '\n'.join(self.__response)
