#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#  /etc/shorewall/nat output module
#
# Copyright (C) 2009 Century Systems Co.,Ltd.
#

class nat(object):
    __header = """
#
# Shorewall version 4 - Nat File
#
# For information about entries in this file, type "man shorewall-nat"
#
# For additional information, see http://shorewall.net/NAT.htm
#
###############################################################################
#EXTERNAL       INTERFACE       INTERNAL        ALL             LOCAL
#                                               INTERFACES                     
"""

    __footer = """
#LAST LINE -- ADD YOUR ENTRIES ABOVE THIS LINE -- DO NOT REMOVE
"""

    def __init__(self, searchList, append=None):
        params = searchList.get('params', {})
        fw_nat = params.get('fw_nat', [])

        lines = []

        for entry in fw_nat:
            lines.append(u"%-15s %-15s %-15s %-15s %-15s" % \
                    (entry['ext_address'],
                     entry['interface'],
                     entry['int_address'],
                     'no',
                     'no'))

        self.__response = self.__header + \
                '\n'.join(lines) + '\n' + self.__footer

    def respond(self):
        return self.__response
        
