#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   /etc/shorewall/routestopped output module
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
#
# Copyright (C) 2008 Century Systems Co.,Ltd.
# Last Modified: 2010/05/10 15:14:30 kikuchi
#

class routestopped(object):
    def __init__(self, searchList, append=None):
        params = searchList['params']

        interfaces = params.get('fw_interface', [])

        response = [
            u"#",
            u"# Shorewall version 4.0 - Sample Routestopped File for two-interface configuration.",
            u"# Copyright (C) 2006 by the Shorewall Team",
            u"#",
            u"# This library is free software; you can redistribute it and/or"
            u"# modify it under the terms of the GNU Lesser General Public",
            u"# License as published by the Free Software Foundation; either",
            u"# version 2.1 of the License, or (at your option) any later version."
            u"#",
            u"# See the file README.txt for further details.",
            u"#------------------------------------------------------------------------------",
            u"# For information about entries in this file, type \"man shorewall-routestopped\"",
            u"#",
            u"# See http://shorewall.net/Documentation.htm#Routestopped and",
            u"# http://shorewall.net/starting_and_stopping_shorewall.htm for additional",
            u"# information.",
            u"#",
            u"##############################################################################",
            u"#INTERFACE    HOST(S)                  OPTIONS"]

        for interface in interfaces:
            response.append(u"%-12s-" % interface['name'])

        response.append(u"#LAST LINE -- ADD YOUR ENTRIES BEFORE THIS ONE -- DO NOT REMOVE")

        self.__response = response

    def respond(self):
        return u"%s\n" % '\n'.join(self.__response)

