#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   /etc/ppp/chap-secrets output module (replaced)
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
#
# Copyright (C) 2008 Century Systems Co.,Ltd.
# Last Modified: 2010/05/10 15:15:20 kikuchi
#

import os

class chap_secrets(object):
    def __init__(self, searchList, append=None):
        params = searchList.get('params', {})
        Secrets = params.get('Secrets', [])

        # MA-E250/Fの場合
        foma = os.path.isfile("/proc/driver/foma_status")
        if foma == True:
            TmpSecrets = []
            for secret in Secrets:
                account = secret['account']
                unit = secret['unit']
                password = secret['password']
                duplication = False
                for tmpsecret in TmpSecrets:
                    if account == tmpsecret['account']:
                        if account != '':
                            duplication = True
                            tmpsecret['unit'] = "*"
                if duplication == False:
                    TmpSecrets.append({
                            'account' : account,
                            'unit' : "ppp%d" % unit,
                            'password' : password
                            })
            Secrets = TmpSecrets

        len_max = {'client' : len('client'),
                   'secret' : len('secret')}

        for secret in Secrets:
            length = len(secret['account'])
            if length > len_max['client']:
                len_max['client'] = length

            length = len(secret['password'])
            if length > len_max['secret']:
                len_max['secret'] = length

        #print "*** len_max = %s" % str(len_max)

        format = ''.join([u"%%-%ds" % (len_max['client'] + 6),
                          u"%-8s",
                          u"%%-%ds" % (len_max['secret'] + 4),
                          u"%s"])

        response = [u"# Secrets for authentication using CHAP/PAP",]

        response.append(format % ('# client', 'server', 'secret', 'IP addresses'))

        for secret in Secrets:
            #print "secret: %s" % str(secret)

            account = secret['account']
            if account == '':
                # OCN IPv6 設定無しの場合
                # MA-E250/Fの場合
                if foma == True:
                    account = secret['unit']
                else:
                    account = "ppp%d" % secret['unit']

            # MA-E250/Fの場合
            if foma == True:
                response.append(format % (
                    "\"%s\"" % account,
                    "%s" % secret['unit'],
                    "\"%s\"" % secret['password'], "*"))
            else:
                response.append(format % (
                    "\"%s\"" % account,
                    "ppp%d" % secret['unit'],
                    "\"%s\"" % secret['password'], "*"))

        self.__response = response

    def respond(self):
        return "%s\n" % '\n'.join(self.__response)
