#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#  /etc/dhcp6c.conf output module
#
# Copyright (C) 2008 Century Systems Co.,Ltd.
#

class dhcp6c_conf(object):

    __template = """
########################################
# dhcp6c configuration for OCN IPv6
# Generated by MA-E2xx WebUI
########################################

# The followings are a sample configuration for requiring the "stateless"
# DHCPv6 service.
interface %(IF_LAN)s {
    #information-only;
};


# The followings are a sample configuration to be delegated an IPv6 prefix
# from an upstream service provider. With this configuration dhcp6c will
# send solicit messages containing an IA_PD option, with an IAID 0, on to
# an upstream PPP link, ppp0. After receiving some prefixes from a server,
# dhcp6c will then configure derived IPv6 prefixes with the SLA ID 1 on a
# local ethernet interface, ne0. Note that the IAID for the id-assoc
# statement is 0 according to the default.

interface ppp100 {
    send ia-pd 0;
};

id-assoc pd 0 {
    prefix-interface %(IF_LAN)s {
        sla-id 1;
        sla-len 0;
    };
};
"""

    def __init__(self, searchList, append=None):
        params = searchList.get('params', {})

        try:
            info = params['OCNv6']
        except:
            print "dhcp6c_conf: parameter error."
            return

        arg = {}
        arg['IF_LAN'] = info['interface']

        self.__response = self.__template % arg

    def respond(self):
        return self.__response

