#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#  /etc/l2tp/l2tp.conf output module
#
# Copyright (C) 2008 Century Systems Co.,Ltd.
#

class l2tp_conf(object):

    __template = """
########################################
# rp-l2tpd configuration
# Generated by MA-E2xx WebUI
########################################
# comment

# Global section (by default, we start in global mode)
global

# Load handlers
load-handler "sync-pppd.so"
load-handler "cmd.so"

# Bind address
listen-port %(LISTEN_PORT)d
hostname %(HOSTNAME)s

# Configure the sync-pppd handler.  You MUST have a "section sync-pppd" line
# even if you don't set any options.
section sync-pppd
lac-pppd-opts "call v6tun"

section peer
peer %(SERVER)s
persist true
holdoff 30
maxfail 10

# No secret - no authentication
port %(LISTEN_PORT)d
lac-handler sync-pppd
lns-handler sync-pppd

# Configure the cmd handler.  You MUST have a "section cmd" line
# even if you don't set any options.
section cmd
"""

    def __init__(self, searchList, append=None):
        params = searchList.get('params', {})

        try:
            info = params['OCNv6']
        except:
            print "l2tp_conf: parameter error."
            return

        arg = {}
        if "l2tp_port" in info:
            arg['LISTEN_PORT'] = int(info['l2tp_port'])
        else:
            arg['LISTEN_PORT'] = 1701

        arg['HOSTNAME'] = info['account']
        arg['SERVER'] = info['l2tp_server']

        self.__response = self.__template % arg

    def respond(self):
        return self.__response
