#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   /etc/mgetty+sendfax/login.config output module
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
#
# Copyright (C) 2008 Century Systems Co.,Ltd.
# Last Modified: 2010/05/10 15:14:51 kikuchi
#

class login_config(object):
    def __init__(self, searchList, append=None):
        pass

    def respond(self):
        return """
# login.config
#
# This is a sample \"login dispatcher\" configuration file for mgetty
#
# Format:
#   username userid utmp_entry login_program [arguments]
#
# Meaning:
#       for a \"username\" entered at mgettys login: prompt, call
#   \"login_program\" with [arguments], with the uid set to \"userid\",
#   and a USER_PROCESS utmp entry with ut_user = \"utmp_entry\"
#
# username may be prefixed / suffixed by \"*\" (wildcard)
#
# userid is a valid user name from /etc/passwd, or \"-\" to not set
#  a login user id and keep the uid/euid root (needed for /bin/login)
#
# utmp_entry is what will appear in the \"who\" listing. Use \"-\" to not
#  set an utmp entry (a must for /bin/login), use \"@\" to set it to the
#  username entered. Maximum length is 8 characters.
#
# login_program is the program that will be exec()ed, with the arguments
#  passed in [arguments]. A \"@\" in the arguments will be replaced with the
#  username entered. Warning: if no \"@\" is given, the login_program has
#  no way to know what user name the user entered.
#
#
# SAMPLES:
# Use this one with my Taylor-UUCP and Taylor-UUCP passwd files. 
#  (Big advantage: tuucp can use the same passwd file for serial dial-in 
#   and tcp dial-in [uucico running as in.uucpd]). Works from 1.05 up.
#
#U* uucp    @   /usr/lib/uucp/uucico -l -u @

#
# Use this one for fido calls (login name /FIDO/ is handled specially)
#
# You need Eugene Crosser's \"ifmail\" package for this to work.
#  mgetty has to be compiled with \"-DFIDO\", otherwise a fido call won't
#  be detected.
#
#/FIDO/ uucp    fido    /usr/local/lib/fnet/ifcico @

#
# Automatic PPP startup on receipt of LCP configure request (AutoPPP).
#  mgetty has to be compiled with \"-DAUTO_PPP\" for this to work.
#  Warning: Case is significant, AUTOPPP or autoppp won't work!
#  Consult the \"pppd\" man page to find pppd options that work for you.
#
#  NOTE: for *some* users, the \"-detach\" option has been necessary, for 
#        others, not at all. If your pppd doesn't die after hangup, try it.
#
#  NOTE2: \"debug\" creates lots of debugging info.  LOOK AT IT if things
#         do not work out of the box, most likely it's a ppp problem!
#
#  NOTE3: \"man pppd\" is your friend!
#
#  NOTE4: max. 9 arguments allowed.
#
#/AutoPPP/ -    a_ppp   /usr/sbin/pppd auth -chap +pap debug kdebug 7
/AutoPPP/ - a_ppp   /usr/sbin/pppd call ppp50

#
#
# An example where no login name in the argument list is desired:
#  automatically telnetting to machine \"smarty\" for a given login name
#
#telnet-smarty  gast    telnet  /usr/bin/telnet -8 smarty
#
# This is the \"standard\" behaviour - *dont* set a userid or utmp
#  entry here, otherwise /bin/login will fail!
#  This entry isn't really necessary: if it's missing, the built-in
#  default will do exactly this.
#
*   -   -   /bin/login @
"""
