#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   /etc/mgetty+sendfax/mgetty.config output module
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
#
# Copyright (C) 2008 Century Systems Co.,Ltd.
# Last Modified: 2010/05/10 14:45:40 kikuchi
#

from datetime import datetime
import re
import syslog

syslog_header = "Template.mgetty_config"

class mgetty_config(object):
    def __init__(self, searchList, append=None):
        params = searchList.get('params', {})

        mgetty_conf = params.get('PPP_dialin', {})

        if mgetty_conf.get('dev_name', 'NTT docomo(UM02-F)') == 'NTT docomo(UM02-F)':
            # UM02-F̏ꍇ
            bps = 460800
        else:
            bps = 115200

        response = [
            u"#" * 80,
            u"## /etc/mgetty+sendfax/mgetty.conf (for mgetty dialin)",
            u"## Generated by MA-E2xx WebUI at %s" % datetime.now().isoformat(' '),
            u"#" * 80,
            u"",
            u"# ----- global section -----",
            u"#",
            u"# In this section, you put the global defaults, per-port stuff is below",
            u"",
            u"# set the global debug level to \"4\" (default from policy.h)",
            u"debug 4",
            u"",
            u"# set the local fax station id",
            u"#fax-id 49 115 xxxxxxxx",
            u"",
            #u"# access the modem(s) 115200 bps",
            #u"speed 115200",
            #u"",
            u"# ----- port specific section -----",
            u"#",
            u"# Here you can put things that are valid only for one line, not the others",
            u"#",
            u""]

        dev_node = mgetty_conf.get('dev_node', '/dev/ttyS1')

        try:
            dev = re.match("/dev/(tty.+)", dev_node).groups()[0]
        except:
            syslog.syslog("%s: dev_node error! ('%s')" % \
                          (syslog_header, dev_node))
            self.__reponse = response
            return

        response.append(u"port %s" % dev)
        response.append(u"  debug 7")

        modeminit = mgetty_conf.get('modeminit', 'AT&FS0=0')
        response.append(u"  init-chat \"\" AT OK %s OK" % modeminit)

        response.append(u"  speed %d" % bps)

        response.append(u"  data-only yes")
        response.append(u"  toggle-dtr yes")
        response.append(u"  need-dsr yes")
        response.append(u"  port-owner root")
        response.append(u"  port-group root")
        response.append(u"  port-mode 600")

        self.__response = response

    def respond(self):
        return u"%s\n" % '\n'.join(self.__response)
