#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#  /etc/conf.d/ntp-client output module
#
# Copyright (C) 2008 Century Systems Co.,Ltd.
#

class ntp_client(object):

    __template = """
##################################################
# Generated by MA-E2xx WebUI
# /etc/conf.d/ntp-client
##################################################

# Command to run to set the clock initially
# Most people should just leave this line alone ...
# however, if you know what you're doing, and you
# want to use ntpd to set the clock, change this to 'ntpd'
NTPCLIENT_CMD="ntpdate"

# Options to pass to the above command
# This default setting should work fine but you should
# change the default 'pool.ntp.org' to something closer
# to your machine.  See http://www.pool.ntp.org/ or
# try running `netselect -s 3 pool.ntp.org`.

%(COMMENT)sNTPCLIENT_OPTS="-s -b -u %(SERVER)s"
"""

    def __init__(self, searchList, append=None):
        params = searchList.get('params', {})

        try:
            info = params['NTP']['ntp_info']
        except:
            print "ntp_client: parameter error."
            return

        arg = {}
        if info['use_ntp'] and info['ntp_server_primary']:
            arg['SERVER'] = info['ntp_server_primary']
            arg['COMMENT'] = ''
        else:
            arg['SERVER'] = 'ntp.nict.jp'
            arg['COMMENT'] = '#'

        self.__response = self.__template % arg

    def respond(self):
        return self.__response


