#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#  /etc/ntp.conf output module
#
# Copyright (C) 2008 Century Systems Co.,Ltd.
#

class ntp_conf(object):

    __template = """
# Generated by MA-E2xx WebUI
#
# NOTES:
#  - you should only have to update the server line below
#  - if you start getting lines like 'restrict' and 'fudge'
#    and you didnt add them, AND you run dhcpcd on your
#    network interfaces, be sure to add '-Y -N' to the
#    dhcpcd_ethX variables in /etc/conf.d/net

# Name of the servers ntpd should sync with
# Please respect the access policy as stated by the responsible person.

server %(PRIMARY_SERVER)s
server %(SECONDARY_SERVER)s
server 127.127.1.1
fudge 127.127.1.1 stratum 10

# you should not need to modify the following paths
driftfile       /var/lib/ntp/ntp.drift

# Warning: Using default NTP settings will leave your NTP
# server accessible to all hosts on the Internet.

# If you want to deny all machines (including your own)
# from accessing the NTP server, uncomment:
#restrict default ignore

# To deny other machines from changing the
# configuration but allow localhost:
restrict default nomodify nopeer
restrict 127.0.0.1

# To allow machines within your network to synchronize
# their clocks with your server, but ensure they are
# not allowed to configure the server or used as peers
# to synchronize against, uncomment this line.
#
#restrict 192.168.0.0 mask 255.255.255.0 nomodify nopeer notrap
"""

    def __init__(self, searchList, append=None):
        params = searchList.get('params', {})

        try:
            info = params['NTP']['ntp_info']
        except:
            print "ntp_conf: parameter error."
            return

        arg = {}
        arg['PRIMARY_SERVER'] = info['ntp_server_primary']
        arg['SECONDARY_SERVER'] = info['ntp_server_secondary']

        self.__response = self.__template % arg

    def respond(self):
        return self.__response

