#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   /etc/ser2net.conf output module
#
# Copyright (C) 2008 Century Systems Co.,Ltd.
#

from datetime import datetime

states = ('off', 'raw', 'rawlp', 'telnet')

class ser2net_conf(object):
    def __init__(self, searchList, append=None):
        params = searchList.get('params', {})

        ser2net = params.get('Ser2net', {})
        ports = ser2net.get('ports', [])

        self.__response = [
            u"#" * 80,
            u"## /etc/ser2net.conf",
            u"## Generated by MA-E2xx WebUI at %s" % datetime.now().isoformat(' '),
            u"#" * 80,
            u"",
            u"BANNER:telban:Welcome to ser2net TCP port \\p device \\d\\r\\n\\",
            u"second line \\",
            u"third line\\r\\n",
            u""]

        for port in ports:

            try:
                state = port.get('state', 0)
                state_str = states[state]
            except:
                state_str = ""

            stopbits = port.get('stopbits', 1)
            if stopbits == 2:
                stopbits_str = "2STOPBITS"
            else:
                stopbits_str = "1STOPBIT"

            flow = port.get('flow', 'NONE')
            if flow == 'SOFT':
                flow_str = "-RTSCTS XONXOFF"
            elif flow == 'HARD':
                flow_str = "RTSCTS -XONXOFF"
            else:
                flow_str = "-RTSCTS -XONXOFF"

            local = port.get('local', True)
            if local:
                local_str = "LOCAL"
            else:
                local_str = "-LOCAL"

            remctl = port.get('remctl', False)
            if remctl and state_str == 'telnet':
                remctl_str = "remctl"
            else:
                remctl_str = ""

            if state_str == 'telnet':
                telban_str = "telban"
            else:
                telban_str = ""

            str = [
                    u"%d:" % port.get('port', 0),
                    u"%s:" % state_str,
                    u"%d:" % port.get('timeout', 0),
                    u"%s:" % port.get('dev_node', ''),
                    u"%d " % port.get('bps', 115200),
                    u"%s " % port.get('parity', 'NONE'),
                    u"%s " % stopbits_str,
                    u"%dDATABITS " % port.get('databits', 8),
                    u"%s " % flow_str,
                    u"%s " % local_str,
                    u"%s " % remctl_str,
                    u"%s" % telban_str]

            self.__response.append(''.join(str))

    def respond(self):
        return u"%s\n" % '\n'.join(self.__response)
