#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   Template FrontEnd (PPP dialin)
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
# Copyright (C) 2008 Century Systems Co.,Ltd.
#
# Last Modified: 2010/05/10 15:13:43 kikuchi
#

from Utils import Utils

# Template FrontEnd Base
from Template_Base import Template_Base

# Template modules
from Modules.mgetty.login_config  import login_config
from Modules.mgetty.mgetty_config import mgetty_config
from Modules.mgetty.peers_mgetty  import peers_mgetty

from Modules.chap_secrets         import chap_secrets
from Modules.dnsmasq_conf         import dnsmasq_conf

#===============================================================================
#
# TemplateModule FrontEnd (PPP dialin)
#
#===============================================================================
class Template_PPP_dialin(Template_Base):
    def __init__(self, debug=False, prefix=''):
        self.super = Template_Base

        self.module_list = [
            ### chap-secrets / pap-secrets
            {'name'   : 'chap_secrets',
             'file'   : ('/etc/ppp/chap-secrets',
                         'etc_ppp_chap-secrets'),
             'module' : chap_secrets},
            {'name'   : 'pap_secrets',
             'file'   : ('/etc/ppp/pap-secrets',
                         'etc_ppp_pap-secrets'),
             'module' : chap_secrets},
            ## dnsmasq
            {'name'   : 'dnsmasq.conf',
             'file'   : ('/etc/dnsmasq.conf',
                         'etc_dnsmasq_conf'),
             'module' : dnsmasq_conf},
            ## mgetty+sendfax
            {'name'   : 'login_config',
             'file'   : ('/etc/mgetty+sendfax/login.config',
                         'etc_mgetty_login.config'),
             'module' : login_config},
            {'name'   : 'mgetty_config',
             'file'   : ('/etc/mgetty+sendfax/mgetty.config',
                         'etc_mgetty_mgetty.config'),
             'module' : mgetty_config},
            {'name'   : 'peers_mgetty',
             'file'   : ('/etc/ppp/peers/ppp50',
                         'etc_ppp_peers_ppp50'),
             'module' : peers_mgetty}]

        # Superclass Constructor
        self.super.__init__(self, debug, prefix)
