#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   Template FrontEnd (Shorewall)
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
# Copyright (C) 2007 Century Systems Co.,Ltd.
#
# Last Modified: 2010/05/10 15:13:48 kikuchi
#

# Template FrontEnd Base
from Template_Base import Template_Base

# Template modules
from Modules.Shorewall.interfaces     import interfaces
from Modules.Shorewall.masq           import masq
from Modules.Shorewall.policy         import policy
from Modules.Shorewall.routestopped   import routestopped
from Modules.Shorewall.rules          import rules
from Modules.Shorewall.shorewall_conf import shorewall_conf
from Modules.Shorewall.zones          import zones
from Modules.Shorewall.nat            import nat

#===============================================================================
#
# TemplateModule FrontEnd (Shorewall)
#
#===============================================================================
class Template_Shorewall(Template_Base):
    def __init__(self, debug=False, prefix=''):
        self.super = Template_Base

        self.module_list = [
            {'name'   : 'interfaces',
             'file'   : ('/etc/shorewall/interfaces',
                         'etc_shorewall_interfaces'),
             'module' : interfaces},
            {'name'   : 'masq',
             'file'   : ('/etc/shorewall/masq',
                         'etc_shorewall_masq'),
             'module' : masq},
            {'name'   : 'policy',
             'file'   : ('/etc/shorewall/policy',
                         'etc_shorewall_policy'),
             'module' : policy},
            {'name'   : 'routestopped',
             'file'   : ('/etc/shorewall/routestopped',
                         'etc_shorewall_routestopped'),
             'module' : routestopped},
            {'name'   : 'rules',
             'file'   : ('/etc/shorewall/rules',
                         'etc_shorewall_rules'),
             'module' : rules},
            {'name'   : 'shorewall_conf',
             'file'   : ('/etc/shorewall/shorewall.conf',
                         'etc_shorewall_shorewall_conf'),
             'module' : shorewall_conf},
            {'name'   : 'zones',
             'file'   : ('/etc/shorewall/zones',
                         'etc_shorewall_zones'),
             'module' : zones},
            {'name'   : 'nat',
             'file'   : ('/etc/shorewall/nat',
                         'etc_shorewall_nat'),
             'module' : nat}]

        # Superclass Constructor
        self.super.__init__(self, debug, prefix)


#===============================================================================
# self test
#===============================================================================
if __name__ == '__main__':
    pass
