#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   Template FrontEnd (ntpd)
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
# Copyright (C) 2007-2008 Century Systems Co.,Ltd.
#
# Last Modified: 2010/05/10 15:13:57 kikuchi
#

# Template FrontEnd Base
from Template_Base import Template_Base

# Template modules
from Modules.ntp_conf   import ntp_conf
from Modules.ntp_client import ntp_client

#===============================================================================
#
# TemplateModule FrontEnd (ntp)
#
#===============================================================================
class Template_ntp(Template_Base):
    def __init__(self, debug = False, prefix = ''):
        self.super = Template_Base

        self.module_list = [
            {'name'   : 'ntp.conf',
             'file'   : ('/etc/ntp.conf',
                         'etc_ntp_conf'),
             'module' : ntp_conf},
            {'name'   : 'ntp-client',
             'file'   : ('/etc/conf.d/ntp-client',
                         'etc_confd_ntp_client'),
             'module' : ntp_client},
            ]

        # Superclass Constructor
        self.super.__init__(self, debug, prefix)


#===============================================================================
# self test
#===============================================================================
if __name__ == '__main__':
    #import syck
    import yaml

    conf_yaml = '\n'.join((
        "NTP: ",
        "  ntp_info: ",
        "    use_ntp: True",
        "    ntp_servers: ",
        "    - ntp.nict.jp",
        "    - \"\"",
        "    act_server: True",
        ""))

    params = syck.load(conf_yaml)

    print params

    ntp_tmpl = Template_ntp(debug=True, prefix='output_test/')

    ntp_tmpl.set_params(params)

    res = ntp_tmpl.get_response()

    for mod in res:
        print "### ModuleName: %s\n%s" % (mod, res[mod])

    ntp_tmpl.write_config()
