#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   Template FrontEnd (ser2net)
# Copyright (C) 2008 Century Systems Co.,Ltd.
#

# Template FrontEnd Base
from Template_Base import Template_Base

# Template modules
from Modules.ser2net_conf import ser2net_conf
from Modules.ser2net_rc import ser2net_rc

#===============================================================================
#
# TemplateModule FrontEnd (ser2net)
#
#===============================================================================
class Template_ser2net(Template_Base):
    def __init__(self, debug = False, prefix = ''):
        self.super = Template_Base

        self.module_list = [
            {'name'   : 'ser2net.conf',
             'file'   : ('/etc/ser2net.conf',
                         'ser2net_conf'),
             'module' : ser2net_conf},
            {'name'   : 'ser2net',
             'file'   : ('/etc/conf.d/ser2net',
                         'ser2net'),
             'module' : ser2net_rc}
            ]

        # Superclass Constructor
        self.super.__init__(self, debug, prefix)

if __name__ == '__main__':
    import yaml

    conf_yaml = '\n'.join((
        "Ser2net: ",
        "  server:",
        "    service: True",
        "    controller: True",
        "    port: 3000",
        "  ports:",
        "  - {port: 4000, state: 3, timeout: 400, dev_node: aaa, dev_name: bbb, " \
        "bps: 9600, parity: EVEN, stopbits: 2, databits: 7, flow: SOFT, local: True, remctl: True}",
        "  - {port: 5000, state: 2, timeout: 400, dev_node: ccc, dev_name: ddd, " \
        "bps: 9600, parity: EVEN, stopbits: 2, databits: 7, flow: SOFT, local: True, remctl: True}",
        ""))

    params = yaml.load(conf_yaml)

    print params

    ser2net_tmpl = Template_ser2net(debug=True, prefix='output_test/')
    ser2net_tmpl.set_params(params)
    res = ser2net_tmpl.get_response()

    for mod in res:
        print "### ModuleName: %s\n%s" % (mod, res[mod])

    ser2net_tmpl.write_config()
