#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   JSON encode/decode module
#
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
# Copyright (C) 2007-2008 Century Systems Co.,Ltd.
#
# Last Modified: 2010/05/10 15:16:53 kikuchi
#

import cherrypy
try:
    # Python2.5 with simplejson
    import simplejson as json
except ImportError:
    # Python2.6
    import json

ContentTypeAllowed = ['application/json', 'text/json']

def dejsonify(encoding='utf-8'):
    if cherrypy.request.method in ['POST', 'PUT']:
        if 'content-type' in cherrypy.request.headers:
            for type in ContentTypeAllowed:
                if cherrypy.request.headers['content-type'].startswith(type):
                    body_as_dict = json.loads(cherrypy.request.body.read())

                    for key in body_as_dict:
                        cherrypy.request.params[key.encode(encoding)] = body_as_dict[key]
                    break

def jsonify():
    if isinstance(cherrypy.response.body, dict):
        cherrypy.response.headers['Content-Type'] = 'application/json'
        cherrypy.response.body = json.dumps(cherrypy.response.body)

cherrypy.tools.dejsonifier = cherrypy.Tool('before_handler', dejsonify)
cherrypy.tools.jsonifier   = cherrypy.Tool('before_finalize', jsonify)
