#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   DaemonTools control module
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
#
# Copyright (C) 2007-2010 Century Systems Co.,Ltd.
# Last Modified: 2010/04/30 14:53:09 kikuchi
#

import os
import subprocess

__author__  = "Takeyoshi Kikuchi"
__version__ = "0.01"

#===============================================================================
#
#
#
#===============================================================================
class DaemonTools:
    def __init__(self):
        self.observe_dir = "/etc/observe"
        self.script_dir  = "/var/service"

    #-----------------------------------
    # 有効にする
    #-----------------------------------
    def enable(self, service_name):
        enabled = self.get_status(service_name)

        if enabled == False:
            script = "%s/%s" % (self.script_dir, service_name)
            service = "%s/%s" % (self.observe_dir, service_name)
            os.symlink(script, service)

            self.start(service_name)
        else:
            self.restart(service_name)

    #-----------------------------------
    # 無効にする
    #-----------------------------------
    def disable(self, service_name):
        enabled = self.get_status(service_name)

        if enabled == True:
            service = "%s/%s" % (self.observe_dir, service_name)

            self.stop(service_name)
            os.unlink(service)

    #-----------------------------------
    # 有効か無効か 状態取得
    #-----------------------------------
    def get_status(self, service_name):
        dirname = "%s/%s" % (self.observe_dir, service_name)
        result = os.access(dirname, os.F_OK)

        return result

    #-----------------------------------
    # サービス開始
    #-----------------------------------
    def start(self, service_name):
        return self.__exec('-u', service_name)

    #-----------------------------------
    # サービス停止
    #-----------------------------------
    def stop(self, service_name):
        return self.__exec('-d', service_name)

    #-----------------------------------
    # サービス再起動
    #-----------------------------------
    def restart(self, service_name):
        #return self.__exec('-t', service_name)
        self.stop(service_name)
        return self.start(service_name)

    #---
    #
    def __exec(self, option, service_name):
        cmdline = ['svc', option, "%s/%s" % (self.observe_dir, service_name)]

        result = subprocess.call(cmdline)
        print "__exec() return with %d" % result

        return result
