#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   rc script module
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
#
# Copyright (C) 2007-2009 Century Systems, Inc.
# Last Modified: 2010/05/10 15:17:57 kikuchi
#

import subprocess

__author__  = "Takeyoshi Kikuchi"
__version__ = "0.10"


#===============================================================================
#
#
#
#===============================================================================
class RCscript:
    def __init__(self):
        pass

    #-----------------------------------
    # サービス開始
    #-----------------------------------
    def start(self, script):
        return self.__exec_rc('start', script)

    #-----------------------------------
    # サービス停止
    #-----------------------------------
    def stop(self, script):
        return self.__exec_rc('stop', script)

    #-----------------------------------
    # save (for iptables)
    #-----------------------------------
    def save(self, script):
        return self.__exec_rc('save', script)

    #-----------------------------------
    # サービス再起動
    #-----------------------------------
    def restart(self, script):
        return self.__exec_rc('restart', script)

    #-----------------------------------
    # 起動時から有効 (rc-update add default)
    #-----------------------------------
    def add_default(self, script):
        return self.__exec_rc_update('add', script)

    #-----------------------------------
    # 起動時は無効 (rc-update del default)
    #-----------------------------------
    def del_default(self, script):
        return self.__exec_rc_update('del', script)

    #----------
    #
    #----------
    def __exec_rc(self, command, script):
        cmdline = ['/etc/init.d/%s' % script, command]

        child = subprocess.Popen(cmdline, close_fds=True)
        child.wait()

        return True

    #----------
    #
    #----------
    def __exec_rc_update(self, command, script):
        cmdline = ['rc-update', command, script, 'default']
        return subprocess.call(cmdline)
