#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#
# Copyright (C) 2009 Century Systems Co.,Ltd.
#

import shlex
import time

class Shconf:
    def __init__(self, filename=None):
        self.__filename = filename

    def load(self, filename=None):
        obj = {}
        if filename:
            fn = filename
        else:
            fn = self.__filename
        fp = open(fn, "r")
        lex = shlex.shlex(fp)
        lex.whitespace += "="
        lex.whitespace_split = True
        while True:
            key = lex.get_token()
            val = lex.get_token()
            if not key or not val:
                break
            try:
                obj[key] = eval(val)
            except:
                obj[key] = val
        fp.close()
        return obj

    def dump(self, obj, filename=None, header=None):
        if filename:
            fn = filename
        else:
            fn = self.__filename
        fp = open(fn, "w+")
        if header:
            fp.write("# %s\n" % header)
        fp.write("# %s\n" % time.asctime())
        for i in obj.items():
            fp.write("%s=%s\n" % (str(i[0]), str(i[1])))
        fp.close()

