#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   Utility Functions
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
#
# Copyright (C) 2007-2008 Century Systems Co.,Ltd.
# Last Modified: 2010/05/10 15:18:08 kikuchi
#

import md5

netmask_table = {}
mask_rev = 0
for i in range(9):
    netmask_table[255 - mask_rev] = 8 - i
    mask_rev += 2 ** i

#-----------------------------------------------------------
#
#-----------------------------------------------------------
def md5sum_file(fileName):
    m = md5.new()

    for f in open(fileName, 'rb'):
        m.update(f)

    return m.hexdigest()

#-----------------------------------------------------------
#
#-----------------------------------------------------------
def prefixlen2netmask(prefixlen):
    if prefixlen < 0 or prefixlen > 32:
        raise IndexError, "prefixlen  0 .. 32"

    mask = '1' * prefixlen + '0' * (32 - prefixlen)
    netmask = []

    for i in range(4):
        netmask.append(str(int(mask[8 * i : 8 * i + 8], 2)))

    return '.'.join(netmask)

#-----------------------------------------------------------
#
#-----------------------------------------------------------
def netmask2prefixlen(netmask):
    if type(netmask) == list:
        if len(netmask) != 4:
            raise TypeError
        mask = netmask
    elif type(netmask) == str:
        tmp = netmask.split('.')

        if len(tmp) != 4:
            raise ValueError

        mask = []
        for i in range(4):
            octet = int(tmp[i])
            mask.append(octet)
    else:
        raise ValueError

    not255 = False
    prefixlen = 0

    for i in range(4):
        tmp = netmask_table[mask[i]]

        if mask[i] != 255:
            if not255 == True and mask[i] != 0:
                raise ValueError

            not255 = True

        prefixlen += tmp

    return prefixlen
