#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#   Configuration Updater
# Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
#
# Copyright (C) 2007 Century Systems Co.,Ltd.
# Last Modified: 2010/05/10 15:18:26 kikuchi
#

import sys
sys.path.append('/var/www/localhost/AppServer')
from RESTClient import RESTClient
from optparse import OptionParser

# ComandLine Parser
parser = OptionParser()
parser.add_option("-a", "--account", dest="account",
                  help="Web UI Account")
parser.add_option("-p", "--password", dest="password",
                  help="Web UI Password")

(options, args) = parser.parse_args()

if options.account == None or options.password == None:
    parser.print_help()
    sys.exit(1)

rest = RESTClient()

rest.set_account(options.account, options.password)
rest.set_endpoint('localhost:8080')

result = rest.nowsse_request("POST", '/service_nowsse/config/', { "command" : "reload"})

if result['status'] == 200:
    print "Configuration updated from YAML file ('/etc/MA_conf.yaml')"
else:
    print "Configuration update failed (status = %d)." % result['status']
