//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// Authentication Module
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2007-2010 Century Systems Co., Ltd.
//
// Last Modified: 2010/05/25 13:53:24 kikuchi
//==============================================================================

mod_auth = {
    //--------------------------------------------
    // HTML template
    //--------------------------------------------
    template_auth : {
	    HTMLtemplate : [
	        "<table class='auth_dialog'>",
	        "<tr>",
	        "  <td>アカウント</td>",
	        "  <td>",
	        "    <input type='text' id='auth_dummy' name='dummy' ",
	        "     tabindex=1 style='display:none;' />",
	        "    <input type='text' id='auth_account' class='text'",
	        "     name='account' tabindex=2 style='width:200px;' />",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <td>パスワード</td>",
	        "  <td>",
	        "    <input type='password' id='auth_password' class='text'",
	        "     name='password' tabindex=3 style='width:200px;' />",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan='2' id='auth_msg' class='errmsg'>",
	        "    &nbsp;",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan='2' style='text-align: right;'>",
	        "    <input type='button' id='bt_login' value='ログイン' tabindex=4 class='button' />",
	        "    <input type='button' id='bt_clear' value='クリア' tabindex=5 class='button' />",
	        "  </td>",
	        "</tr>",
	        "</table>"
	    ].join("\n"),
	    handlers : [
	        [
		        // "Login" button 'onClick'
		        'bt_login', 'click', function() {
		            mod_auth.authenticate();
		        }],
	        [
		        // "Clear" button 'onClick'
		        'bt_clear', 'click', function() {
		            $('auth_account').value  = '';
		            $('auth_password').value = '';
		        }],
	        [
		        // "Clear" button 'onKeyPress'
		        'bt_clear', 'keydown', function(event) {
		            var charCode, keyCode, msg;

		            keyCode = event.keyCode;

		            if (keyCode == 9) {
			            if (event.charCode != undefined) {
			                debug("Firefox");
			                $('auth_dummy').focus();
			            } else {
			                debug("Not Firefox");
			                $('auth_account').focus();
			                return false;
			            }
		            }
		        } ],
	        [
		        // Key Press on Account field
		        'auth_account', 'keypress', function(event) {
		            var keyCode, msg;

		            $('auth_msg').innerHTML = '&nbsp;';

		            keyCode = parseInt(event.keyCode);

		            if (keyCode == 13) {
			            mod_auth.authenticate();
			            return false;
		            }
		        } ],
	        [
		        // Key Press on Password field
		        'auth_password', 'keypress', function(event) {
		            var charCode, keyCode;

		            keyCode = event.keyCode;

		            $('auth_msg').innerHTML = '&nbsp;';

		            if (keyCode == 13) {
			            mod_auth.authenticate();
			            return false;
		            }
		        } ]
	    ]
    },

    data : {
	    dummy : 'dummy'
    },

    auth_data : {
	    user       : '',
	    password   : '',
	    digest     : '',
	    authorized : 'false'
    },

    //--------------------------------------------
    // Initialize
    //--------------------------------------------
    init : function(elem) {
	    this.elem = elem;

	    this.auth_data = {
	        user       : '',
	        password   : '',
	        digest     : '',
	        authorized : 'false'
	    };

	    this.elem.innerHTML = '';
	    this.showDialog();
    },

    //--------------------------------------------
    // 認証 Dialog
    //--------------------------------------------
    showDialog : function() {
	    var win, params, parser, template, html;

	    params = {
	        className   : "alphacube",
	        title       : "認証が必要です",
	        width       : 300,
	        height      : 120,
	        resizable   : false,
	        closable    : false,
	        minimizable : false,
	        maximizable : false,
	        draggable   : false,
	        showEffect  : Element.show,
	        hideEffect  : Element.hide,

	        destroyOnClose: true
	    };

	    win = new Window('authDialog', params);

	    template = this.template_auth;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    win.getContent().innerHTML = html;

	    set_handlers(template);

	    win.showCenter(true);	// Modal window
    },

    //--------------------------------------------
    // 認証 Dialog (Old)
    //--------------------------------------------
    showDialogOld : function() {
	    var win, dialog_params;

	    dialog_params = {
	        className   : "alphacube",
	        title       : "Authentication Required",
	        width       : 230,
	        height      : 100,
	        okLabel     : "Login",
	        cancelLabel : "Cancel",
	        onOk        : this.authenticate
	    };

	    Dialog.confirm(this.template, dialog_params);
    },

    //--------------------------------------------
    // Ajax認証
    //--------------------------------------------
    authenticate : function() {
	    var url, params, wsse_header;
	    var account, password, pass_digest, result = false;

	    account     = strip_escapeHTML($('auth_account').value);
	    password    = $('auth_password').value.strip();
	    pass_digest = hex_sha1(password);

	    //		wsse_header = wsseHeader(account, password);
	    wsse_header = wsseHeader(account, pass_digest);

	    url = "/service/conf/net/ethernet";

	    params = {
	        method: "GET",
	        asynchronous: false,
	        requestHeaders: [
		        'X-WSSE', wsse_header,
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
	        ],
	        onFailure: function(httpObj) {
		        $('auth_msg').innerHTML = "アカウントまたはパスワードが違います。";

		        new Effect.Shake(Windows.focusedWindow.getId());
	        },
	        onSuccess: function(httpObj) {
		        mod_auth.auth_data = {
		            account    : account,
		            password   : password,
		            digest     : pass_digest,
		            authorized : 'true'
		        };

		        $('auth_msg').innerHTML = "認証に成功しました。";

		        Windows.close('authDialog');
	        }
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // 認証情報取得
    //--------------------------------------------
    getAccountInfo : function() {
	    return this.auth_data;
    },

    //--------------------------------------------
    // 認証情報更新
    //--------------------------------------------
    setAccountInfo : function(account, password) {
	    this.auth_data.user = account;
	    this.auth_data.digest = password;
    }
};
