//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// 通信モジュール設定
// Copyright (C) 2008 Century Systems Co., Ltd.
//==============================================================================

mod_commodule = {
    //--------------------------------------------------------------------------
    // HTML template (Main)
    //--------------------------------------------------------------------------
    template_main : {
	    HTMLtemplate : [
	        "<h1 class='title'>通信モジュール設定</h1>",
	        "<h3>通信モジュール情報</h3><br/>",
	        "<table class='zebra'>",
	        "<tr>",
	        "<td colspan='2' class='noborderright'>",
	        "<img id='indicator_info' src='img/indicator.gif'",
	        "style='visibility: hidden;'/>",
	        "<input id='btn_reload_info' type='button'",
	        "class='button' style='width:50px;' value='更新'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th style='width:140px;'>型名</th>",
	        "<td style='width:200px;'>${info.type}</td>",
	        "</tr>",
	        "<tr>",
	        "<th>メーカ名</th>",
	        "<td>${info.manufacturer}</td>",
	        "</tr>",
	        "<tr>",
	        "<th>製造番号</th>",
	        "<td>${info.production_number}</td>",
	        "</tr>",
	        "<tr>",
	        "<th>登録状態</th>",
	        "<td>",
	        "<:if info.register_status == '0':>未登録<:/if:>",
	        "<:elseif info.register_status == '1':>登録済<:/elseif:>",
	        "<:elseif info.register_status == '2':>登録+解約済<:/elseif:>",
	        "<:elseif info.register_status == '3':>障害<:/elseif:>",
	        "<:else:>unknown(${info.register_status})<:/else:>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th>ROM書き問い合わせ番号</th>",
	        "<td>${info.rom_write_number}</td>",
	        "</tr>",
	        "<tr>",
	        "<th>電話番号</th>",
	        "<td>${info.phone_number}</td>",
	        "</tr>",
	        "<tr>",
	        "<th>呼状態</th>",
	        "<td>",
	        "<:if stat.status == '0':>通話中<:/if:>",
	        "<:elseif stat.status == '2':>発信中<:/elseif:>",
	        "<:elseif stat.status == '3':>Alerting<:/elseif:>",
	        "<:elseif stat.status == '4':>着信中<:/elseif:>",
	        "<:elseif stat.status == '5':>待ち受け中<:/elseif:>",
	        "<:else:>unknown(${stat.status})<:/else:>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th>圏内／圏外</th>",
	        "<td>",
	        "<:if stat.antenna_status == '0':>圏外<:/if:>",
	        "<:elseif stat.antenna_status == '1':>圏内<:/elseif:>",
	        "<:else:>unknown(${stat.antenna_status})<:/else:>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th>アンテナ本数</th>",
	        "<td>",
	        "<:if stat.antenna_level == '0':>圏外<:/if:>",
	        "<:elseif stat.antenna_level == '1':>0本<:/elseif:>",
	        "<:elseif stat.antenna_level == '2':>1本<:/elseif:>",
	        "<:elseif stat.antenna_level == '3':>2本<:/elseif:>",
	        "<:elseif stat.antenna_level == '4':>3本<:/elseif:>",
	        "<:else:>unknown(${stat.antenna_level})<:/else:>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<td colspan=2 align='right' style='color:gray; border:none;'>",
	        "${info.module_version}",
	        "</td>",
	        "</tr>",
	        "</table>",
	        "<br/>",

	        "<h3>OTA</h3><br/>",
	        "<table class='zebra'>",
	        "<tr>",
	        "<th style='width:140px;'>回線利用開始</th>",
	        "<td style='width:200px;'>",
	        "<input id='btn_otasp' type='button' class='button'",
	        "style='width:100px;' value='OTASP実施'/>",
	        "<img id='indicator_otasp' src='img/indicator.gif'",
	        "style='visibility: hidden;'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th>回線利用終了</th>",
	        "<td>",
	        "<input id='btn_otapa' type='button' class='button'",
	        "style='width:100px;' value='OTAPA実施'/>",
	        "<img id='indicator_otapa' src='img/indicator.gif'",
	        "style='visibility: hidden;'/>",
	        "</td>",
	        "</tr>",
	        "</table>"
	    ].join(' '),

	    handlers : [
	        [
		        'btn_reload_info', 'click', function() {
		            mod_commodule.cancel_reload_timer();
		            mod_commodule.GET_Module_info();
		        }
	        ],
	        [
		        'btn_otasp', 'click', function() {
		            mod_commodule.ota_confirm('otasp');
		        }
	        ],
	        [
		        'btn_otapa', 'click', function() {
		            mod_commodule.ota_confirm('otapa');
		        }
	        ]
	    ]
    },

    data : {
	    info : {},
	    stat : {}
    },

    init : function(elem) {
	    var auth_data;
	    this.elem = elem;

	    auth_data = mod_auth.getAccountInfo();

	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);
	        return;
	    }

	    this.elem.module = this;

	    this.GET_Module_info();
    },

    exit : function() {
	    this.cancel_reload_timer();
    },

    render : function() {
	    var template, html, parser;

	    template = this.template_main;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    set_handlers(template);
    },

    GET_Module_info : function() {
	    var auth_data;
	    var url, params, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/commodule/infostat";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;
		        this.hide_indicator('indicator_info');
		        this.elem_enable('btn_reload_info');

		        switch (status) {
		        case 401:
		            alert("Authentication failed @GET_Module_info (401)");
		            load_module('auth', 'content', true);
		            break;
		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;
		        this.hide_indicator('indicator_info');
		        this.elem_enable('btn_reload_info');

		        debug($jq.sprintf("GET_Module_info: %s", httpObj.responseText));
		        result = eval("(" + httpObj.responseText + ")");
		        this.data.info = result['info'];
		        this.data.stat = result['stat'];
		        this.render();

		        this.start_reload_timer();
	        }.bind(this)
	    };

	    this.show_indicator('indicator_info');
	    this.elem_disable('btn_reload_info');
	    new Ajax.Request(url, params);
    },

    ota_confirm : function(command) {
	    var params, msg;

	    if (command == 'otasp') {
	        msg = 'OTASPを実行してもよろしいですか?';
	    } else if (command == 'otapa') {
	        msg = 'OTAPAを実行してもよろしいですか?';
	    } else {
	        return;
	    }

	    params = {
	        className : "alphacube",
	        width : 300,
	        showEffect : Element.show,
	        hideEffect : Element.hide,

	        onOk : function() {
		        setTimeout(this.ota.bind(this, command), 10);
		        return true;
	        }.bindAsEventListener(this),

	        onCancel : function() {
		        return false;
	        }
	    };

	    Dialog.confirm(msg, params);
    },

    ota : function(command) {
	    var auth_data;
	    var msg, url, params, wsse_header;

	    if (command == 'otasp') {
	        url = '/service/conf/net/commodule/otasp'; 
	    } else if (command == 'otapa') {
	        url = '/service/conf/net/commodule/otapa'; 
	    } else {
	        return;
	    }

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    params = {
	        method: "POST",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        this.hide_indicator('indicator_otasp');
		        this.hide_indicator('indicator_otapa');
		        this.elem_enable('btn_otasp');
		        this.elem_enable('btn_otapa');
		        this.elem_enable('btn_reload_info');

		        switch (status) {
		        case 401:
		            alert("Authentication failed @GET_Module_info (401)");
		            load_module('auth', 'content', true);
		            break;
		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        this.hide_indicator('indicator_otasp');
		        this.hide_indicator('indicator_otapa');
		        this.elem_enable('btn_otasp');
		        this.elem_enable('btn_otapa');
		        this.elem_enable('btn_reload_info');

		        debug($jq.sprintf("ota: %s", httpObj.responseText));
		        result = eval("(" + httpObj.responseText + ")");
		        this.show_ota_result(result);

		        this.GET_Module_info();
	        }.bind(this)
	    };

	    this.show_indicator('indicator_' + command);
	    this.elem_disable('btn_otasp');
	    this.elem_disable('btn_otapa');
	    this.elem_disable('btn_reload_info');
	    this.cancel_reload_timer();

	    new Ajax.Request(url, params);
    },

    show_ota_result : function(result) {
	    var msg;

	    switch (result.result) {
	    case 0:
	        msg = "OTA実施に成功しました。<BR>";
	        break;

	    case -2:
	        msg = "OTA実施に失敗しました。<BR>";
	        if ("expect" in result)
		        msg += "'" + result.expect + 
		        "'の応答待ちがタイムアウトしました。";
	        break;

	    case -3:
	        msg = "OTA実施に失敗しました。<BR>";
	        if ("resp" in result) 
		        msg += "リザルトコード = " + result.resp;
	        break;

	    default:
	        msg = "OTA実施に失敗しました。<BR>";
	        break;
	    }

	    Dialog.alert(msg,
		             {
			             className: "alphacube",
			             width: 300,
			             showEffect: Element.show,
			             hideEffect: Element.hide
		             });
    },

    //================================================================
    //
    // Utility functions
    //
    //================================================================

    // AJAX 処理開始
    show_indicator : function(elem) {
	    if ($(elem))
	        $(elem).style.visibility = 'visible';
    },

    // AJAX 処理完了
    hide_indicator : function(elem) {
	    if ($(elem))
	        $(elem).style.visibility = 'hidden';
    },

    elem_disable : function(elem) {
	    if ($(elem))
	        $(elem).disabled = true;
    },

    elem_enable : function(elem) {
	    if ($(elem))
	        $(elem).disabled = false;
    },

    start_reload_timer : function() {
	    debug("start reload timer.");
	    this.stat_timer = setTimeout(this.GET_Module_info.bind(this), 60000);
    },

    cancel_reload_timer : function() {
	    if (this.stat_timer) {
	        debug("cancel reload timer.");
	        clearTimeout(this.stat_timer);
	    }
    }
};
