//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// 設定データ管理 (Download/Upload)
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2007-2008 Century Systems Co., Ltd.
//
// Last Modified: 2010/05/28 15:04:17 kikuchi
//==============================================================================

mod_config = {
    //--------------------------------------------
    // HTML template
    //--------------------------------------------
    template : {
	    HTMLtemplate : [
	        "<h1 class='title'>設定データ管理</h1>",
	        "<form action='/service_nowsse/config' method='post'",
	        " target='ifr_updownload' id='conf_upload' enctype='multipart/form-data'>",
	        "<table id='config_table' class='zebra'>",
	        "<tr>",
	        "  <th colspan=2 class='header' style='width:360px;' >",
	        "    設定ファイルダウンロード",
	        "  </th>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan=2 class='noborderright'>",
	        "    <input type='button' id='btn_download' class='button'",
	        "     style='width:80px;' value='ダウンロード' />",
	        "  </td>",
	        "</tr>",
	        "<tr><td class='noborder'>&nbsp;</td></tr>",
	        "<tr>",
	        "  <th colspan=2 class='header' style='width:360px;' >",
	        "    設定ファイルアップロード",
	        "  </th>",
	        "</tr>",
	        "<tr>",
	        "  <th style='width:80px;'>ファイル選択</th>",
	        "  <td class='noborder'>",
	        "    <input type='file' id='upload_file' name='configfile' class='text' ",
	        "     style='width:240px;' value='upload_file' />",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan=2 class='noborderright'>",
	        "    <img id='indicator_upload' src='img/indicator.gif'",
	        "     style='visibility: hidden;' />",
	        "    <input type='button' id='btn_upload' class='button'",
	        "     style='width:80px;' value='アップロード'",
	        "     disabled='disabled' />",
	        "  </td>",
	        "</tr>",
	        "<tr><td class='noborder'>&nbsp;</td></tr>",
	        "<tr>",
	        "  <th colspan=2 class='header' style='width:360px;' >",
	        "    設定データを本体に保存",
	        "  </th>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan=2 class='noborderright'>",
	        "    <img id='indicator_save' src='img/indicator.gif'",
	        "     style='visibility: hidden;' />",
	        "    <input type='button' id='btn_savemtd' class='button'",
	        "     style='width:80px;' value='保存' />",
	        "  </td>",
	        "</tr>",
	        "<tr><td class='noborder'>&nbsp;</td></tr>",
	        "<tr>",
	        "  <th colspan=2 class='header' style='width:360px;' >",
	        "    設定データ初期化",
	        "  </th>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan=2 class='noborderright'>",
	        "    <input type='button' id='btn_allclear' class='button'",
	        "     style='width:100px;' value='設定初期化' />",
	        "  </td>",
	        "</tr>",
	        "</table>",
	        "<input type='hidden' id='wsse' name='X-WSSE' value='' />",
	        "<input type='hidden' id='callback' name='callback' value='' />",
	        "</form>",
	        "<iframe id='ifr_updownload' name='ifr_updownload' src='' style='display:none;' />"
	    ].join("\n"),
	    handlers : [
	        [
		        // Download
		        'btn_download', 'click', function() {
		            mod_config.downloadYAML();
		        }],
	        [
		        // Upload
		        'btn_upload', 'click', function() {
		            if ($('upload_file').value == '') {
			            debug("upload file isn't set.");

			            $('btn_upload').disabled = true;
			            return false;
		            }

		            $('btn_upload').disabled = true;
		            mod_config.uploadYAML();
		        }],
	        [
		        // Upload file change
		        'upload_file', 'change', function() {
		            var stat = true;

		            if ($('upload_file').value != '')
			            stat = false;

		            $('btn_upload').disabled = stat;
		        }],
	        [
		        // Save to mtd
		        'btn_savemtd', 'click', function() {
		            debug("Save to mtd button clicked.");

		            mod_config.ajax_save_mtd();
		        }],
	        [
		        // All clear
		        'btn_allclear', 'click', function() {
		            debug("All clear button clicked.");

		            if (confirm("設定を初期化して再起動します。実行してもよろしいですか?"))
			            mod_config.ajax_all_clear();
		        }]
	    ]
    },

    // dummy data
    data : {
	    uploaded : false
    },

    //--------------------------------------------
    // Initialize
    //--------------------------------------------
    init : function(elem) {
	    var auth_data;
	    this.elem = elem;

	    // Auth check
        auth_data = mod_auth.getAccountInfo();
	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);

	        return;
	    }

	    this.render();
    },

    //--------------------------------------------
    // Render HTML
    //--------------------------------------------
    render : function() {
	    var html, parser, template;

	    template = this.template;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    set_handlers(template);
    },

    //================================================================
    //
    // Utility functions
    //
    //================================================================

    show_indicator : function(elem) {
	    $(elem).style.visibility = 'visible';
    },

    hide_indicator : function(elem) {
	    $(elem).style.visibility = 'hidden';
    },

    //================================================================
    //
    // Ajax Functions
    //
    //================================================================

    //--------------------------------------------
    // download YAML
    //--------------------------------------------
    downloadYAML : function() {
	    var auth_data;
	    var url, params, wsse_header;

        auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    debug($jq.sprintf("downloadYAML:\n X-WSSE='%s'", wsse_header));

	    url = $jq.sprintf("/service_nowsse/config/?X-WSSE=%s",
		              encodeURIComponent(wsse_header));

	    $('ifr_updownload').src = url;
    },

    //--------------------------------------------
    // upload YAML
    //--------------------------------------------
    uploadYAML : function() {
	    var auth_data, put_data;
	    var url, params, msg, wsse_header;
	    var json;

	    params = {
	        className : "alphacube",
	        width: 400,
	        showEffect  : Element.show,
	        hideEffect  : Element.hide,

	        onOk : function() {
		        debug("Confirm: OK");

		        // Show Indicator
		        mod_config.show_indicator('indicator_upload');

                auth_data = mod_auth.getAccountInfo();
		        wsse_header = wsseHeader(auth_data.account, auth_data.digest);

		        debug($jq.sprintf("uploadYAML:\n X-WSSE='%s'", wsse_header));

		        $('wsse').value = wsse_header;
		        $('callback').value = 'mod_config.uploadCompleteCallback';

		        $('conf_upload').submit();

		        return true;
	        }.bindAsEventListener(this),
	        onCancel : function() {
		        debug("Confirm: Cancel");

		        return false;
	        }
	    };

	    msg = ["設定ファイルのアップロードを開始します。<br/><br/>",
	           "<p align=left>設定ファイルの内容はPPP設定以外は直ちに反映され",
	           "ます。設定画面へのアクセスに使用しているインターフェースの",
	           "IPアドレスを変更をする場合は変更の実行後にブラウザを閉じ、",
	           "変更後のIPアドレスへ再度アクセスしてください。</p><br/>",
	           "<p align=left>接続中のPPPインターフェースには変更は反映されませ",
	           "ん。PPPの設定を反映させるには、PPP設定画面で再接続を行うか、シス",
	           "テムを再起動してください。</p><br/>",
	           "設定ファイルのアップロードを実行してよろしいですか?"].join("");
	    Dialog.confirm(msg, params);
    },

    //--------------------------------------------
    // YAML upload complete -> call from iframe
    //--------------------------------------------
    uploadCompleteCallback : function(msg) {
	    var dialog_param;

	    // Hide Indicator
	    mod_config.hide_indicator('indicator_upload');
	    $('upload_file').value = ''
	    $('btn_upload').disabled = true;

	    dialog_param = {
	        className  : "alphacube",
	        width      : 240,
	        showEffect : Element.show,
	        hideEffect : Element.hide
	    };

	    Dialog.alert(msg, dialog_param);
    },

    //--------------------------------------------
    // Save to mtd (POST)
    //--------------------------------------------
    ajax_save_mtd : function() {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var json;

        auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service_nowsse/config";

	    debug($jq.sprintf("ajax_save_mtd() : URL= %s", url));

	    // Show Indicator
	    mod_config.show_indicator('indicator_save');

	    params = {
	        method: "POST",
	        postBody: $jq.sprintf("X-WSSE=%s&command=save", wsse_header),
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        // Hide Indicator
		        mod_config.hide_indicator('indicator_save');

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ ajax_save_mtd. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result = eval("(" + httpObj.responseText + ")");

		        // Hide Indicator
		        mod_config.hide_indicator('indicator_save');

		        debug($jq.sprintf("ajax_save_mtd() --> '%s'", httpObj.responseText));
		        alert(result.msg);
	        }
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Clear all settings (POST)
    //--------------------------------------------
    ajax_all_clear : function() {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var json;

        auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service_nowsse/config";

	    debug($jq.sprintf("ajax_all_clear() : URL= %s", url));

	    params = {
	        method: "POST",
	        postBody: $jq.sprintf("X-WSSE=%s&command=all_clear", wsse_header),
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ ajax_all_clear. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result = eval("(" + httpObj.responseText + ")");
		        var auth_data;

		        debug($jq.sprintf("ajax_all_clear() --> '%s'", httpObj.responseText));

		        if (result.result) {
		            load_module('auth', 'content', true);
		        } else {
		            alert(result.msg);
		        }
	        }
	    };

	    new Ajax.Request(url, params);
    }

    //================================================================
    //
    // Event Handlers
    //
    //================================================================
};
