//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// 日付・時刻設定
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2007-2010 Century Systems Co., Ltd.
//
// Last Modified: 2010/05/28 15:04:30 kikuchi
//==============================================================================

mod_datetime = {
    //--------------------------------------------
    // HTML template
    //--------------------------------------------
    template : {
	    HTMLtemplate : [
	        "<h1 class='title'>日付・時刻設定</h1>",
	        "<form id='datetime_form'>",
	        "<table id='datetime_table' class='zebra'>",
	        // "<tr>",
	        // "  <th>日付</th>",
	        // "  <td colspan=4 class='noborder'>",
	        // "    <input type='text' id='txt_date' name='txt_date' class='text'",
	        // "     style='width:130px;' readonly='readonly' value=${date} />",
	        // "    <div id='div_calendar'></div>",
	        // "  </td>",
	        // "</tr>",
	        "<tr>",
	        "  <th>日付</th>",
	        "  <td colspan=4 class='noborder'>",
	        "    <input type='text' id='txt_date' name='txt_date' class='text'",
	        "     style='width:130px;' readonly='readonly' value=${date} />",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th>時刻</th>",
	        "  <td class='noborder'>",
	        "    <select name='sel_hour' id='sel_hour' class='select_time' />",
	        "     <%var hours = new Array; var i; %>",
	        "     <%for (i = 0; i < 24; i++) { hours.push(i); } %>",
	        "     <:foreach h in hours:>",
	        "      <%var hour_str = $jq.sprintf('%02d', h); %>",
	        "      <option value=${h} ",
	        "       <:if datetime[3]==h :>selected='selected'<:/if:> >",
	        "         ${hour_str}",
	        "      </option>",
	        "     <:/foreach:>",
	        "    </select>",
	        "  </td>",
	        "  <td class='noborder' style='padding:0;'>時</td>",
	        "  <td class='noborder'>",
	        "    <select name='sel_min' id='sel_min' class='select_time' />",
	        "     <%var minutes = new Array; var i; %>",
	        "     <%for (i = 0; i < 60; i++) { minutes.push(i); } %>",
	        "     <:foreach m in minutes:>",
	        "      <%var minute_str = $jq.sprintf('%02d', m); %>",
	        "      <option value=${m} ",
	        "       <:if datetime[4]==m :>selected='selected'<:/if:> >",
	        "         ${minute_str}",
	        "      </option>",
	        "     <:/foreach:>",
	        "    </select>",
	        "  </td>",
	        "  <td class='noborder' style='padding:0;'>分</td>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan=5 class='noborderright'>",
	        "    <input type='button' id='bt_get' value='読込' class='button' />",
	        "    <input type='button' id='bt_set' value='設定' class='button' />",
	        "  </td>",
	        "</tr>",
	        "</table>",
	        "</form>"
	    ].join("\n"),
	    //------------------------------
	    // Event Handlers
	    //------------------------------
	    handlers : [
	        // Calendar Handlers
	        // [
		    //     // 日付 Textbox
		    //     'txt_date', 'click', function() {
		    //         mod_datetime.writeCalendar();
		    //     }],
	        // [
		    //     'txt_date', 'change', function() {
		    //         mod_datetime.getFormValue();
		    //         mod_datetime.hideCalendar();
		    //     }],
	        [
		        // '更新' button (MA-4xxから日付・時刻を取得
		        'bt_get', 'click', function() {
		            mod_datetime.getDateTime();
		        }],
	        [
		        // '設定' button
		        'bt_set', 'click', function() {
		            mod_datetime.setDateTime();
		        }]
	    ],
	    //------------------------------
	    // Tooltips
	    //------------------------------
	    tooltips : [
	        [
		        'bt_get', 'Note', $jq.sprintf("%s から現在の日時を<br/>取得します。", MA4xx_conf.kinds)
	        ],
	        [
		        'bt_set', 'Note', $jq.sprintf("%s へ日時を設定します。", MA4xx_conf.kinds)
	        ]

	    ]
    },

    // dummy data
    data : {
	    date : "2007/06/26",
	    time : "10:10:10",
	    datetime : [ 2007, 6, 26, 10, 10, 10 ]
    },

    //--------------------------------------------
    // Initialize
    //--------------------------------------------
    init : function(elem) {
	    var auth_data;
	    this.elem = elem;

	    // Auth check
	    auth_data = mod_auth.getAccountInfo();
	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);

	        return;
	    }

	    this.getDateTime();
    },

    //--------------------------------------------
    // Render HTML
    //--------------------------------------------
    render : function() {
	    var html, parser, template;

	    template = this.template;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    //this.calendar = new JKL.Calendar('div_calendar', 'datetime_form', 'txt_date');

	    set_handlers(template);
	    set_tooltips(template, true);

	    $jq("#txt_date").datepicker();
    },

    //--------------------------------------------
    // update data from Form
    //--------------------------------------------
    updateFromForm : function() {
	    var dateArray;
	    var datetime;

	    datetime = this.data.datetime;

	    dateArray = $('txt_date').value.strip().split('/');

	    datetime[0] = dateArray[0];
	    datetime[1] = dateArray[1];
	    datetime[2] = dateArray[2];

	    datetime[3] = parseInt($('sel_hour').value, 10);
	    datetime[4] = parseInt($('sel_min').value, 10);
	    datetime[5] = 0;

	    this.data.time = $jq.sprintf("%02d:%02d", datetime[3], datetime[4]);
    },

    //================================================================
    //
    // Ajax Functions
    //
    //================================================================

    //--------------------------------------------
    // Get Date/Time
    //--------------------------------------------
    getDateTime : function() {
	    var auth_data;
	    var url, params, wsse_header;

	    auth_data = mod_auth.getAccountInfo();

	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/datetime";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ getInterfaces. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var datetime = eval("(" + httpObj.responseText + ")");
		        this.data = datetime;

		        this.render();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Set Date/Time
    //--------------------------------------------
    setDateTime : function() {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var json;

	    this.updateFromForm();

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/datetime";

	    json = Object.toJSON(this.data);
	    debug($jq.sprintf("setDateTime(): %s", json));

	    params = {
	        method: "PUT",
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ getInterfaces. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        alert("更新しました。");
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //================================================================
    //
    // Event Handlers
    //
    //================================================================

    //--------------------------------------------
    // Calendar handlers (1)
    //--------------------------------------------
    writeCalendar : function() {
	    $('txt_date').disabled = true;
	    this.calendar.write();
    },

    //--------------------------------------------
    // Calendar handlers (2)
    //--------------------------------------------
    getFormValue : function() {
	    this.calendar.getFormValue();
    },

    //--------------------------------------------
    // Calendar handlers (3)
    //--------------------------------------------
    hideCalendar : function() {
	    this.calendar.hide();
    }
};
