//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// Firmware Update
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2007-2010 Century Systems Co., Ltd.
//
// Last Modified: 2010/05/28 15:05:01 kikuchi
//==============================================================================

mod_firmup = {
    //--------------------------------------------
    // HTML template (Main)
    //--------------------------------------------
    template_main : {
        HTMLtemplate : [
            "<h1 class='title'>ファームウェア更新</h1>",
            "<form action='http://${hostaddr}:8080/service_nowsse/firmup' method='post'",
            " target='ifr_firmup' id='frm_upload' enctype='multipart/form-data'>",
            "<table id='tbl_firmup' class='zebra'>",
            "<tr>",
            "  <th colspan='2' class='header'>ファームウェアアップロード</th>",
            "</tr>",
            "<tr>",
            "  <th>現在のバージョン</th>",
            "  <td>${version}</td>",
            "</tr>",
            "<tr>",
            "  <th>ファイル選択</th>",
            "  <td class='noborder'>",
            "    <input type='file' class='text' id='firmfile' name='firmfile'",
            "     style='width:240px;'/>",
            "  </td>",
            "</tr>",
            "<tr>",
            "  <th>進捗状況</th>",
            "  <td class='noborderright'>",
            "    <div id='progress_bar' width='100'></div>",
            "  </td>",
            "</tr>",
            "<tr>",
            "  <td colspan='2' class='noborderright'>",
            "    <div id='progress_message'>&nbsp;</div>",
            "    <img id='indicator_upload' src='img/indicator.gif' ",
            "     style='visibility: hidden;' />",
            "    <input type='button' id='btn_upload' class='button'",
            "     style='width:60px;' value='送信' />",
            "  </td>",
            "</tr>",
            "<tr>",
            "  <td class='noborder'>&nbsp;</td>",
            "</tr>",
            "<tr>",
            "  <th colspan='2' class='header'>アップロード結果</th>",
            "</tr>",
            "<tr>",
            "  <th>ファイルサイズ [バイト]</th>",
            "  <td class='noborder'>",
            "    <input type='text' readonly='readonly' class='text' id='firm_size'",
            "     style='width:240px;' value='' />",
            "  </td>",
            "</tr>",
            "<tr>",
            "  <th>サム値 (md5sum)</th>",
            "  <td class='noborder'>",
            "    <input type='text' readonly='readonly' class='text' id='firm_md5sum'",
            "     style='width:240px;' value='' />",
            "  </td>",
            "</tr>",
            "<tr>",
            "  <th>モード選択</th>",
            "  <td>",
            "   <ul style='list-style-type: none;'>",
            "    <li>",
            "     <label for='mode_save'>",
            "      <input type='radio' name='firmup_mode' value='save' id='mode_save'",
            "       checked='checked' />",
            "       設定データはそのまま",
            "     </label>",
            "    </li>",
            "    <li>",
            "     <label for='mode_clear'>",
            "      <input type='radio' name='firmup_mode' value='clear' id='mode_clear' />",
            "       設定データをクリア",
            "     </label>",
            "    </li>",
            "   </ul>",
            "  </td>",
            "</tr>",
            "<tr>",
            "  <td colspan='2' class='noborderright'>",
            "    <input type='button' id='btn_cancel' class='button'",
            "     style='width:60px;' value='中止' />",
            "    <input type='button' id='btn_update' class='button'",
            "     style='width:60px;' value='開始' />",
            "  </td>",
            "</tr>",
            "</table>",
            "<input type='hidden' id='wsse' name='X-WSSE' value='' />",
            "<input type='hidden' id='mode' name='mode' value='' />",
            "</form>",
            "<iframe id='ifr_firmup' name='ifr_firmup' src='' style='display:none;' />"
        ].join("\n"),
        handlers : [
            [
                // Upload file change
                'firmfile', 'change', function() {
                    var btn_disabled, new_stat;
                    var filename = $('firmfile').value;

                    debug($jq.sprintf("Firmware file changed. '%s'", filename));
                    mod_firmup.data.filename = filename;

                    if (filename != '&nbsp;') {
                        btn_disabled = false;
                        new_stat = 'Enable';
                    } else {
                        btn_disabled = true;
                        new_stat = 'Disable';
                    }

                    $('btn_upload').disabled = btn_disabled;
                    debug($jq.sprintf("[Upload button] --> %s", new_stat));
                } ],
            [
                // Button 'Upload' clicked
                'btn_upload', 'click', function() {
                    var auth_data, wsse_header;

                    mod_firmup.get_ticket();

		            auth_data = mod_auth.getAccountInfo();
                    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

                    debug($jq.sprintf("'Upload' button is clicked, filename = '%s'.",
                                  $('firmfile').value));
                }],
            [
                // Button 'Update' clicked
                'btn_update', 'click', function() {
                    debug("'Update' button is clicked.");

                    mod_firmup.ajax_updateFirmware();
                }],
            [
                // Button 'Cancel' clicked
                'btn_cancel', 'click', function() {
                    debug("'Update' button is clicked.");

                    mod_firmup.ajax_cancelUpdate(false);
                }]
        ]
    },

    // dummy data
    data : {
        firmsize : 33030144,
        version : 'version is not set.',
        ticket : null,
        timer : null
    },

    //--------------------------------------------
    // Initialize
    //--------------------------------------------
    init : function(elem) {
        var auth_data;
        this.elem = elem;

        // Auth check
	    auth_data = mod_auth.getAccountInfo();
        if (auth_data == null || auth_data.authorized != 'true') {
            load_module("auth", "content", true);

            return;
        }

        // Get current firmware version --> render()
        this.get_currentFirmwareVersion();

        //this.render();

        // for Destructor
        this.elem.module = this;
    },

    //--------------------------------------------
    // Destructor
    //--------------------------------------------
    exit : function() {
        // アップロードされたファイルの情報がある場合、
        // ファイル削除リクエストを発行する
        if (this.data.firmware_info != undefined) {
            this.ajax_cancelUpdate(true);
        }
    },

    //--------------------------------------------
    // Render HTML (Main)
    //--------------------------------------------
    render : function() {
        var html, parser, template;
        var ipaddr;

        this.data.hostaddr = get_hostaddr();

        template = this.template_main;

        parser = new ZParse(Implementation);
        parser.parse(template.HTMLtemplate);
        html = parser.process(this.data);

        this.elem.innerHTML = html;

        if ($('firmfile').value == '')
            $('btn_upload').disabled = true;
        else
            $('btn_upload').disabled = false;

        if ($('firm_size').value == '') {
            $('btn_update').disabled = true;
            $('btn_cancel').disabled = true;
        } else {
            $('btn_update').disabled = false;
            $('btn_cancel').disabled = false;
        }

        set_handlers(template);

        $jq("#progress_bar").progressbar({
            min: 0,
            max: 100,
            value: 0
        });
    },

    //================================================================
    //
    // Utility functions
    //
    //================================================================

    // アップロード中
    show_indicator : function() {
        $('btn_upload').disabled = true;
        $('indicator_upload').style.visibility = 'visible';
    },

    // アップロード完了
    hide_indicator : function() {
        $('indicator_upload').style.visibility = 'hidden';
        $('btn_upload').disabled = false;
    },

    file_submit : function() {
	    var auth_data = mod_auth.getAccountInfo();
        var wsse_header = wsseHeader(auth_data.account, auth_data.digest);

        debug($jq.sprintf("X-WSSE: %s", wsse_header));
        $('wsse').value = wsse_header;
        $('frm_upload').submit();
    },

    update_progress : function(size) {
        var progress = Math.round(size * 100 / mod_firmup.data.firmsize);
        $("progress_message").innerHTML = [
            "" + size,
            "/ " + mod_firmup.data.firmsize,
            "bytes",
            "(" + progress + "%)"].join(' ');
        $jq('#progress_bar').progressbar("value", progress);
    },

    init_status : function() {
        delete(mod_firmup.data.firmware_info);
        // Clear form
        $('firm_size').value = '';
        $('firm_md5sum').value = '';
        $('progress_message').innerHTML = '&nbsp;';
        $('btn_update').disabled = true;
        $('btn_cancel').disabled = true;

        $jq('#progress_bar').progressbar("value", 0);
    },

    //================================================================
    //
    // Event Handlers
    //
    //================================================================

    //--------------------------------------------
    // Upload Complete handler
    //--------------------------------------------
    upload_complete : function(fileName, fileSize, md5sum) {
        var format;

        debug($jq.sprintf("uploadComplete: fileName='%s', fileSize=%d, md5sum='%s'",
                      fileName, fileSize, md5sum));

        $('firm_size').value = fileSize;
        $('firm_md5sum').value = md5sum;

        if (fileSize != MA4xx_conf.firmware_size) {
            format = ["ファイルサイズがファームウェアと異なります。",
                      "正しいサイズは %d バイトです。",
                      "(アップロードされたファイルは %d バイトです)" ].join('\n');
            alert($jq.sprintf(format, MA4xx_conf.firmware_size, fileSize));

            // 'update' / 'cancel' ボタン無効
            $('btn_update').disabled = true;
            $('btn_cancel').disabled = true;

            // 情報をクリア
            mod_firmup.ajax_cancelUpdate(false);
            return;
        }

        format = ["ファームウェアファイルのアップロード完了しました。",
                  "サイズは %d バイトです。",
                  "サム値を確認し、正しければ [開始] ボタンを",
                  "クリックして下さい。" ].join('\n');
        alert($jq.sprintf(format, fileSize));

        // 'update' / 'cancel' ボタン有効
        $('btn_update').disabled = false;
        $('btn_cancel').disabled = false;

        mod_firmup.data.firmware_info = {
            fileName : fileName,
            fileSize : fileSize,
            md5sum   : md5sum
        };
    },

    //--------------------------------------------
    // Get Firmware version
    //--------------------------------------------
    get_currentFirmwareVersion : function() {
        var auth_data, put_data;
        var url, params, wsse_header, mode;
        var json;

	    auth_data = mod_auth.getAccountInfo();
        wsse_header = wsseHeader(auth_data.account, auth_data.digest);

        url = "/service_nowsse/firmup/version";

        debug($jq.sprintf("get_currentFirmwareVersion() : URL=%s", url));

        params = {
            method: "GET",
            requestHeaders: [
                'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
                'X-WSSE', wsse_header
            ],
            onFailure: function(httpObj) {
                var status = httpObj.status;

                switch (status) {
                case 401:
                    alert("Authentication failed @ get_currentFirmwareVersion. (401)");
                    load_module('auth', 'content', true);
                    break;

                default:
                    alert($jq.sprintf("Error %d", status));
                    break;
                }
            },
            onSuccess: function(httpObj) {
                var result = eval("(" + httpObj.responseText + ")");

                mod_firmup.data.version = result.version;
                mod_firmup.render();
            }
        };

        new Ajax.Request(url, params);
    },

    get_ticket : function() {
        var auth_data, put_data;
        var url, params, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
        wsse_header = wsseHeader(auth_data.account, auth_data.digest);

        url = "/service_nowsse/firmup/get_ticket";

        params = {
            method: "GET",
            requestHeaders: [
                'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
                'X-WSSE', wsse_header
            ],
            onFailure: function(httpObj) {
                var status = httpObj.status;
                switch (status) {
                case 401:
                    alert("Authentication failed @ get_ticket. (401)");
                    load_module('auth', 'content', true);
                    break;
                default:
                    alert($jq.sprintf("Error %d", status));
                    break;
                }
            },
            onSuccess: function(httpObj) {
                var result = eval("(" + httpObj.responseText + ")");
                debug($jq.sprintf("get_ticket() --> '%s'", httpObj.responseText));
                if (result.result == false) {
                    alert($jq.sprintf("他のクライアント(%s)がファームウェア更新を実行中です。",
                                  result.owner));
                } else {
                    mod_firmup.data.ticket = result.ticket;
                    mod_firmup.file_submit();
                    mod_firmup.show_indicator();
                    mod_firmup.poll_firmUploadCompletion();
                }
            }
        };

        new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Firmware upload completion handler (longpoll)
    //--------------------------------------------
    poll_firmUploadCompletion : function() {
        var auth_data, put_data;
        var url, params, wsse_header, mode;
        var json;

	    auth_data = mod_auth.getAccountInfo();
        wsse_header = wsseHeader(auth_data.account, auth_data.digest);

        url = "/service_nowsse/firmup/upload_poll/" + mod_firmup.data.ticket;

        debug($jq.sprintf("poll_firmUploadCompletion() : URL=%s", url));

        params = {
            method: "GET",
            requestHeaders: [
                'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
                'X-WSSE', wsse_header
            ],
            onFailure: function(httpObj) {
                var status = httpObj.status;

                mod_firmup.hide_indicator();

                switch (status) {
                case 401:
                    alert("Authentication failed @ poll_firmUploadCompletion. (401)");
                    load_module('auth', 'content', true);
                    break;

                default:
                    alert($jq.sprintf("Error %d", status));
                    break;
                }
                mod_firmup.data.timer = null;
            },
            onSuccess: function(httpObj) {
                var result = eval("(" + httpObj.responseText + ")");

                if (result.result == false) {
                    // アップロード失敗 (タイムアウト)
                    alert(result.msg);

                    // 情報をクリア
                    mod_firmup.ajax_cancelUpdate(false);
                    mod_firmup.data.timer = null;
                } else {
                    if ("size" in result) {
                        mod_firmup.update_progress(result.size);
                        mod_firmup.data.timer = 
                            setTimeout(mod_firmup.poll_firmUploadCompletion,
                                       3000);
                    } else if ("msg" in result) {
                        // アップロード成功
                        var msg = result.msg;
                        mod_firmup.update_progress(msg.fileSize);
                        mod_firmup.upload_complete(
                            msg.fileName, msg.fileSize, msg.md5sum);
                        mod_firmup.hide_indicator();
                    }
                }
            }
        };

        new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // "Update" button handler
    //--------------------------------------------
    ajax_updateFirmware : function() {
        var auth_data, put_data;
        var url, params, wsse_header, mode;
        var json;

        // 'update' / 'cancel' ボタン無効
        $('btn_update').disabled = true;
        $('btn_cancel').disabled = true;

	    auth_data = mod_auth.getAccountInfo();
        wsse_header = wsseHeader(auth_data.account, auth_data.digest);

        mode = Form.serialize($('frm_upload')).toQueryParams()['firmup_mode'];

        url = "/service_nowsse/firmup";

        debug($jq.sprintf("ajax_updateFirmware() : URL=%s, mode=%s",
                      url, mode));

        delete(this.data.firmware_info);

        params = {
            method: "POST",
            postBody: $jq.sprintf("X-WSSE=%s&command=update&mode=%s",
                              wsse_header, mode),
            requestHeaders: [
                'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
                'X-WSSE', wsse_header
            ],
            onFailure: function(httpObj) {
                var status = httpObj.status;

                switch (status) {
                case 401:
                    alert("Authentication failed @ ajax_updateFirmware. (401)");
                    load_module('auth', 'content', true);
                    break;

                default:
                    mod_firmup.init_status();
                    alert($jq.sprintf("Error %d", status));
                    break;
                }
            },
            onSuccess: function(httpObj) {
                var result = eval("(" + httpObj.responseText + ")");

                debug($jq.sprintf("ajax_updateFirmware() --> '%s'", httpObj.responseText));
                alert(result.msg);

                load_module('auth', 'content', true);
            }
        };

        new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // "Cancel" button handler
    //--------------------------------------------
    ajax_cancelUpdate : function(noMsg) {
        var auth_data, put_data;
        var url, params, wsse_header, mode;
        var json;

        // 'update' / 'cancel' ボタン無効
        $('btn_update').disabled = true;
        $('btn_cancel').disabled = true;

	    auth_data = mod_auth.getAccountInfo();
        wsse_header = wsseHeader(auth_data.account, auth_data.digest);
        mode = 'dummy';

        url = "/service_nowsse/firmup";

        debug($jq.sprintf("ajax_cancelUpdate() : URL = %s", url));

        params = {
            method: "POST",
            postBody: $jq.sprintf("X-WSSE=%s&command=cancel&mode=%s",
                              wsse_header, mode),
            requestHeaders: [
                'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
                'X-WSSE', wsse_header
            ],
            onFailure: function(httpObj) {
                var status = httpObj.status;

                switch (status) {
                case 401:
                    alert("Authentication failed @ ajax_cancelUpdate. (401)");
                    load_module('auth', 'content', true);
                    break;

                default:
                    mod_firmup.init_status();
                    alert($jq.sprintf("Error %d", status));
                    break;
                }
            },
            onSuccess: function(httpObj) {
                var result = eval("(" + httpObj.responseText + ")");

                debug($jq.sprintf("ajax_cancelUpdate() --> '%s'", httpObj.responseText));

                if (noMsg == false) {
                    alert(result.msg);
                }

                mod_firmup.init_status();
            }
        };

        new Ajax.Request(url, params);
    }
};
