//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// GRE 設定
// Copyright (C) 2009-2010 Century Systems Co., Ltd.
//==============================================================================

mod_gre = {
    template_main : {
	    HTMLtemplate : [
	        "<h1 class='title'>GRE設定</h1>",
	        "<h3>編集されるファイル&nbsp;",
	        "<img src='img/ark_help.png' id='help_file'/>",
	        "</h3><br/>",

	        "<table id='if_list' class='zebra'>",
	        "<tr>",
	        "<td colspan='3' class='noborderright'>",
	        "<img id='indicator' src='img/indicator.gif'",
	        "style='visibility: hidden;'/>",
	        "<input id='btn_add' type='button' class='button'",
	        "style='width:50px;' value='追加'/>",
	        "</td>",
	        "</tr>",

	        "<tr>",
	        "<th class='header' style='width:120px;'>インターフェース名</th>",
	        "<th class='header' style='width:120px;'>接続名称</th>",
	        "<th class='header' style='width:120px;'>リモートアドレス</th>",
	        "</tr>",

	        "<:if gre.length == 0:>",
	        "<tr>",
	        "<td class='centering' colspan='3'>",
	        "インターフェースは登録されておりません。",
	        "</td>",
	        "</tr>",
	        "<:/if:>",

	        "<:else:>",
	        "<:for idx in gre:>",
	        "<%var conf=gre[idx]; %>",
	        "<tr>",
	        "<td>${conf.name}</td>",
	        "<td>${conf.conn_name}</td>",
	        "<td>${conf.remote_ip}</td>",
	        "<td class='noborder'>",
	        "<input type='button' id='btn_edit_${idx}' value='編集'",
	        "class='button' style='width:50px;'",
	        "onClick='mod_gre.onEditConf(${idx})'/>",
	        "<input type='button' id='btn_del_${idx}' value='削除'",
	        "class='button' style='width:50px;'",
	        "onClick='mod_gre.onDeleteConf(${idx})'/>",
	        "</td>",
	        "</tr>",
	        "<:/for:>",
	        "<:/else:>",

	        "</table>",
	    ].join(' '),

	    handlers : [
	        [
		        'btn_add', 'click', function() {
		            mod_gre.onEditConf(-1);
		        }
	        ]
	    ],

	    tooltips : [
	        [
		        'help_file', 'Note', [ "下記のファイルが編集対象です。<br/>",
				                       "/etc/conf.d/net" ].join('\n')
	        ]
	    ]
    },

    data : {
	    gre : [],
	    work : {}
    },

    init : function(elem) {
	    var auth_data;
	    this.elem = elem;

	    auth_data = mod_auth.getAccountInfo();
	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);
	        return;
	    }

	    this.elem.module = this;

	    this.GET_gre();
    },

    render : function() {
	    var html, parser, template;

	    template = this.template_main;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template);
    },

    //--------------------------------------------
    // HTML template (add/edit interface)
    //--------------------------------------------
    template_conf : {
	    HTMLtemplate : [
	        "<center>",
	        "<h2>GREインターフェース編集</h2><br/>",
	        "<form>",
	        "<table class='zebra'>",

	        "<tr>",
	        "<th class='header'>インターフェース名</th>",
	        "<td class='noborder'>${work.name}</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>接続名称</th>",
	        "<td class='noborder'>",
	        "<input type='text' id='conn_name' style='width:140px;'",
	        "tabindex='1' value='${work.conn_name}'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>リモートアドレス</th>",
	        "<td class='noborder'>",
	        "<input type='text' id='remote_ip' style='width:140px;'",
	        "tabindex='2' value='${work.remote_ip}'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>ローカルアドレス</th>",
	        "<td class='noborder'>",
	        "<input type='text' id='local_ip' style='width:140px;'",
	        "tabindex='3' value='${work.local_ip}'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>インターフェースアドレス</th>",
	        "<td class='noborder'>",
	        "<input type='text' id='if_address' style='width:140px;'",
	        "tabindex='4' value='${work.if_address}'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>TTL</th>",
	        "<td class='noborder'>",
	        "<input type='text' id='ttl' style='width:100px;'",
	        "tabindex='4' value='${work.ttl}'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>MTU</th>",
	        "<td class='noborder'>",
	        "<input type='text' id='mtu' style='width:100px;'",
	        "tabindex='5' value='${work.mtu}'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<td colspan=2 class='noborderright'>",
	        "<input type='button' id='bt_gre_ok' value='OK'",
	        "tabindex='5' class='button'/>",
	        "<input type='button' id='bt_gre_cancel' value='Cancel'",
	        "tabindex='6' class='button'/>",
	        "</td>",
	        "</tr>",
	        "</table>",
	        "</form>",
	        "</center>"
	    ].join(' '),

	    //------------------------------
	    // Event Handlers
	    //------------------------------
	    handlers : [
	        [
		        // Edit OK
		        'bt_gre_ok', 'click', function() {
		            mod_gre.onEditOK();
		        }
	        ],
	        [
		        // Edit Cancel
		        'bt_gre_cancel', 'click', function() {
		            Windows.close('greDialog');
		        }
	        ]
	    ],

	    //------------------------------
	    // Tooltips
	    //------------------------------
	    tooltips : []
    },

    //--------------------------------------------
    // add/edit interface configuration
    //--------------------------------------------
    onEditConf : function(idx) {
	    var win, param, parser, template, html;
	    var conf;

	    param = {
	        className      : "alphacube",
	        title          : "GRE設定",
	        width          : 370,
	        height         : 270,
	        resizable      : false,
	        closable       : true,
	        minimizable    : false,
	        maximizable    : false,
	        showEffect     : Element.show,
	        hideEffect     : Element.hide,
	        destroyOnClose : true
	    };

	    if (idx == -1) {
	        //add interface
	        var num, i, j, gre_id, name;

	        num = this.data.gre.length;
	        for(i = 0; ; i++) {
		        gre_id = i;
		        name = 'gtn' + gre_id;
		        for (j = 0; j < num; j++) {
		            if (name == this.data.gre[j].name) {
			            break;
		            }
		        }
		        if (j == num) {
		            break;
		        }
	        }

	        this.data.work = {
		        'action': 'add',
		        'name': name,
		        'gre_id' : gre_id,
		        'conn_name': '',
		        'remote_ip': '',
		        'local_ip': '',
		        'if_address': '',
		        'ttl': 255,
		        'mtu': 1476,
		        'type': 2,
		        'zone': 'loc'};
	    } else {
	        this.data.work = Object.clone(this.data.gre[idx]);
	        conf = this.data.work;
	        conf.action = 'edit';
	    }

	    win = new Window('greDialog', param);

	    template = this.template_conf;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    win.getContent().innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template);

	    win.showCenter(true);
    },

    //--------------------------------------------
    // delete interface configuration
    //--------------------------------------------
    onDeleteConf : function(idx) {
	    var conf;
	    conf = mod_gre.data.gre[idx];

	    if (confirm($jq.sprintf("GREインターフェース(%s)を削除してよろしいですか？",
			                conf['name'])))
	        mod_gre.ajax_deleteConf(idx);
    },

    //--------------------------------------------
    // edit dialog OK
    //--------------------------------------------
    onEditOK : function() {
	    var oldconf, newconf;

	    oldconf = mod_gre.data.work;
	    newconf = {}
	    newconf.gre_id = oldconf.gre_id;
	    newconf.name = oldconf.name;
	    newconf.type = oldconf.type;
	    newconf.zone = oldconf.zone;

	    newconf.conn_name = strip_escapeHTML($('conn_name').value);
	    newconf.remote_ip = strip_escapeHTML($('remote_ip').value);
	    newconf.local_ip = strip_escapeHTML($('local_ip').value);
	    newconf.if_address = strip_escapeHTML($('if_address').value);
	    newconf.ttl = parseInt($('ttl').value.strip(), 10);
	    newconf.mtu = parseInt($('mtu').value.strip(), 10);

	    if (this.validateConfig(newconf) == false)
	        return false;

	    Windows.close('greDialog');

	    this.ajax_updateConf(newconf);
    },

    //--------------------------------------------
    // validate new config
    //--------------------------------------------
    validateConfig : function(conf) {
	    var result, errMsgArray = [], errMsg;

	    result = true;

	    if (conf.remote_ip == "") {
	        errMsgArray.push("・リモートアドレスを指定してください。");
	    }

	    if (conf.ttl != 0) {
	        if (isNaN(conf.ttl) || conf.ttl < 1 || conf.ttl > 255) {
		        errMsgArray.push("・TTLは1から255の間で指定してください。");
	        }
	    }

	    if (conf.mtu != 0) {
	        if (isNaN(conf.mtu) || conf.mtu > 1500) {
		        errMsgArray.push("・MTUは1500以下で指定してください。");
	        }
	    }

	    if (errMsgArray.length > 0) {
	        errMsg = errMsgArray.join('\n');
	        alert(errMsg);

	        result = false;
	    }

	    return result;
    },

    //================================================================
    //
    // Ajax Functions
    //
    //================================================================

    //--------------------------------------------
    // GET GRE interfaces
    //--------------------------------------------
    GET_gre : function() {
	    var auth_data;
	    var url, params, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/gre";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @GET_gre (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("GET_gre: %s", httpObj.responseText));
		        result = eval("(" + httpObj.responseText + ")");
		        this.data.gre = result.gre;

		        this.render();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // add/update gre configuration
    //--------------------------------------------
    ajax_updateConf : function(newconf) {
	    var auth_data;
	    var url, params, wsse_header, json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/gre/conf/" + newconf.name;
	    json = Object.toJSON(newconf);
	    debug($jq.sprintf("json: '%s'", json));

	    params = {
	        method: 'PUT', 
	        contentType: 'application/json',
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;
		        this.hide_indicator('indicator');

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ajax_updateConf (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        this.hide_indicator('indicator');

		        debug($jq.sprintf("ajax_updateConf: %s", httpObj.responseText));

		        // reload
		        this.GET_gre();
	        }.bind(this)
	    };

	    this.show_indicator('indicator');
	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // delete gre configuration
    //--------------------------------------------
    ajax_deleteConf : function(idx) {
	    var auth_data;
	    var url, params, wsse_header;
	    var method, json;
	    var conf;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);
	    conf = mod_gre.data.gre[idx];

	    url = $jq.sprintf("/service/conf/net/gre/conf/%s", conf['name']);

	    params = {
	        method: "DELETE",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        this.hide_indicator('indicator');

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ajax_deleteConf (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        this.hide_indicator('indicator');

		        debug($jq.sprintf("ajax_deleteConf: %s", httpObj.responseText));

		        // reload
		        this.GET_gre();
	        }.bind(this)
	    };

	    this.show_indicator('indicator');
	    new Ajax.Request(url, params);
    },

    //================================================================
    //
    // Utility functions
    //
    //================================================================

    // AJAX 処理開始
    show_indicator : function(elem) {
	    $(elem).style.visibility = 'visible';
    },

    // AJAX 処理完了
    hide_indicator : function(elem) {
	    $(elem).style.visibility = 'hidden';
    }
};
