//==============================================================================
// MA-E2xx WebUI Module
//
// Data Logger
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2010 Century Systems Co., Ltd.
//
// Last Modified: 2010/05/28 15:05:22 kikuchi
//==============================================================================

mod_logger = {
    //--------------------------------------------
    // HTML template (Main)
    //--------------------------------------------
    template_main : {
	    HTMLtemplate : [
	        "<h1 class='title'>データロガー設定</h1>",
	        "<div id='dhtmlgoodies_tabView1'>",

	        //--------------------------
	        // Tab No.1
	        //--------------------------
	        "  <div class='dhtmlgoodies_aTab'>",
	        "  <h2>モジュール情報</h2><br/>",
	        "   <h3>対応モジュール一覧</h3>",
	        "    <table id='modules_table' class='zebra'>",
	        "     <tr>",
	        "      <th class='header'>No.</th>",
	        "      <th class='header'>モジュール名</th>",
	        "      <th class='header'>名称</th>",
	        "      <th class='header'>A-In ch数</th>",
	        "      <th class='header'>D-In ch数</th>",
	        "      <th class='header'>備考</th>",
	        "     </tr>",
	        "     <:for idx in modules:>",
	        "      <%var mod=modules[idx]; %>",
	        "      <tr>",
	        "       <td>${idx+1}</td>",
	        "       <td>${mod.moduleName}</td>",
	        "       <td>${mod.name}</td>",
	        "       <td class='numeric'>${mod.input.analog.length}</td>",
	        "       <td class='numeric'>${mod.input.digital.length}</td>",
	        "       <td>${mod.description}</td>",
	        "      </tr>",
	        "     <:/for:>",
	        "    </table>",
	        "  </div>",

	        //--------------------------
	        // Tab No.2
	        //--------------------------
	        "  <div class='dhtmlgoodies_aTab'>",
	        "  <h2>ロガー設定</h2><br/>",
	        "   <h3>ロガー稼働状況</h3>",
	        "    <table id='worker_table' class='zebra'>",
	        "     <tr>",
	        "      <th class='header'>No.</th>",
	        "      <th class='header'>binded module</th>",
	        "      <th class='header'>inputs</th>",
	        "      <th class='header'>状態</th>",
	        "     </tr>",
	        "     <:for idx in status:>",
	        "      <%var stat=status[idx]; %>",
	        "      <tr>",
	        "       <td>${idx+1}</td>",
	        "       <td>${stat.binded_module}</td>",
	        "       <td>${stat.inputs}</td>",
	        "       <td>${stat.started}</td>",
	        "      </tr>",
	        "     <:/for:>",
	        "    </table>",
	        "  </div>",

	        //--------------------------
	        // Tab No.3
	        //--------------------------
	        "  <div class='dhtmlgoodies_aTab'>",
	        "  <h2>データ取得</h2><br/>",
	        "   <h3>グラフ</h3>",
	        "    <table id='data_table' class='zebra'>",
	        "    <tr>",
	        "     <th class='header'>",
	        "      対象選択",
	        "     </th>",
	        "     <td class='noborder'>",
	        "      <select id='sel_worker' name='sel_worker' class='select'",
	        "       style='width:180px;'>",
	        "       <option value='-1' selected='selected'>選んでください",
	        "       </option>",
	        "      <:for idx in status:>",
	        "      <%var stat=status[idx]; %>",
	        "       <:if stat.binded==true:>",
	        "        <option value=${idx}",
	        "         <:if idx==selected:>selected='selected'<:/if:>",
	        "        >${idx+1} : ${stat.binded_module}</option>",
	        "       <:/if:>",
	        "      <:/for:>",
	        "      </select>",
	        "     </td>",
	        "     <td class='noborder'>",
	        "      <input type='button' class='button' id='btn_update' disabled=true",
	        "       value='更新'/>",
	        "     </td>",
	        "    </tr>",
	        "    </table>",
	        "   <img id='graph' src='img/graph_none.png'>",
	        "   </img>",
	        "  </div>"

	    ].join("\n"),
	    //------------------------------
	    // Event Handlers
	    //------------------------------
	    handlers : [
	        [
		        // select graph
		        'sel_worker', 'change', function() {
		            var sel = parseInt($('sel_worker').value, 10);
		            var dd = new Date();

		            if (sel == -1) {
			            $('graph').src = 'img/graph_none.png';
			            $('btn_update').disabled = true;
		            } else {
			            $('graph').src = $jq.sprintf("/logger/worker/%d/graph?idx=0&now=%d",
						                         sel, dd.getTime());
			            $('btn_update').disabled = false;
		            }
		        }],
	        [
		        // update graph
		        'btn_update', 'click', function() {
		            var sel = parseInt($('sel_worker').value, 10);
		            var dd = new Date();

		            $('graph').src = $jq.sprintf("/logger/worker/%d/graph?idx=0&now=%d",
					                         sel, dd.getTime());
		        }]
	    ],
	    // tooltip
	    tooltips : [
	    ]
    },

    // dummy data
    data : {
	    // モジュール一覧
	    modules : [

	    ],

	    // Worker Threads
	    status : [

	    ],
	    selected : -1
    },

    //--------------------------------------------
    // Initialize
    //--------------------------------------------
    init : function(elem) {
	    var auth_data;
	    this.elem = elem;

	    // Auth check
	    auth_data = mod_auth.getAccountInfo();
	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);

	        return;
	    }

	    // validator
	    if (!this.validator)
	        this.validator = new validateUtil();

	    this.GET_modules(true);
    },

    //--------------------------------------------
    // Render HTML (Main)
    //--------------------------------------------
    render : function(pane) {
	    var html, parser, template;

	    template = this.template_main;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.data.html = html;

	    this.elem.style.visibility = 'hidden';
	    this.elem.innerHTML = html;

	    if (!pane || pane == undefined)
	        pane = 0;

	    initTabs('dhtmlgoodies_tabView1',
		         Array('モジュール設定', 'ロガー設定', 'グラフ表示'),
		         //Array('モジュール設定', 'ロガー設定'),
		         //pane, 600, 500, Array(false, false, false, false));
		         pane, 700, "", Array(false, false, false));
        //		 pane, 600, "", Array(false, false));

	    set_handlers(template);
	    //set_tooltips(template, true);

	    this.elem.style.visibility = 'visible';
    },

    //==========================================================================
    //
    // Form callbacks
    //
    //==========================================================================

    //================================================================
    //
    // Utility functions
    //
    //================================================================

    show_indicator : function(elem) {
	    $(elem).style.visibility = 'visible';
    },

    hide_indicator : function(elem) {
	    $(elem).style.visibility = 'hidden';
    },

    //================================================================
    //
    // Ajax Functions
    //
    //================================================================

    //--------------------------------------------
    // Get Modules
    //--------------------------------------------
    GET_modules : function(chain) {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/logger/module/scan";

	    params = {
	        method: "POST",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            // Auth error
		            alert("Authentication failed @ ajax_getHostInfo. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("ajax_getHostInfo: Error %d.", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var res = eval('(' + httpObj.responseText + ')');

		        debug($jq.sprintf("GET_modules() --> %s", httpObj.responseText));

		        this.data.modules = res['modules']

		        if (chain)
		            this.GET_logger_status(true, -1);
		        else
		            mod_logger.render();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Get logger status
    //--------------------------------------------
    GET_logger_status : function(chain, worker) {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = $jq.sprintf("/logger/worker/%d/status", worker);

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            // Auth error
		            alert("Authentication failed @ GET_logger_status. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("GET_logger_status: Error %d.", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var res = eval('(' + httpObj.responseText + ')');

		        debug($jq.sprintf("GET_logger_status() --> %s", httpObj.responseText));

		        this.data.status = res['status']

		        mod_logger.render();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Get Graph kinds
    //--------------------------------------------
    GET_graph_kinds : function(chain, worker) {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = $jq.sprintf("/logger/worker/%d/graph_kinds", worker);

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            // Auth error
		            alert("Authentication failed @ ajax_getHostInfo. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("ajax_getHostInfo: Error %d.", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var res = eval('(' + httpObj.responseText + ')');

		        debug($jq.sprintf("GET_graph_kinds() --> %s", httpObj.responseText));

		        if (worker != -1)
		            this.data.status[worker].graph_kinds = res['graph_kinds']

		        mod_logger.render();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    }
};
