//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// 死活監視
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2007-2008 Century Systems Co., Ltd.
//
// Last Modified: 2010/05/28 15:05:31 kikuchi
//==============================================================================

mod_monitor = {
	//--------------------------------------------
	// HTML template (Main)
	//--------------------------------------------
	template_main : {
		HTMLtemplate : [
			"<h1 class='title'>死活監視設定</h1>",
			"<div id='dhtmlgoodies_tabView1'>",

			//--------------------------
			// Tab No.1
			//--------------------------
			"  <div class='dhtmlgoodies_aTab'>",
			"  <h2>死活監視設定</h2><br/>",
			"   <h3>ポーリング条件設定</h3>",
			"    <table id='polling_table' class='zebra'>",
			"     <tr>",
			"      <th class='header' id='th_polltime'>ポーリング間隔</th>",
			"      <td class='noborder' style='width:120px;'>",
			"       <select name='sel_polltime' id='sel_polltime' class='select'",
			"        style='width:60px;' tabindex='1'>",
			"        <:for i in poll_info.interval_opts:>",
			"         <option value=${i} ",
			"          <:if poll_info.interval==poll_info.interval_opts[i]:>",
			"           selected='selected'",
			"          <:/if:> >${poll_info.interval_opts[i]}",
			"         </option>",
			"        <:/for:>",
			"       </select>&nbsp;秒",
			"      </td>",
			"     </tr>",
			"     <tr>",
			"      <th class='header' id='th_retry'>リトライ回数</th>",
			"      <td class='noborder'>",
			"       <input type='text' class='text' id='txt_retry' style='width:60px;' ",
			"        value='${poll_info.retry_max}' />&nbsp;回",
			"      </td>",
			"     </tr>",
			"    </table>",
			"    <br/>",
			"   <h3>監視対象ホスト設定</h3>",
			"    <table id='target_table' class='zebra'>",
			"     <tr>",
			"      <td colspan='4' class='noborderright'>",
			"       <img id='indicator_hosts' src='img/indicator.gif' ",
			"        style='visibility: hidden;' />",
			"       <input type='button' class='button' id='bt_host_add'",
			"        value='追加' />",
			"       <input type='button' class='button' id='bt_all_enable'",
			"        value='全て有効' />",
			"       <input type='button' class='button' id='bt_all_disable'",
			"        value='全て無効' />",
			"       <input type='button' class='button' id='bt_host_update'",
			"        value='設定' />",
			"      </td>",
			"      <td class='noborder'>",
			"       <img id='indicator_target' src='img/indicator.gif' style='visibility: hidden;' />",
			"      </td>",
			"     </tr>",
			"     <tr>",
			"      <th class='header'>No.</th>",
			"      <th class='header'>IPアドレス</th>",
			"      <th class='header'>備考</th>",
			"      <th class='header'>有効/無効</th>",
			"     </tr>",
			"     <:if hostlist.length==0:>",
			"      <tr>",
			"       <td colspan='4' class='centering'>",
			"        監視対象ホストが登録されておりません。",
			"       </td>",
			"      </tr>",
			"     <:/if:>",
			"     <:else:>",
			"     <:for i in hostlist:>",
 			"      <tr>",
 			"       <td class='numeric' style='width: 30px;'>${i + 1}</td>",
 			"       <td>${hostlist[i].address}</td>",
 			"       <td style='width: 160px;'>${hostlist[i].name}</td>",
 			"       <td class='centering'>",
 			"        <:if hostlist[i].enable==true:>",
 			"         ○",
 			"        <:/if:>",
 			"        <:else:>",
 			"         ×",
 			"        <:/else:>",
 			"       </td>",
 			"       <td class='noborder'>",
 			"         <input type='button' class='button' id='edit_host_${i}'",
 			"          onClick='mod_monitor.edit_host(${i})' value='編集' />",
 			"         <input type='button' class='button' id='del_host_${i}'",
 			"          onClick='mod_monitor.delete_host(${i})' value='削除' />",
 			"      </tr>",
			"     <:/for:>",
			"     <:/else:>",
			"    </table>",
			"  </div>",

			//--------------------------
			// Tab No.2
			//--------------------------
			"<div class='dhtmlgoodies_aTab'>",
			"<h2>定期送信設定</h2><br/>",
				"<form>",
				"<table class='zebra'>",
				"<tr>",
					"<th>機能の有効化</th>",
					"<td>",
						"<ul style='list-style-type:none;'>",
							"<li>",
								"<label for='use_periodic'>",
								"<input id='use_periodic' type=checkbox",
									"<:if periodic.enable==true:>checked<:/if:>/>",
									"定期送信機能を使用する",
								"</label>",
							"</li>",
						"</ul>",
					"</td>",
				"</tr>",
				"<tr>",
					"<th>メール送信間隔(分)</th>",
					"<td>",
						"<input type='text' class='text required' id='periodic_interval'",
							"value='${periodic.interval}'/>",
					"</td>",
				"</tr>",
				"<tr>",
					"<td colspan=2 class='noborderright'>",
						"<img id='indicator_periodic' src='img/indicator.gif' ",
							"style='visibility:hidden;'/>",
						"<input type='button' class='button' id='bt_periodic_update' ",
							"value='設定'/>",
					"</td>",
				"</tr>",
				"</table>",
				"</form>",
			"</div>",

			//--------------------------
			// Tab No.3
			//--------------------------
			"  <div class='dhtmlgoodies_aTab'>",
			"  <h2>通知先設定</h2><br/>",
//			"    <table id='smtp_table' class='zebra'>",
// 			"    <tr><th class='header' colspan='2'>SNMP Trap</th></tr>",
// 			"    <tr>",
// 			"      <th>有効 / 無効</th>",
// 			"      <td class='noborder'>",
// 			"       <input type='checkbox' id='chk_snmp' tabindex=1",
// 			"        <:if alert.snmp.enable==true:>checked='checked'<:/if:>/>",
// 			"       SNMP Trapを利用する",
// 			"      </td>",
// 			"    </tr>",
// 			"    <tr>",
// 			"      <th>SNMP Trap送信先</th>",
// 			"      <td class='noborder'>",
// 			"       <input type='text' class='text' id='manager_addr'",
// 			"        style='width:160px;' tabindex=2",
// 			"        value='${alert.snmp.manager_addr}' />",
// 			"      </td>",
// 			"    </tr>",
// 			"    <tr>",
// 			"      <th>Trap コミュニティ名</th>",
// 			"      <td class='noborder'>",
// 			"       <input type='text' class='text' id='trapcom'",
// 			"        style='width:160px;' tabindex=3",
// 			"        value='${alert.snmp.trapcom}' />",
// 			"      </td>",
// 			"    </tr>",
// 			"    <tr>",
// 			"     <td colspan='2' class='noborderright'>",
// 			"      <input type='button' class='button' id='bt_snmp_update'",
// 			"       tabindex=4 value='設定' />",
// 			"     </td>",
// 			"    </tr>",
// 			"    <tr><br/></tr>",

//			"    <tr><th class='header' colspan='3'>E-Mail 通知</th></tr>",

			"    <fieldset><legend>E-Mail 通知先</legend>",
			"    <table id='smtp_table' class='zebra'>",
			"     <th class='header'>No.</th>", 
			"     <th class='header'>送信先メールアドレス</th>",
			"     <th class='header'>有効</th>",
			"    </tr>",
			"    <%var email_accounts = [0, 1, 2]; %>",
			"    <:for i in email_accounts:>",
			"     <tr>",
			"      <td class='numeric'>${i + 1}</td>",
			"      <td class='noborder'>",
			"       <input type='text' class='text' id='txt_email_${i}' style='width:180px;'",
			"        tabindex='${i * 2 + 1}'",
			"       <:if alert.email[i] != null:>",
			"        value='${alert.email[i].mail_addr}'",
			"       <:/if:>",
			"       <:else:>",
			"        value=''",
			"       <:/else:> >",
			"      </td>",
			"      <td class='noborder'>",
			"       <input type='checkbox' id='chk_email_enable_${i}' tabindex='${i * 2 + 2}'",
			"        <:if alert.email[i] != null && alert.email[i].enable == true:>",
			"         checked='checked'",
			"        <:/if:> >",
			"      </td>",
			"     </tr>",
			"    <:/for:>",
 			"    <tr>",
 			"     <td colspan='3' class='noborderright'>",
			"      <img id='indicator_alert_email' src='img/indicator.gif' ",
			"       style='visibility: hidden;' />",
 			"      <input type='button' class='button' id='bt_email_update'",
 			"       tabindex=6 value='設定' />",
 			"     </td>",
 			"    </tr>",
			"    </table>",
			"   </fieldset>",
			"  </div>",

			//--------------------------
			// Tab No.4
			//--------------------------
			"  <div class='dhtmlgoodies_aTab'>",
			"  <h2>E-Mail 通知用 アカウント設定</h2><br/>",
			"   <form id='email_form'>",
			"    <table id='email_table' class='zebra'>",
			"    <tr><th class='header' id='email_notice' colspan='2'>必須項目</th></tr>",
			"    <tr>",
			"      <th>有効 / 無効</th>",
			"      <td class='noborder'>",
			"       <ul style='list-style-type: none;'>",
			"        <li>",
			"        <label for='enable_email'>",
			"        <input type='checkbox' id='enable_email' tabindex='1'",
			"         <:if email.enable==true:>checked='checked'<:/if:>>",
			"          アカウントを有効にする",
			"        </input>",
			"        </label>",
			"        </li>",
			"       </ul>",
			"      </td>",
			"    </tr>",
			"    <tr>",
			"      <th>SMTPサーバ名</th>",
			"      <td class='noborder'>",
			"       <input type='text' class='text required' id='smtp_addr'",
			"        tabindex='2' style='width:160px;' title='required'",
			"        <:if email.smtp_server:>",
			"         value='${email.smtp_server}'",
			"        <:/if:><:else:>value=''<:/else:> />",
			"      </td>",
			"    </tr>",
			"    <tr>",
			"      <th>POP3サーバ名</th>",
			"      <td class='noborder'>",
			"       <input type='text' class='text' id='pop3_addr'",
			"        tabindex='3' style='width:160px;'",
			"        value='${email.pop3_server}' />",
			"      </td>",
			"    </tr>",
			"    <tr>",
			"      <th>ユーザID</th>",
			"      <td class='noborder'>",
			"       <input type='text' class='text' id='account'",
			"        tabindex='4' style='width:160px;'",
			"        value='${email.account}' />",
			"      </td>",
			"    </tr>",
			"    <tr>",
			"      <th>パスワード</th>",
			"      <td class='noborder'>",
			"       <input type='password' class='text' id='password'",
			"        tabindex='5' style='width:160px;'",
			"        value='${email.password}' />",
			"      </td>",
			"    </tr>",
			"    <tr>",
			"      <th>名前</th>",
			"      <td class='noborder'>",
			"       <input type='text' class='text' id='smtp_name'",
			"        tabindex='6' style='width:160px;'",
			"        value='${email.name}' />",
			"      </td>",
			"    </tr>",
			"    <tr>",
			"      <th>メールアドレス</th>",
			"      <td class='noborder'>",
			"       <input type='text' class='text' id='mail_address'",
			"        tabindex='7' style='width:160px;'",
			"        value='${email.mail_addr}' />",
			"      </td>",
			"    </tr>",
			"    <tr><th class='header' colspan='2'>オプション項目</th></tr>",
			"    <tr>",
			"      <th>SMTPポート</th>",
			"      <td class='noborder'>",
			"       <input type='text' class='text' id='smtp_port'",
			"        tabindex='8' style='width:160px;'",
			"        value='${email.smtp_port}' />",
			"      </td>",
			"    </tr>",
			"    <tr>",
			"      <th>POP3ポート</th>",
			"      <td class='noborder'>",
			"       <input type='text' class='text' id='pop3_port'",
			"        tabindex='9' style='width:160px;'",
			"        value='${email.pop3_port}' />",
			"      </td>",
			"    </tr>",
			"    <tr>",
			"      <th>認証方式</th>",
			"      <td>",
			"       <ul style='list-style-type: none;'>",
			"        <li>",
			"         <label for='auth_smtp'>",
			"          <input type='radio' name='auth_type' value='auth_smtp'",
			"           id='auth_smtp' tabindex='10'",
			"           <:if email.auth_type=='auth_smtp':>checked='checked'<:/if:> >",
			"            SMTP認証",
			"           </input>",
			"         </label>",
			"        </li>",
			"        <li>",
			"         <label for='auth_pop'>",
			"          <input type='radio' name='auth_type' value='auth_pop'",
			"           id='auth_pop' tabindex='11'",
			"           <:if email.auth_type=='auth_pop':>checked='checked'<:/if:> >",
			"            POP Before SMTP認証",
			"           </input>",
			"         </label>",
			"        </li>",
			"        <li>",
			"         <label for='auth_ssl'>",
			"          <input type='radio' name='auth_type' value='auth_ssl'",
			"           id='auth_ssl' tabindex='12'",
			"           <:if email.auth_type=='auth_ssl':>checked='checked'<:/if:> >",
			"            SMTP over TLS認証",
			"           </input>",
			"         </label>",
			"        </li>",
			"        <li>",
			"         <label for='auth_none'>",
			"          <input type='radio' name='auth_type' value='auth_none'",
			"           id='auth_none' tabindex='13'",
			"           <:if email.auth_type=='auth_none':>checked='checked'<:/if:> >",
			"            認証なし",
			"           </input>",
			"         </label>",
			"        </li>",
			"       </ul>",
			"      </td>",
			"    </tr>",
			"    <tr>",
			"     <td colspan='2' class='noborderright'>",
			"      <img id='indicator_email' src='img/indicator.gif' ",
			"       style='visibility: hidden;' />",
			"      <input type='button' class='button' id='bt_smtp_update'",
			"       tabindex='11' value='設定' />",
			"     </td>",
			"    </tr>",
			"    </table>",
			"   </form>",
			"  </div>",

			"</div>"
			].join("\n"),
		//------------------------------
		// Event Handlers
		//------------------------------
		handlers : [
			//------------------------------------
			// 監視対象設定 Tab
			//------------------------------------
			[
				// 監視対象追加
				'bt_host_add', 'click', function() {
					mod_monitor.add_host();
				}],
			[
				// 全て有効
				'bt_all_enable', 'click', function() {
					var i, nums, hostlist;

					hostlist = mod_monitor.data.hostlist;
					nums = hostlist.length;

					if (nums > 0) {
						for (i = 0; i < nums; i++)
							hostlist[i].enable = true;
						
						mod_monitor.render(0);
					}
				}],
			[
				// 全て無効
				'bt_all_disable', 'click', function() {
					var i, nums, hostlist;

					hostlist = mod_monitor.data.hostlist;
					nums = hostlist.length;

					if (nums > 0) {
						for (i = 0; i < nums; i++)
							hostlist[i].enable = false;
						
						mod_monitor.render(0);
					}
				}],
			[
				// リスト更新
				'bt_host_update', 'click', function() {
					mod_monitor.update_target();
				}],
			//------------------------------------
			// 定期送信設定 Tab
			//------------------------------------
			[
				'bt_periodic_update', 'click', function() {
					mod_monitor.update_periodic();
				}],
			//------------------------------------
			// 通知先設定 Tab
			//------------------------------------
			[
				// SNMP Trap更新
				'bt_snmp_update', 'click', function() {
					mod_monitor.update_alert_snmp();
				}],
			[
				// E-Mail通知 更新
				'bt_email_update', 'click', function() {
					mod_monitor.update_alert_email();
				}],
			//------------------------------------
			// E-Mailアカウント設定 Tab
			//------------------------------------
			[
				// 認証方式 → SMTP認証
				'auth_smtp', 'change', function() {
					mod_monitor.update_auth();
				}],
			[
				// 認証方式 → POP before SMTP認証
				'auth_pop', 'change', function() {
					mod_monitor.update_auth();
				}],
			[
				// 認証方式 → SSL認証
				'auth_ssl', 'change', function() {
					mod_monitor.update_auth();
				}],
			[
				// 認証方式 → 認証なし
				'auth_none', 'change', function() {
					mod_monitor.update_auth();
				}],
			[
				// E-Mail アカウント設定更新
				'bt_smtp_update', 'click', function() {
					if (mod_monitor.update_smtp() == true) {
						mod_monitor.update_email_usability();

						mod_monitor.ajax_updateEmailInfo();
					}
				}]
			],
		// tooltip
		tooltips : [
			//------------------------------------
			// 監視対象設定 Tab
			//------------------------------------
			[
				// 'ポーリング間隔'
				'th_polltime', 'Note', "監視を行う間隔を選択して下さい。"
				],
			[
				// 'リトライ回数'
				'th_retry', 'Note', "PING NG何回でエラーとするかを指定して下さい。"
				],
			[
				// 'ホストの追加'
				'bt_host_add', 'Note', "監視対象のホストを追加します。"
				],
			[
				// '全て有効'
				'bt_all_enable', 'Note', "全ホストの監視を有効にします。"
				],
			[
				// '全て無効'
				'bt_all_disable', 'Note', "全ホストの監視を無効にします。"
				],
			[
				// '設定'
				'bt_host_update', 'Note', "このタブの設定を反映させます。"
				],
			//------------------------------------
			// E-Mailアカウント設定 Tab
			//------------------------------------
			[
				// 
				'email_notice', 'Note', "E-Mail通知用のアカウントを<br/>設定して下さい。"
				]
			]
	},

	// dummy data
	data : {
		// ホスト登録最大数
		max_hosts : 7,

		// 監視対象設定
		hostlist : [
            {
	            addr   : '192.168.253.2',
	            name   : '留守モニタ',
	            enable : true
            },{
	            addr   : '192.168.253.3',
	            name   : '音声ユニット',
	            enable : true
            }],

		// ポーリング設定
		poll_info : {
			interval_opts : [ 30, 60, 90, 120 ],
			interval_sel  : 0,
			retry_max : 3
		},

		alert : {
			// SNMP Trap設定
			snmp : {
				enable       : true,
				manager_addr : '172.16.0.1',
				trapcom      : 'secure'
			},

			// E-Mail通知設定
			email : {
				enable : true,
				mail_addr : [
					'support@centurysys.co.jp',
					'',
					''
					]
			}
		},

		periodic : {
			enable : false,
			interval : 60
		},

		// E-Mail設定
		email : {
			enable        : false,
			smtp_server   : 'smtp.example.com',
			pop3_server   : 'pop.example.com',
			account       : 'user',
			password      : 'pass',
			name          : 'MA-E2xx',
			mail_addr     : 'ma430@fuga.jp',
			smtp_port     : 25,
			pop3_port     : 110,
			auth_type     : 'auth_smtp',
			valid         : true
		}
	},

	//--------------------------------------------
	// HTML template (監視対象 Edit Dialog)
	//--------------------------------------------
	template_host : {
		HTMLtemplate : [
			"<center>",
			"<h2>監視対象の編集</h2><br/>",
			"<form>",
			"<table class='zebra'>",
			"<tr>",
			"  <th class='header'>IPアドレス</th>",
			"  <td class='noborder'>",
			"    <input type='text' id='host_addr' class='text' style='width:140px;' ",
			"    <:if operation=='edit':>value='${address}'<:/if:> tabindex=1 />",
			"  </td>",
			"</tr>",
			"<tr>",
			"  <th class='header'>備考</th>",
			"  <td class='noborder'>",
			"    <input type='text' id='host_note' class='text' style='width:140px;'",
			"    <:if operation=='edit':>value='${note}'<:/if:> tabindex=2 />",
			"  </td>",
			"</tr>",
			"<tr>",
			"  <th class='header'>有効/無効</th>",
			"  <td class='noborder'>",
			"    <input type='checkbox' id='host_enable'",
			"     <:if enable==true:>checked='checked'<:/if:> tabindex=3>",
			"      監視を有効にする",
			"    </input>",
			"  </td>",
			"</tr>",
			"<tr>",
			"  <td colspan='2' class='noborderright'>",
			"    <input type='button' id='bt_ok' value='適用' class='button' tabindex=4 />",
			"    <input type='button' id='bt_cancel' value='中止' class='button' tabindex=5 />",
			"  </td>",
			"</tr>",
			"</table>",
			"</form>",
			"</center>"
			].join("\n"),
		handlers : [
			[
				// "OK" button handler
				'bt_ok', 'click', function() {
					mod_monitor.onHostEditOK();
				}],
			[
				// "Cancel" button handler
				'bt_cancel', 'click', function() {
					Windows.close('hostDialog');
				}]
			]
	},
			
	//----------------------------------
	// dummy data (監視対象 Edit Dialog)
	//----------------------------------
	host_dialog_data : {
		operation : 'new',	// 'new' or 'edit'

		entryNo : 0,
		address : '192.168.0.0',
		note    : '',
		enable  : true
	},

	//--------------------------------------------
	// Initialize
	//--------------------------------------------
	init : function(elem) {
		var auth_data;
		this.elem = elem;

		// Auth check
        auth_data = mod_auth.getAccountInfo();
		if (auth_data == null || auth_data.authorized != 'true') {
			load_module("auth", "content", true);

			return;
		}

		// validator
		if (!this.validator)
			this.validator = new validateUtil();

		this.ajax_getHostInfo(true);
	},

	//--------------------------------------------
	// Render HTML (Main)
	//--------------------------------------------
	render : function(pane) {
		var html, parser, template;

		template = this.template_main;

		parser = new ZParse(Implementation);
		parser.parse(template.HTMLtemplate);
		html = parser.process(this.data);

		this.elem.style.visibility = 'hidden';
		this.elem.innerHTML = html;

		if (!pane || pane == undefined)
			pane = 0;

		initTabs('dhtmlgoodies_tabView1',
				 Array('死活監視設定', '定期送信設定', '通知先設定', 'E-Mail 設定'),
				 pane, 600, "", Array(false, false, false, false));

		set_handlers(template);
//		set_tooltips(template, true);

		this.update_hostList();
		this.update_auth();
		this.update_email_usability();
//		this.update_snmp_usability();

		this.elem.style.visibility = 'visible';
	},

	//==========================================================================
	//
	// Form callbacks
	//
	//==========================================================================

	//------------------------------------------------------
	// 監視対象設定Tab

	//--------------------------------------------
	// Add host
	//--------------------------------------------
	add_host : function() {
		var dialog_data;

		debug("add_host() clicked.");

		dialog_data = this.host_dialog_data;

		dialog_data.operation = 'new';
		dialog_data.entryNo   = this.data.hostlist.length;
		dialog_data.address   = '';
		dialog_data.note      = '';
		dialog_data.enable    = true;

		this.showHostEditDialog();
	},

	//--------------------------------------------
	// Edit host
	//--------------------------------------------
	edit_host : function(no) {
		var dialog_data;

		debug($jq.sprintf("edit_host(%d) clicked.", no + 1));

		dialog_data = this.host_dialog_data;

		dialog_data.operation = 'edit';
		dialog_data.entryNo   = no;
		dialog_data.address   = this.data.hostlist[no].address;
		dialog_data.note      = this.data.hostlist[no].name;
		dialog_data.enable    = this.data.hostlist[no].enable;

		this.showHostEditDialog();
	},

	//--------------------------------------------
	// Edit host dialog
	//--------------------------------------------
	showHostEditDialog : function() {
		var win, param, parser, template, html;

		param = {
			className   : 'alphacube',
			title       : '監視対象の編集',
			width       : 340,
			height      : 180,
			resizable   : false,
			closable    : true,
			minimizable : false,
			maximizable : false,
			showEffect  : Element.show,
			hideEffect  : Element.hide,

			destroyOnClose: true
		};

		win = new Window('hostDialog', param);

		template = this.template_host;

		parser = new ZParse(Implementation);
		parser.parse(template.HTMLtemplate);
		html = parser.process(this.host_dialog_data);

		win.getContent().innerHTML = html;

		set_handlers(template);

		win.showCenter(true);	// Modal window
	},

	//--------------------------------------------
	// Add/Edit 'OK' clicked
	//--------------------------------------------
	onHostEditOK : function() {
		var address, note, enable, newHost, operation;
		var idx;

		operation = this.host_dialog_data.operation;

		address = strip_escapeHTML($('host_addr').value);
		note    = strip_escapeHTML($('host_note').value);
		enable  = $('host_enable').checked;

		if (note == "")
			note = $jq.sprintf("IP: %s", address);

		newHost = {
			address : address,
			name    : note,
			enable  : enable
		};

		// validate
		if (this.validateHost(newHost) == false)
			return false;

		// 重複チェック
		for (idx in this.data.hostlist) {
			if (this.data.hostlist[idx].address == address &&
				this.host_dialog_data.entryNo != idx) {
				alert("IPアドレスが重複しています。");
				return false;
			}
		}

		if (operation == 'new')
			// New
			this.data.hostlist = this.data.hostlist.insertByIndex(
				this.host_dialog_data.entryNo, Object.clone(newHost));
		else
			// Edit
			this.data.hostlist = this.data.hostlist.replaceByIndex(
				this.host_dialog_data.entryNo, Object.clone(newHost));

		Windows.close('hostDialog');

		this.render(0);
	},
			
	//--------------------------------------------
	// Delete host
	//--------------------------------------------
	delete_host : function(no) {
		var params, msg;

		debug($jq.sprintf("delete_host(%d) clicked.", no + 1));

		params = {
			className : "alphacube",
			width: 300,
			showEffect : Element.show,
			hideEffect : Element.hide,

			onOk : function() {
				debug("Confirm: OK");
				this.data.hostlist = this.data.hostlist.removeByIndex(no);
				this.render();

				return true;
			}.bind(this),
			onCancel : function() {
				debug("Confirm: Cancel");

				return true;
			}
		};

		msg = "No." + (no + 1) + " の機器を<br/>監視対象から外してよろしいですか ?"
		Dialog.confirm(msg, params);
	},

	//--------------------------------------------
	// Update target host
	//--------------------------------------------
	update_target : function() {
		var poll_retry, interval_sel;
		var errMsg = '';

		// validate Polling retry
		poll_retry = parseInt($('txt_retry').value.strip(), 10);

		if (isNaN(poll_retry))
			errMsg = "・リトライ回数には数値を設定して下さい。";
		else {
			if (poll_retry < 1)
				errMsg = "・リトライ回数を設定して下さい。";
			else if (poll_retry > 10)
				errMsg = "・現実的なリトライ回数を設定して下さい(10回以下)。";
		}

		interval_sel = parseInt($('sel_polltime').value, 10);

		if (errMsg != '') {
			alert(errMsg);
			return false;
		}

		//this.data.poll_info.interval_sel = interval_sel;
		this.data.poll_info.interval  = this.data.poll_info.interval_opts[interval_sel];
		this.data.poll_info.retry_max = poll_retry;

		// OK, update
		this.ajax_updateTarget();
	},

	//--------------------------------------------
	// "監視対象ホスト" button update
	//--------------------------------------------
	update_hostList : function() {
		var hostNums, disable;

		hostNums = this.data.hostlist.length;

		if (hostNums > 0)
			disable = false;
		else
			disable = true;

		$('bt_all_enable').disabled  = disable;
		$('bt_all_disable').disabled = disable;
		$('sel_polltime').disabled   = disable;
		$('txt_retry').disabled      = disable;

		// ホスト数制限
		if (hostNums >= this.data.max_hosts)
			disable = true;
		else
			disable = false;

		$('bt_host_add').disabled = disable;
	},

	//--------------------------------------------
	// "監視対象ホスト" Add/Edit validation
	//--------------------------------------------
	validateHost : function(newHost) {
		var result = true;

		// validate IP Address
		if (this.validator.checkIPAddress(newHost.address) == false) {
			alert("・IPアドレスが不正です。");
			result = false;
		}

		return result;
	},

	//------------------------------------------------------
	// 定期送信設定 Tab
	
	update_periodic : function() {
		var enable, interval, errMsg = '';

		enable = $('use_periodic').checked;

		if (enable) {
			interval = parseInt($('periodic_interval').value.strip(), 10);
			if (isNaN(interval)) {
				errMsg = "・送信間隔には数値を設定してください。";
			} else {
				if (interval < 10) {
					errMsg = "・送信間隔は10分以上に設定してください。";
				}
			}
		}
		if (errMsg != '') {
			alert(errMsg);
			return false;
		}

		this.data.periodic.enable = enable;
		if (enable)
			this.data.periodic.interval = interval;
		else
			this.data.periodic.interval = '';
		this.ajax_updatePeriodicInfo();
	},

	//------------------------------------------------------
	// 通知先設定 Tab

	//--------------------------------------------
	// Update SNMP
	//--------------------------------------------
	update_alert_snmp : function() {
		var new_snmp, enable, manager_addr, trapcom;
		var errMessage = '';

		debug("update_alert_snmp() clicked.");

		enable       = $('chk_snmp').checked;
		manager_addr = strip_escapeHTML($('manager_addr').value);
		trapcom      = strip_escapeHTML($('trapcom').value);

		if (enable == true) {
			if (manager_addr == '')
				errMessage = "SNMP Trap送信先を設定して下さい。";
			else if (trapcom == '')
				errMessage = "Trapコミュニティ名を設定して下さい。";

			if (errMessage != '') {
				alert(errMessage);
				return;
			}
		}

		new_snmp = {
			enable       : enable,
			manager_addr : manager_addr,
			trapcom      : trapcom
		};

		// 更新
		this.data.alert.snmp = new_snmp;
		this.ajax_updateAlert();
	},

	//--------------------------------------------
	// Update E-Mail
	//--------------------------------------------
	update_alert_email : function() {
		var new_email, enable, mail_addr, elem;
		var mail_addr_array;
		var errMsgArray = [], errMsg;

		debug("update_alert_email() clicked.");

		var mail_elems = ['txt_email_0',
						  'txt_email_1',
						  'txt_email_2'];

		mail_addr_array = new Array();

		if (this.data.email.valid == false) {
			alert("・E-Mail 設定がなされていないため使用できません。");

			for (i = 0; i < 3; i++)
				$($jq.sprintf('chk_email_enable_%d', i)).checked = false;
			return;
		}

		// E-Mail通知有効の場合のみ Validation
		for (i = 0; i < mail_elems.length; i++) {
			mail_addr = strip_escapeHTML($(mail_elems[i]).value);
			enable = $($jq.sprintf('chk_email_enable_%d', i)).checked;

			if (mail_addr != '') {
				if (this.validator.checkEmailAddress(mail_addr) == true) {
					var new_account = {};

					new_account.mail_addr = mail_addr;
					new_account.enable    = enable;
				
					mail_addr_array.push(new_account);
				} else
					errMsgArray.push($jq.sprintf("・送信先メールアドレス%d が不正です。", i + 1));
			}
		}

		if (mail_addr_array.length == 0) {
			errMsgArray.push("・E-Mail通知先を設定して下さい。");

			$('enable_email').disabled = false;
		} else {
			// E-Mail有効なので、アカウントを無効にできないようにする
			$('enable_email').disabled = true;
		}

		if (errMsgArray.length > 0) {
			errMsg = errMsgArray.join('\n');

			alert(errMsg);
			return false;
		}

//		new_email = {
//			mail_addr : mail_addr_array
//		};
		
		// 更新
//		this.data.alert.email = new_email;
		this.data.alert.email = mail_addr_array;

		this.ajax_updateAlert();
	},

	//--------------------------------------------
	// Update SNMP (enable or disable)
	//--------------------------------------------
	update_snmp_usability : function() {
		var disable;

		disable = true;

		if ($('chk_snmp') != null) {
			if (disable)
				$('chk_snmp').checked = false;

			$('chk_snmp').disabled       = disable;
			$('manager_addr').disabled   = disable;
			$('trapcom').disabled        = disable;
			$('bt_snmp_update').disabled = disable;
		}
	},

	//--------------------------------------------
	// Update E-Mail (enable or disable)
	//--------------------------------------------
	update_email_usability : function() {
		var disable, i, count;

		debug("update_email_usability()");

		if (this.data.email.enable == true)
			disable = false;
		else
			disable = true;

		for (i = 0; i < 3; i++) {
			$($jq.sprintf('txt_email_%d', i)).disabled = disable;
			$($jq.sprintf('chk_email_enable_%d', i)).disabled = disable;
		}

		$('bt_email_update').disabled = disable;

		count = 0;
		for (i in this.data.alert.email) {
			if (disable == true)
				this.data.alert.email[i].enable == false;
			else if (this.data.alert.email[i].enable == true)
				count++;
		}

		debug($jq.sprintf("count: %d", count));

		if (count > 0)
			$('enable_email').disabled = true;
		else
			$('enable_email').disabled = false;
	},

	//------------------------------------------------------
	// E-Mail 設定 Tab

	//--------------------------------------------
	// Update E-Mail
	//--------------------------------------------
	update_smtp : function() {
		var new_email = new Object;

		new_email.enable = $('enable_email').checked;

		if (new_email.enable == true) {
			new_email.smtp_server   = strip_escapeHTML($('smtp_addr').value);
			new_email.pop3_server   = strip_escapeHTML($('pop3_addr').value);
			new_email.account       = strip_escapeHTML($('account').value);
			new_email.password      = strip_escapeHTML($('password').value);
			new_email.name          = strip_escapeHTML($('smtp_name').value);
			new_email.mail_addr     = strip_escapeHTML($('mail_address').value);
			new_email.smtp_port     = parseInt($('smtp_port').value.strip(), 10);
			new_email.pop3_port     = parseInt($('pop3_port').value.strip(), 10);
			new_email.auth_type     = Form.serialize($('email_form')).toQueryParams()['auth_type']
		} else {
			new_email.smtp_server   = "";
			new_email.pop3_server   = "";
			new_email.account       = "";
			new_email.password      = "";
			new_email.name          = "MA-E2xx Default";
			new_email.mail_addr     = "";
			new_email.smtp_port     = 25;
			new_email.pop3_port     = 110;
			new_email.auth_type     = 'auth_smtp';
		}

		debug($jq.sprintf("new_email: %s", Object.toJSON(new_email)));

		// Validation
		if (this.validate_email_account(new_email) == false)
			return false;

		new_email.valid = true;
		this.data.email = new_email;
		return true;
	},

	//--------------------------------------------
	// Update E-Mail (Validator)
	//--------------------------------------------
	validate_email_account : function(info) {
		var errMsgArray = [], errMsg;

		// Use E-mail ?
		if (info.enable == false)
			return true;

		// validate SMTP Server
		if (this.validator.checkFQDN(info.smtp_server) == false &&
			this.validator.checkIPAddress(info.smtp_server) == false)
			errMsgArray.push("・SMTPサーバが不正です。");

		// Use "POP before SMTP" ?
		if (info.auth_type == 'auth_pop') {
			// validate POP3 Server
			if (this.validator.checkFQDN(info.pop3_server) == false &&
				this.validator.checkIPAddress(info.pop3_server) == false)
				errMsgArray.push("・POP3サーバが不正です。");
		}

		// Use authentication ?
		if (info.auth_type != 'auth_none') {
			// validate UserID
			if (info.account == "")
				errMsgArray.push("・ユーザIDが設定されておりません。");
			// validate POP3 Password
			if (info.password == "")
				errMsgArray.push("・パスワードが設定されておりません。");
		}

		// validate Name
		if (info.name == "")
			errMsgArray.push("・名前が設定されておりません。");
		// validate E-mail address
		if (this.validator.checkEmailAddress(info.mail_addr) == false)
			errMsgArray.push("・メールアドレスが不正です。");
		// validate SMTP Port
		if (this.validator.checkRangeInt(info.smtp_port, 1, 65535) == false)
			errMsgArray.push("・SMTPポート番号が不正です。");

		if (info.auth_type == 'auth_pop') {
			if (this.validator.checkRangeInt(info.pop3_port, 1, 65535) == false)
				errMsgArray.push("・POP3ポート番号が不正です。");
		}

		if (errMsgArray.length > 0) {
			errMsg = errMsgArray.join('\n');

			alert(errMsg);
			return false;
		}

		return true;
	},

	//--------------------------------------------
	// Update Authentication use or not
	//--------------------------------------------
	update_auth : function() {
		var pop3_disable, smtp_disable, account_disable;

		if ($('auth_none').checked == true)
			account_disable = true;
		else
			account_disable = false;

		if ($('auth_pop').checked == true)
			pop3_disable = false;
		else
			pop3_disable = true;

//		if ($('auth_ssl').checked == true)
//			smtp_disable = true;
//		else
//			smtp_disable = false;

		$('smtp_addr').disabled = smtp_disable;
		$('smtp_port').disabled = smtp_disable;
		$('pop3_addr').disabled = pop3_disable;
		$('pop3_port').disabled = pop3_disable;
		$('account').disabled   = account_disable;
		$('password').disabled  = account_disable;

//		if ($('auth_ssl').checked == true) {
//			$('smtp_addr').value = 'smtp.gmail.com';
//			$('pop3_addr').value = 'pop.gmail.com';
//			$('smtp_port').value = 587;
//			$('pop3_port').value = 995;
//		}
	},

	//================================================================
	//
	// Utility functions
	//
	//================================================================

	show_indicator : function(elem) {
		$(elem).style.visibility = 'visible';
	},

	hide_indicator : function(elem) {
		$(elem).style.visibility = 'hidden';
	},

	//================================================================
	//
	// Ajax Functions
	//
	//================================================================

	//------------------------------------------------------
	// 監視対象設定Tab

	//--------------------------------------------
	// Get Hosts Information
	//--------------------------------------------
	ajax_getHostInfo : function(chain) {
		var auth_data, put_data;
		var url, params, wsse_header;
		var json;

        auth_data = mod_auth.getAccountInfo();
		wsse_header = wsseHeader(auth_data.account, auth_data.digest);

		url = "/service/apps/monitor/hosts";

		params = {
			method: "GET",
			requestHeaders: [
				'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
				'X-WSSE', wsse_header
				],
			onFailure: function(httpObj) {
				var status = httpObj.status;

				switch (status) {
				case 401:
					// Auth error
					alert("Authentication failed @ ajax_getHostInfo. (401)");
					load_module('auth', 'content', true);
					break;

				default:
					alert($jq.sprintf("ajax_getHostInfo: Error %d.", status));
					break;
				}
			}.bind(this),
			onSuccess: function(httpObj) {
				var res = eval('(' + httpObj.responseText + ')');

				debug($jq.sprintf("ajax_getHostInfo() --> %s", httpObj.responseText));

				if (res.hosts && res.hosts.length > 0)
					this.data.hostlist = res.hosts;
				else
					this.data.hostlist = new Array();

				if (res.poll) {
					debug("poll_info found.");
					this.data.poll_info = res.poll;
				} else
					debug("poll_info not found.");

				if (chain == true)
					this.ajax_getAlertInfo(chain);
				else
					mod_monitor.render();
			}.bind(this)
		};

		new Ajax.Request(url, params);
	},

	//--------------------------------------------
	// Update
	//--------------------------------------------
	ajax_updateTarget : function() {
		var auth_data, put_data;
		var url, params, wsse_header;
		var json, send_data;

        auth_data = mod_auth.getAccountInfo();
		wsse_header = wsseHeader(auth_data.account, auth_data.digest);

		url = "/service/apps/monitor/hosts";

		send_data = {'host_info' : this.data.hostlist,
					 'poll_info' : this.data.poll_info};

		json = Object.toJSON(send_data);
		debug($jq.sprintf("Monitor : ajax_updateTarget(): %s", json));

		params = {
			method: "PUT",
			postBody: json,
			requestHeaders: [
				'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
				'X-WSSE', wsse_header,
				'Content-type', 'application/json'
				],
			onFailure: function(httpObj) {
				var status = httpObj.status;

				this.hide_indicator('indicator_hosts');

				switch (status) {
				case 401:
					alert("Authentication failed @ ajax_updateTarget. (401)");
					load_module('auth', 'content', true);
					break;

				default:
					alert($jq.sprintf("ajax_updateTarget error %d.", status));
					break;
				}
			}.bind(this),
			onSuccess: function(httpObj) {
				this.hide_indicator('indicator_hosts');
				this.update_email_usability();

				alert("更新しました。");
			}.bind(this)
		};

		this.show_indicator('indicator_hosts');
		new Ajax.Request(url, params);
	},

	//------------------------------------------------------
	// 通知先設定Tab

	//--------------------------------------------
	// Get Alert Information
	//--------------------------------------------
	ajax_getAlertInfo : function(chain) {
		var auth_data, put_data;
		var url, params, wsse_header;
		var json;

        auth_data = mod_auth.getAccountInfo();
		wsse_header = wsseHeader(auth_data.account, auth_data.digest);

		url = "/service/apps/monitor/alert";

		params = {
			method: "GET",
			requestHeaders: [
				'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
				'X-WSSE', wsse_header
				],
			onFailure: function(httpObj) {
				var status = httpObj.status;

				switch (status) {
				case 401:
					// Auth error
					alert("Authentication failed @ ajax_getAlertInfo. (401)");
					load_module('auth', 'content', true);
					break;

				default:
					alert($jq.sprintf("ajax_getAlertInfo: Error %d.", status));
					break;
				}
			},
			onSuccess: function(httpObj) {
				var res = eval('(' + httpObj.responseText + ')');

				debug($jq.sprintf("ajax_getAlertInfo() --> %s", httpObj.responseText));

				this.data.alert = res.alert;

				if (chain == true)
					this.ajax_getPeriodicInfo(chain);
				else
					mod_monitor.render(1);
			}.bind(this)
		};

		new Ajax.Request(url, params);
	},

	//--------------------------------------------
	// Update SNMP & E-Mail
	//--------------------------------------------
	ajax_updateAlert : function() {
		var auth_data, put_data;
		var url, params, wsse_header;
		var json, send_data;

        auth_data = mod_auth.getAccountInfo();
		wsse_header = wsseHeader(auth_data.account, auth_data.digest);

		url = "/service/apps/monitor/alert";

		send_data = { 'alert_info' : this.data.alert };
		json = Object.toJSON(send_data);
		debug($jq.sprintf("Monitor : ajax_updateTarget(): %s", json));

		params = {
			method: "PUT",
			postBody: json,
			requestHeaders: [
				'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
				'X-WSSE', wsse_header,
				'Content-type', 'application/json'
				],
			onFailure: function(httpObj) {
				var status = httpObj.status;

				this.hide_indicator('indicator_alert_email');

				switch (status) {
				case 401:
					alert("Authentication failed @ ajax_updateAlert. (401)");
					load_module('auth', 'content', true);
					break;

				default:
					alert($jq.sprintf("ajax_updateAlert error %d.", status));
					break;
				}
			}.bind(this),
			onSuccess: function(httpObj) {
				this.hide_indicator('indicator_alert_email');
				this.update_email_usability();

				alert("更新しました。");
			}.bind(this)
		};

		this.show_indicator('indicator_alert_email');
		new Ajax.Request(url, params);
	},

	//------------------------------------------------------
	// 定期送信設定Tab
	
	ajax_getPeriodicInfo : function(chain) {
		var auth_data, put_data;
		var url, param, wsse_header;
		
        auth_data = mod_auth.getAccountInfo();
		wsse_header = wsseHeader(auth_data.account, auth_data.digest);

		url = "/service/apps/monitor/periodic";

		params = {
			method: "GET",

			requestHeaders: [
				'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
				'X-WSSE', wsse_header
			],

			onFailure: function(httpObj) {
				var status = httpObj.status;
				switch(status) {
				case 401:
					alert("Authentication failed @ ajax_getPeriodicInfo, (401)");
					load_module("auth", "content", true);
					break;
				default:
					alert($jq.sprintf("ajax_getPeriodicInfo: Error %d.", status));
					break;
				}
			},

			onSuccess: function(httpObj) {
				var res = eval('(' + httpObj.responseText + ')');
				debug($jq.sprintf("ajax_getPeriodicInfo() --> %s", httpObj.responseText));
				this.data.periodic = res.periodic;
				if (chain == true)
					this.ajax_getEmailInfo(chain);
				else
					mod_monitor.render(0);
			}.bind(this)
		};

		new Ajax.Request(url, params);
	},

	ajax_updatePeriodicInfo : function() {
		var auth_data, wsse_header, url, params;

        auth_data = mod_auth.getAccountInfo();
		wsse_header = wsseHeader(auth_data.account, auth_data.digest);
		url = "/service/apps/monitor/periodic";
		json = Object.toJSON({'periodic': this.data.periodic});

		debug($jq.sprintf("updatePeriodicInfo: --> '%s'", json));

		params = {
			method: "PUT",
			postBody: json,
			requestHeaders: [
				'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
				'X-WSSE', wsse_header,
				'Content-type', 'application/json'
				],
				
			onFailure: function(httpObj) {
				var status = httpObj.status;
				this.hide_indicator('indicator_periodic');
				switch (status) {
				case 401:
					alert("Authentication failed @ ajax_updatePeriodicInfo. (401)");
					load_module('auth', 'content', true);
					break;
				default:
					alert($jq.sprintf("ajax_updateEmailInfo: Error %d.", status));
					break;
				}
			}.bind(this),

			onSuccess: function(httpObj) {
				this.hide_indicator('indicator_periodic');
				alert("更新しました。");
			}.bind(this)
		};

		this.show_indicator('indicator_periodic');
		new Ajax.Request(url, params);
	},
	
	//------------------------------------------------------
	// E-Mail設定Tab

	//--------------------------------------------
	// Get E-Mail Information
	//--------------------------------------------
	ajax_getEmailInfo : function(chain) {
		var auth_data;
		var url, params, wsse_header;

        auth_data = mod_auth.getAccountInfo();
		wsse_header = wsseHeader(auth_data.account, auth_data.digest);

		url = "/service/apps/monitor/email";

		params = {
			method: "GET",
			requestHeaders: [
				'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
				'X-WSSE', wsse_header
				],
			onFailure: function(httpObj) {
				var status = httpObj.status;

				switch (status) {
				case 401:
					// Auth error
					alert("Authentication failed @ ajax_getEmailInfo. (401)");
					load_module('auth', 'content', true);
					break;

				default:
					alert($jq.sprintf("ajax_getEmailInfo: Error %d.", status));
					break;
				}
			},
			onSuccess: function(httpObj) {
				var res = eval('(' + httpObj.responseText + ')');

				debug($jq.sprintf("ajax_getEmailInfo() --> %s", httpObj.responseText));

				this.data.email = res.email;
				
				mod_monitor.render(0);
			}.bind(this)
		};

		new Ajax.Request(url, params);
	},

	//--------------------------------------------
	// Update E-Mail Information
	//--------------------------------------------
	ajax_updateEmailInfo : function() {
		var auth_data, put_data;
		var url, params, wsse_header;
		var send_data, json;

        auth_data = mod_auth.getAccountInfo();
		wsse_header = wsseHeader(auth_data.account, auth_data.digest);

		url = "/service/apps/monitor/email";

		send_data = { 'email_info' : this.data.email };
		json = Object.toJSON(send_data);

		debug($jq.sprintf("updateEmailInfo: --> '%s'", json));

		params = {
			method: "PUT",
			postBody: json,
			requestHeaders: [
				'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
				'X-WSSE', wsse_header,
				'Content-type', 'application/json'
				],
			onFailure: function(httpObj) {
				var status = httpObj.status;

				this.hide_indicator('indicator_email');

				switch (status) {
				case 401:
					// Auth error
					alert("Authentication failed @ ajax_updateEmailInfo. (401)");
					load_module('auth', 'content', true);
					break;

				default:
					alert($jq.sprintf("ajax_updateEmailInfo: Error %d.", status));
					break;
				}
			}.bind(this),
			onSuccess: function(httpObj) {
				this.hide_indicator('indicator_email');

				alert("更新しました。");
			}.bind(this)
		};

		this.show_indicator('indicator_email');
		new Ajax.Request(url, params);
	},

	showIndicator : function(elem) {
		$(elem).style.visibility = 'visible';
	},

	hideIndicator : function(elem) {
		$(elem).style.visibility = 'hidden';
	}
};
