//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// ネットワーク設定
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2007-2010 Century Systems Co., Ltd.
//
// Last Modified: 2010/05/28 15:05:36 kikuchi
//==============================================================================

mod_network = {
    //--------------------------------------------
    // HTML template
    //--------------------------------------------
    template : {
	    HTMLtemplate : [
	        "<h1 class='title'>インターフェース設定</h1>",
	        "<h3>編集されるファイル&nbsp;<img src='img/ark_help.png' id='help_file' /></h3><br/>",
	        "<% var use_dhcp = conf[ifaces[ifnum]].config.use_dhcp; %>",
	        "<form id='netconf_form'>",
	        "<table id='netconf_table' class='zebra'>",
	        "<tr>",
	        "  <th colspan='2' class='header'>Ethernet I/F設定</th>",
	        "</tr>",
	        "<tr>",
	        "  <th id='th_iface'>インターフェース</th>",
	        "  <td class='noborder'>",
	        "    <select id='iface' name='iface' class='select'",
	        "     tabindex='1' style='width:60px;'>",
	        "     <:for i in ifaces:>",
	        "      <option value='${ifaces[i]}' ",
	        "       <:if i == ifnum :>selected='selected'<:/if:>",
	        "      >${ifaces[i]}</option>",
	        "     <:/for:>",
	        "    </select>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "</tr>",
	        "<tr>",
	        "  <th id='th_ipaddr'>IPアドレス</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='ipaddr' class='text' style='width:100%;'",
	        "     tabindex='2' value=${conf[ifaces[ifnum]].config.address}></input>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th id='th_netmask'>ネットマスク</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='netmask' class='text' style='width:100%;'",
	        "     tabindex='3' value=${conf[ifaces[ifnum]].config.netmask}></input>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th id='th_gateway'>デフォルトゲートウェイ</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='gateway' class='text' style='width:100%;'",
	        "     tabindex=4' value=${conf[ifaces[ifnum]].config.gateway}></input>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th>DHCPオプション</th>",
	        "  <td>",
	        "   <ul style='list-style-type: none;'>",
	        "    <li>",
	        "    <label for='dhcp'>",
	        "    <input id='dhcp' name='dhcp' type=checkbox ",
	        "      <:if conf[ifaces[ifnum]].config.use_dhcp == true:>checked='checked'<:/if:>/>",
	        "      DHCPを使用する<br/><br/>",
	        "      <% if (conf[ifaces[ifnum]].config.dhcp_opts == null)",
	        "        conf[ifaces[ifnum]].config.dhcp_opts = new Array; %>",
 	        "      <% var dhcp_opts = conf[ifaces[ifnum]].config.dhcp_opts; %>",
	        "    </label>",
	        "    </li>",
 	        "    <div id='dhcp_enable' ",
	        "     <:if use_dhcp == false:>style='display:none'<:/if:>>",
	        "      <li>",
	        "      <label for='release'>",
  	        "      <input type='checkbox' id='release' value='release' ",
  	        "        <:if use_dhcp && dhcp_opts.indexOf('release') >= 0:>checked='checked'<:/if:>/>",
  	        "        再利用できるようにIPアドレスを解放する<br/>",
	        "      </label>",
	        "      </li>",
	        "      <li>",
	        "      <label for='nodns'>",
  	        "      <input type='checkbox' id='nodns' value='nodns' ",
  	        "        <:if use_dhcp && dhcp_opts.indexOf('nodns') >= 0:>checked='checked'<:/if:>/>",
  	        "        /etc/resolv.conf を書き換えない<br/>",
	        "      </label>",
	        "      </li>",
	        "      <li>",
	        "      <label for='nontp'>",
  	        "      <input type='checkbox' id='nontp' value='nontp' ",
  	        "        <:if use_dhcp && dhcp_opts.indexOf('nontp') >= 0:>checked='checked'<:/if:>/>",
  	        "      /etc/ntp.conf を書き換えない<br/>",
	        "      </label>",
	        "      </li>",
	        "      <li>",
	        "      <label for='nogateway'>",
  	        "      <input type='checkbox' id='nogateway' value='nogateway' ",
  	        "        <:if use_dhcp && dhcp_opts.indexOf('nogateway') >= 0:>checked='checked'<:/if:>/>",
  	        "        デフォルトゲートウェイを設定しない<br/>",
	        "      </label>",
	        "      </li>",
	        "     </ul>",
 	        "    </div>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "<tr>",
	        "  <th colspan='2' class='header'>DNSサーバ設定</th>",
	        "</tr>",
	        "<tr>",
	        "  <th>DNSサーバ (1)</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='dns1' class='text' style='width:100%;'",
	        "     tabindex='5' value=${dnsservers[0]}></input>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th>DNSサーバ (2)</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='dns2' class='text' style='width:100%;'",
	        "     tabindex='6' value=${dnsservers[1]}></input>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan='2' class='noborderright'>",
			"    <img id='indicator' src='img/indicator.gif' ",
			"     style='visibility: hidden;' />",
	        "    <input type='button' id='bt_update' value='設定' class='button'",
	        "     tabindex='7' style='width:60px;' />",
	        "  </td>",
	        "</tr>",
	        "</table></form>"
	    ].join("\n"),
	    //------------------------------
	    // Event Handler
	    //------------------------------
	    handlers : [
	        [
		        // Interface ('eth*') change handler
		        'iface', 'change', function() {
		            mod_network.ifChange($('iface').value)
		        }],
	        [
		        // DHCP checkbox click handler
		        'dhcp', 'click', function() {
		            if ($('dhcp').checked) {
			            new Effect.Appear($('dhcp_enable'));
		            } else {
			            new Effect.Fade($('dhcp_enable'));
		            }
		        }],
	        [
		        // "Update" button handler
		        'bt_update', 'click', function() {
		            mod_network.updateInterface($('iface').value)
		        }],
	        [
		        // "Restart" button handler
		        'bt_restart', 'click', function() {
		            mod_network.restartInterface($('iface').value)
		        }]
	    ],
	    //------------------------------
	    // Tooltip
	    //------------------------------
	    tooltips : [
	        [
		        // Interface
		        'th_iface', 'Note', "Ethernet I/Fを選択してください。"
	        ],
	        [
		        // IPv4 Address
		        'th_ipaddr', 'Note', ["IPアドレスを設定します。DHCPを使用する場合、",
				                      "DHCPリクエストが失敗した場合に",
				                      "ここで指定したアドレスが設定されます。"].join('')
	        ],
	        [
		        // IPv4 Netmask
		        'th_netmask', 'Note', ["ネットマスクを設定します。DHCPを使用する場合、",
				                       "DHCPリクエストが失敗した場合に",
				                       "ここで指定したネットマスクが設定されます。"].join('')
	        ],
	        [
		        // IPv4 Gateway
		        'th_gateway', 'Note', ["デフォルトゲートウェイを設定します。<br/>",
				                       "装置に対して1つだけ設定してください。"].join('')
	        ],
	        [
		        // "Update" button
		        'bt_update', 'Note', ["設定を装置へ保存します。<br/>",
				                      "反映するには再起動が必要です。"].join('')
	        ],
	        // 			[
	        // 				// "Restart" button
	        // 				'bt_restart', 'Note', "選択されたI/Fを再起動します。"
	        // 				],
	        [
		        // --- 編集されるファイル ---
		        'help_file', 'Note', ["下記のファイルが編集対象です。<br/>",
				                      "/etc/conf.d/net"
				                     ].join('\n')
	        ]
	    ]
    },

    // dummy data
    data : {
	    //		ifaces : [ 'eth0', 'eth1' ],
	    ifaces : [ 'eth0' ],
	    conf : {
	        'eth0' : { 'modules' : [ 'iproute2' ],
		               'config' :
		               { 'dhcp'    : false,
			             'ipaddr'  : '192.168.253.253',
			             'netmask' : '255.255.255.0' },
		               'dhcp_opts' : [ 'release', 'nontp' ]
		             }
	    },
	    dnsservers : [
	        '202.247.130.5',	// primary
	        ''					// secondary
	    ],
	    // for Update
	    putdata : {
	        'address'   : '192.168.254.200',
	        'netmask'   : '255.255.255.0',
	        'gateway'   : '',
	        'use_dhcp'  : false,
	        'dhcp_opts' : []
	    }
    },

    //--------------------------------------------
	// show / hide indicator
	//--------------------------------------------
	show_indicator : function() {
		$('bt_update').disabled = true;
		$('indicator').style.visibility = 'visible';
	},

	hide_indicator : function() {
		$('bt_update').disabled = false;
		$('indicator').style.visibility = 'hidden';
	},

	//--------------------------------------------
    // Initialize
    //--------------------------------------------
    init : function(elem) {
	    var auth_data;
	    this.elem = elem;

	    auth_data = mod_auth.getAccountInfo();

	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);

	        return;
	    }

	    if (!this.validator)
	        this.validator = new validateUtil();

	    this.ajax_getDNSServers();
	    this.ajax_getInterfaces();
    },

    //--------------------------------------------
    // Render HTML
    //--------------------------------------------
    render : function(intf) {
	    var parser, template, html;

	    template = this.template;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template, true);
    },

    //==========================================================================
    //
    // Classes
    //
    //==========================================================================

    //==========================================================================
    //
    // Internal use
    //
    //==========================================================================

    //------------------------------------------------------
    // Interface情報FORMから 更新用データ生成
    //------------------------------------------------------
    update_conf: function(intf) {
	    var modules, config, dhcp_opts;

	    // shortcuts
	    config = this.data.putdata;

	    config.address   = strip_escapeHTML($('ipaddr').value);
	    config.netmask   = strip_escapeHTML($('netmask').value);
	    config.dhcp_opts = new Array;

	    // DHCP使用する ?
	    if ($('dhcp').checked) {
	        config.use_dhcp = true;
	        modules = ['dhcpcd'];

	        var options = ['release', 'nodns', 'nontp', 'nogateway'];
	        for (var i = 0; i < options.length; i++) {
		        var opt = options[i];

		        if ($(opt).checked)
		            config.dhcp_opts.push(opt);
	        }
	    } else {
	        config.use_dhcp = false;
	        modules = ['iproute2'];
	    }

	    // Default gateway
	    config.gateway = strip_escapeHTML($('gateway').value);
	    config.modules = modules;

	    // DNS Servers
	    this.data.dnsservers[0] = strip_escapeHTML($('dns1').value);
	    this.data.dnsservers[1] = strip_escapeHTML($('dns2').value);
    },

    //==========================================================================
    //
    // Ajax functions
    //
    //==========================================================================

    //------------------------------------------------------
    // Interface 一覧取得 (GET)
    //------------------------------------------------------
    ajax_getInterfaces: function() {
	    var auth_data;
	    var url, params, wsse_header;

	    auth_data = mod_auth.getAccountInfo();

	    //wsse_header = wsseHeader(auth_data.account, auth_data.password);
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/ethernet";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ getInterfaces. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var ifaces = eval("(" + httpObj.responseText + ")");
		        this.data.ifaces = ifaces['Interfaces'];

		        // 1つめの情報を取得
		        this.getInterfaceInfo(this.data.ifaces[0]);
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //------------------------------------------------------
    // Interface 情報取得 (GET)
    //------------------------------------------------------
    getInterfaceInfo: function(intf) {
	    var auth_data;
	    var url, params, configs, wsse_header;

	    auth_data = mod_auth.getAccountInfo();

	    //wsse_header = wsseHeader(auth_data.account, auth_data.password);
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/ethernet/" + intf;

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @getInterfaceInfo. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var ifaces = eval("(" + httpObj.responseText + ")");
		        debug($jq.sprintf("getInterfaceInfo: --> '%s'", httpObj.responseText));

		        this.data.conf[intf] = {}
		        this.data.conf[intf]['config'] = ifaces;
		        this.data.ifnum = this.data.ifaces.indexOf(intf);

		        this.render(intf);
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //------------------------------------------------------
    // DNS Server 一覧取得 (GET)
    //------------------------------------------------------
    ajax_getDNSServers : function() {
	    var auth_data;
	    var url, params, wsse_header;

	    auth_data = mod_auth.getAccountInfo();

	    //wsse_header = wsseHeader(auth_data.account, auth_data.password);
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/dns";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ getInterfaces. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result = eval("(" + httpObj.responseText + ")");
		        this.data.dnsservers = result['DNS_Servers'];
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Interface setting update (PUT)
    //--------------------------------------------
    ajax_putInterface : function(intf) {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    this.update_conf(intf);

	    url = "/service/conf/net/ethernet/" + intf;

	    put_data = this.data.putdata;
	    json = Object.toJSON(put_data);

	    debug($jq.sprintf("updateInterface() : %s", json));

	    params = {
	        method: "PUT",
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ updateInterface. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
				this.hide_indicator();

				var dialog_param = {
					className  : "alphacube",
					width      : 240,
					showEffect : Element.show,
					hideEffect : Element.hide
				};
				Dialog.alert(intf + "の設定を更新しました。", 
						dialog_param);
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // DNS Server update (PUT)
    //--------------------------------------------
    ajax_putDNSServers : function(intf) {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/dns";

	    this.update_conf(intf);

	    put_data = {'dns_servers' : this.data.dnsservers};
	    json = Object.toJSON(put_data);
	    debug($jq.sprintf("updateDNSServers() : %s", json));

	    params = {
	        method: "PUT",
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ updateDNSServers. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result = eval("(" + httpObj.responseText + ")");

		        debug($jq.sprintf("call mod_network.putInterface(%d)", intf));
		        mod_network.ajax_putInterface(intf);
	        }
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Ethernet Interface restart (POST)
    //--------------------------------------------
    ajax_restartInterface : function(intf) {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = $jq.sprintf("/service/conf/net/ethernet/%s", intf);

	    debug($jq.sprintf("ajax_restartInterface() : URL= %s", url));

	    params = {
	        method: "POST",
	        postBody: 'command=restart',
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ ajax_restartInterface. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result = eval("(" + httpObj.responseText + ")");

		        debug($jq.sprintf("call mod_network.putInterface(%d)", intf));
		        mod_network.ajax_putInterface(intf);
	        }
	    };

	    new Ajax.Request(url, params);
    },

    //==========================================================================
    //
    // Form callbacks
    //
    //==========================================================================

    //--------------------------------------------
    // Interface change
    //--------------------------------------------
    ifChange : function(intf) {
	    this.data.ifnum = this.data.ifaces.indexOf(intf);
	    this.getInterfaceInfo(intf);
    },

    //--------------------------------------------
    // Interface update
    //--------------------------------------------
    updateInterface : function(intf) {
	    var params, msg;

	    // Form validation
	    if (this.validateForm() == false)
	        return;

	    params = {
	        className : "alphacube",
			width: 400,
	        showEffect  : Element.show,
	        hideEffect  : Element.hide,

	        onOk : function() {
		        debug("Confirm: OK");
				mod_network.show_indicator();

		        //this.putInterface(intf);
		        this.ajax_putDNSServers(intf);

		        return true;
	        }.bindAsEventListener(this),
	        onCancel : function() {
		        debug("Confirm: Cancel");

		        return false;
	        }
	    };

		msg = "Interface '" + intf + "' の設定を変更します。<br/><br/>";
		msg += "<p align=left>設定の変更は直ちに反映されます。設定画面へのアクセスに使用している";
		msg += "インターフェースのIPアドレスを変更をする場合は、変更の実行後にブラウザを閉じ、";
		msg += "変更後のIPアドレスへ再度アクセスしてください。</p><br/>";
		msg += "設定の変更を実行してよろしいですか?";
	    Dialog.confirm(msg, params);
    },

    //--------------------------------------------
    // Interface restart
    //--------------------------------------------
    restartInterface : function(intf) {
	    var params, msg;

	    params = {
	        className : "alphacube",
	        width: 300,

	        onOk : function() {
		        debug("Confirm: OK");

		        // Network I/F Restart
		        mod_network.ajax_restartInterface(intf);
		        return true;
	        }.bindAsEventListener(this),
	        onCancel : function() {
		        debug("Confirm: Cancel");

		        return false;
	        }
	    };

	    msg = "Interface '" + intf + "' を<br/>再起動してよろしいですか ?";
	    Dialog.confirm(msg, params);
    },

    //--------------------------------------------
    // Form validation
    //--------------------------------------------
    validateForm : function() {
	    var ipaddr, netmask, gateway;
	    var dns = [], i;
	    var errMsgArray = [], errMsg;

	    ipaddr  = strip_escapeHTML($('ipaddr').value);
	    netmask = strip_escapeHTML($('netmask').value);
	    gateway = strip_escapeHTML($('gateway').value);

	    dns[0] = strip_escapeHTML($('dns1').value);
	    dns[1] = strip_escapeHTML($('dns2').value);

	    if (this.validator.checkIPAddress(ipaddr) == false)
	        errMsgArray.push("・IPアドレスが不正です。");

	    if (this.validator.checkNetmask(netmask) == false)
	        errMsgArray.push("・ネットマスクが不正です。");

	    if (gateway != "") {
	        if (this.validator.checkIPAddress(gateway) == false)
		        errMsgArray.push("・デフォルトゲートウェイが不正です。");
	        else if (this.validator.checkReachability(ipaddr, netmask, gateway) == false)
		        errMsgArray.push("・デフォルトゲートウェイに\n　到達できないアドレスが設定されています。");
	    }

	    for (i = 0; i < 2; i++) {
	        if (dns[i] != "" && this.validator.checkIPAddress(dns[i]) == false)
		        errMsgArray.push($jq.sprintf("・DNSサーバ(%d)が不正です。", i + 1));
	    }

	    if (errMsgArray.length > 0) {
	        errMsg = errMsgArray.join("\n");
	        alert(errMsg);

	        return false;
	    }

	    return true;
    }
};
