//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// OCN IPv6管理
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2007-2010 Century Systems Co., Ltd.
//
// Last Modified: 2010/05/28 15:05:56 kikuchi
//==============================================================================

mod_ocnipv6 = {
    //--------------------------------------------
    // HTML template
    //--------------------------------------------
    template_setting : {
	    HTMLtemplate : [
	        "<h1 class='title'>OCN IPv6設定</h1>",
	        "<h3>編集されるファイル&nbsp;<img src='img/ark_help.png' id='help_file' /></h3><br/>",
	        "<table id='ocnipv6_table' class='zebra'>",
	        "<tr>",
	        "  <th colspan=2 class='header'>現在の状態</th>",
	        "</tr>",
	        "<tr>",
	        "  <th>接続状態</th>",
	        "  <td id='stat_connect'>",
	        "   <:if status.connection == true:>",
	        "     接続確立",
	        "   <:/if:>",
	        "   <:else:>",
	        "     <:if status.action == 'connect':>",
	        "       接続中...",
	        "     <:/if:>",
	        "     <:elseif status.action == 'disconnect':>",
	        "       切断中...",
	        "     <:/elseif:>",
	        "     <:else:>",
	        "       接続していません",
	        "     <:/else:>",
	        "   <:/else:>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th>プレフィックス</th>",
	        "  <td id='stat_prefix'>",
	        "   <:if status.connection == true:>",
	        "     ${status.prefix}::/${status.prefixlen}",
	        "   <:/if:>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan='2' class='noborderright'>",
	        "    <img id='indicator_status' src='img/indicator.gif' ",
	        "     style='visibility: hidden;' />",
	        "    <input type='button' id='btn_get_stat' class='button' style='width:60px;'",
	        "     value='更新' />",
	        "    <input type='button' id='btn_disconnect' class='button' style='width:60px;'",
	        "     value='切断' />",
	        "    <input type='button' id='btn_connect' class='button' style='width:60px;'",
	        "     value='接続' />",
	        "  </td>",
	        "</tr>",
	        "<tr><br/></tr>",

	        "<tr>",
	        "  <th colspan=2 class='header'>アカウント設定</th>",
	        "</tr>",
	        "<tr>",
	        "  <th>サービス利用</th>",
	        "  <td>",
	        "   <ul style='list-style-type: none;'>",
	        "    <li>",
	        "    <label for='chk_ocnv6'>",
	        "    <input type='checkbox' id='chk_ocnv6' tabindex='1'",
	        "     <:if settings.use_ocnv6==true:>checked='checked'<:/if:> />",
	        "     OCN IPv6サービスを利用する",
	        "    </label>",
	        "    </li>",
	        "   </ul>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th>自動起動</th>",
	        "  <td>",
	        "   <ul style='list-style-type: none;'>",
	        "    <li>",
	        "    <label for='chk_auto_connect'>",
	        "    <input type='checkbox' id='chk_auto_connect' tabindex='2'",
	        "     <:if settings.auto_connect==true:>checked='checked'<:/if:>",
	        "     <:if settings.use_ocnv6==false:>disabled='disabled'<:/if:> />",
	        "     起動時に自動接続する",
	        "    </label>",
	        "    </li>",
	        "   </ul>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th>接続サーバ名</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='txt_l2tp_server' class='text'",
	        "     style='width:200px;' tabindex='4'",
	        "      value='${settings.l2tp_server}' />",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th>L2TPサーバ Listenポート</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='txt_l2tp_port' class='text'",
	        "     style='width:200px;' tabindex='5'",
	        "      value='${settings.l2tp_port}' />",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th>認証ID</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='userID' class='text'",
	        "     style='width:200px;' tabindex='6'",
	        "     value='${settings.account}' />",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th>認証パスワード</th>",
	        "  <td class='noborder'>",
	        "    <input type='password' id='password' class='text'",
	        "     style='width:200px;' tabindex='7'",
	        "     value='${settings.password}' />",
	        "  </td>",
	        "</tr>",
	        "  <th>認証パスワード(確認)</th>",
	        "  <td class='noborder'>",
	        "    <input type='password' id='password_verify' class='text'",
	        "     style='width:200px;' tabindex='8'",
	        "     value='${settings.password}' />",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan='2' class='noborderright'>",
	        "    <img id='indicator_settings' src='img/indicator.gif' ",
	        "     style='visibility: hidden;' />",
	        "    <input type='button' id='btn_update' class='button'",
	        "     style='width:60px;' tabindex='9'",
	        "     value='設定' />",
	        "  </td>",
	        "</tr>",
	        "</table>"
	    ].join("\n"),
	    //------------------------------
	    // Event Handlers
	    //------------------------------
	    handlers : [
	        [
		        // OCNv6 checkbox
		        'chk_ocnv6', 'click', function() {
		            var checked;

		            checked = $('chk_ocnv6').checked;

		            if (!checked) {
			            $('chk_auto_connect').checked  = false;
			            $('chk_auto_connect').disabled = true;
		            } else
			            $('chk_auto_connect').disabled = false;
		        }],
	        [
		        // '更新' button
		        'btn_get_stat', 'click', function() {
		            //debug("'更新' button clicked.");

		            mod_ocnipv6.getStatus(false, false);
		        } ],
	        [
		        // '切断' button
		        'btn_disconnect', 'click', function() {
		            //debug("'切断' button clicked.");

		            mod_ocnipv6.reqDisconnect(false);
		        } ],
	        [
		        // '接続' button
		        'btn_connect', 'click', function() {
		            //debug("'接続' button clicked.");

		            mod_ocnipv6.reqConnect(false);
		        } ],
	        [
		        // '設定' button
		        'btn_update', 'click', function() {
		            //debug("'設定' button clicked.");

		            mod_ocnipv6.setConfig();
		        } ]
	    ],
	    //------------------------------
	    // Tooltips
	    //------------------------------
	    tooltips : [
	        [
		        // '更新' button
		        'btn_get_stat', 'Note', "OCN IPv6接続状態を更新します。"
	        ],
	        [
		        // '切断' button
		        'btn_disconnect', 'Note', "OCN IPv6から切断します。"
	        ],
	        [
		        // '(再)接続' button
		        'btn_connect', 'Note', "OCN IPv6に接続します。"
	        ],
	        [
		        // --- 編集されるファイル ---
		        'help_file', 'Note', [ "下記のファイルが編集対象です。<br/>",
				                       "/etc/l2tp/l2tp.conf<br/>",
				                       "/etc/ppp/chap-secrets<br/>",
				                       "/etc/ppp/peers/v6tun<br/>",
				                       "/etc/OCNIPv6/ocnv6" ].join('\n')
	        ]
	    ]
    },

    // dummy data
    data : {
	    // 設定情報
	    settings : {
	        l2tp_server : '',
	        l2tp_port   : 1701,

	        account  : "hogehoge@fuga.ocn.ne.jp",
	        password : "hogefuga",

	        use_ocnv6    : true,
	        auto_connect : false,
	        interface    : 'eth1'
	    },

	    // 接続状態
	    status : {
	        connection : true,
	        prefix     : '2001:0380:0e04:0000',
	        prefixlen  : 64
	    },

	    LNS : [
	        [ "固定プレフィックス用",
	          'v6tffd1.ocn.ne.jp' ],
	        [ "非固定プレフィックス用",
	          'v6tfpa1.ocn.ne.jp' ],
	        [ "Manual Setting",
	          '' ]
	    ]
    },

    //--------------------------------------------
    // Initialize
    //--------------------------------------------
    init : function(elem) {
	    var auth_data;
	    this.elem = elem;

	    // Auth check
	    auth_data = mod_auth.getAccountInfo();
	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);

	        return;
	    }

	    // Form validator
	    if (!this.validator)
	        this.validator = new validateUtil();

	    // 状態取得
	    this.getStatus(true, true);

	    //		this.render_settings();
    },

    //--------------------------------------------
    // Render HTML (設定)
    //--------------------------------------------
    render_settings : function() {
	    var html, parser, template, idx;

	    template = this.template_setting;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template, true);

	    this.update_button();
    },

    //--------------------------------------------
    // update data from Form
    //--------------------------------------------
    updateFromForm : function() {
	    var settings;
	    var new_settings = new Object();
	    var passwd = new Array();

	    // Shortcut
	    settings = this.data.settings;

	    // use OCN IPv6
	    new_settings.use_ocnv6    = $('chk_ocnv6').checked;

	    if (new_settings.use_ocnv6 == true) {
	        new_settings.l2tp_server = strip_escapeHTML($('txt_l2tp_server').value);

	        // L2TP Listen port
	        new_settings.l2tp_port = parseInt($('txt_l2tp_port').value.strip(), 10);

	        // 認証ID
	        new_settings.account = strip_escapeHTML($('userID').value);

	        // 認証パスワード
	        passwd[0] = $('password').value.strip();
	        passwd[1] = $('password_verify').value.strip();

	        if (passwd[0] != passwd[1]) {
		        alert("・パスワードが一致しません。");

		        return false;
	        }

	        new_settings.password     = passwd[0];
	        new_settings.auto_connect = $('chk_auto_connect').checked;
	    } else {
	        //			new_settings.LNS_sel      = 0;
	        new_settings.l2tp_server  = 'v6tffd1.ocn.ne.jp';
	        new_settings.l2tp_port    = 1701;
	        new_settings.account      = '';
	        new_settings.password     = '';
	        new_settings.auto_connect = false;
	    }

	    new_settings.interface = MA4xx_conf.net.lan;
	    new_settings.unit      = 100;
	    new_settings.name      = 'ppp100';

	    debug($jq.sprintf("new_settings = %s", Object.toJSON(new_settings)));

	    // validation
	    if (this.validate(new_settings) == true) {
	        this.data.settings = new_settings;
	        return true;
	    }

	    return false;
    },

    //--------------------------------------------
    // Update connection status
    //--------------------------------------------
    updateStatus : function() {
	    var status;
	    var txt_connect, txt_prefix;

	    //debug("updateStatus()");

	    status = this.data.status;

	    if (status.connection == true) {
	        txt_connect = "接続確立";
	        txt_prefix = $jq.sprintf("%s::/%d", status.prefix, status.prefixlen);
	    } else {
	        txt_prefix = "";

	        if (status.action == 'connect')
		        txt_connect = "接続中...";
	        else if (status.action == 'disconnect')
		        txt_connect = "切断中...";
	        else
		        txt_connect = "接続していません";
	    }

	    $('stat_connect').innerHTML = txt_connect;
	    $('stat_prefix').innerHTML = txt_prefix;

	    this.update_button();
    },

    //--------------------------------------------
    // Form validation
    //--------------------------------------------
    validate : function(new_settings) {
        var errMsgArray = [], errMsg;

        // OCN IPv6サービスを利用する場合のみ
        if (new_settings.use_ocnv6 == true) {
            // validate userID (account)
            if (this.validator.checkOCN_Account(new_settings.account) == false)
                errMsgArray.push("・認証IDが不正です。");
            if (new_settings.password == "")
                errMsgArray.push("・認証パスワードが設定されていません。");
        } else {
            // insure
            new_settings.auto_connect = false;
            new_settings.account      = '';
            new_settings.password     = '';
        }

        if (errMsgArray.length > 0) {
            errMsg = errMsgArray.join('\n');
            alert(errMsg);

            return false;
        }

        return true;
    },

    //--------------------------------------------
    // update button status
    //--------------------------------------------
    update_button : function() {
        var btn_get_stat, btn_disconnect, btn_connect;

        if (this.data.settings.use_ocnv6 == true) {
            // OCN IPv6サービスを利用する
            //debug("update_button: settings.use_ocnv6 == true");
            btn_get_stat = false;

            if (this.data.status.connection == true) {
                // 接続確立中
                //debug("update_button: status.connection == true");
                btn_disconnect = false;
                btn_connect    = true;
            } else {
                if (this.data.status.action == 'connect') {
                    // 接続中
                    //debug("update_button: status.action == 'connect'");
                    btn_disconnect = false;
                    btn_connect    = true;
                } else if (this.data.status.action == 'disconnect') {
                    // 切断中
                    //debug("update_button: status.action == 'disconnect'");
                    btn_disconnect = true;
                    btn_connect    = true;
                } else {
                    // 接続していない
                    //debug("update_button: Not connected");
                    btn_disconnect = true;
                    btn_connect    = false;
                }
            }
        } else {
            // OCN IPv6サービスを利用しない
            btn_get_stat   = true;
            btn_disconnect = true;
            btn_connect    = true;
        }

        $('btn_get_stat').disabled   = btn_get_stat;
        $('btn_disconnect').disabled = btn_disconnect;
        $('btn_connect').disabled    = btn_connect;

        // 接続中 → 設定変更不可
        $('btn_update').disabled = this.data.status.connection;
    },

    //================================================================
    //
    // Utility functions
    //
    //================================================================

    //
    show_indicator : function(elem) {
        $(elem).style.visibility = 'visible';
    },

    //
    hide_indicator : function(elem) {
        $(elem).style.visibility = 'hidden';
    },

    //================================================================
    //
    // Ajax Functions
    //
    //================================================================

    //--------------------------------------------
    // Get Configuration
    //--------------------------------------------
    getSettings : function(render) {
        var auth_data;
        var url, params, wsse_header;

        auth_data = mod_auth.getAccountInfo();
        wsse_header = wsseHeader(auth_data.account, auth_data.digest);

        url = "/service/conf/net/ocnv6/settings";

        params = {
            method: "GET",
            requestHeaders: [
                'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
                'X-WSSE', wsse_header
            ],
            onFailure: function(httpObj) {
                var status = httpObj.status;

                switch (status) {
                case 401:
                    alert("Authentication failed @ getInterfaces. (401)");
                    load_module('auth', 'content', true);
                    break;

                default:
                    alert($jq.sprintf("Error %d", status));
                    break;
                }
            }.bind(this),
            onSuccess: function(httpObj) {
                var settings = eval("(" + httpObj.responseText + ")");
                this.data.settings = settings;

                debug($jq.sprintf("getSettings: '%s'", httpObj.responseText));

                if (render == true)
                    this.render_settings();
            }.bind(this)
        };

        new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Get Status
    //--------------------------------------------
    getStatus : function(render, chain) {
        var auth_data;
        var url, params, wsse_header;

        auth_data = mod_auth.getAccountInfo();
        wsse_header = wsseHeader(auth_data.account, auth_data.digest);

        url = "/service/conf/net/ocnv6/status";

        params = {
            method: "GET",
            requestHeaders: [
                'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
                'X-WSSE', wsse_header
            ],
            onFailure: function(httpObj) {
                var status = httpObj.status;

                switch (status) {
                case 401:
                    alert("Authentication failed @ getStatus. (401)");
                    load_module('auth', 'content', true);
                    break;

                default:
                    alert($jq.sprintf("Error %d.", status));
                    break;
                }
            }.bind(this),
            onSuccess: function(httpObj) {
                var status = eval("(" + httpObj.responseText + ")");
                debug($jq.sprintf("getStatus: '%s'", httpObj.responseText));

                this.data.status = status;

                if (chain == true) {
                    //debug("getStatus --> chain");
                    this.getSettings(render);
                } else if (render == true) {
                    //debug("'render' == true, call render()");
                    this.render();
                } else {
                    //debug("'render' == false, call updateStatus()");
                    mod_ocnipv6.updateStatus();
                }
            }.bind(this)
        };

        new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Set Configuration
    //--------------------------------------------
    setConfig : function() {
        var auth_data, put_data;
        var url, params, wsse_header;
        var json;

        if (this.updateFromForm() == false)
            return;

        auth_data = mod_auth.getAccountInfo();
        wsse_header = wsseHeader(auth_data.account, auth_data.digest);

        url = "/service/conf/net/ocnv6/settings";

        json = Object.toJSON(this.data.settings);
        debug($jq.sprintf("OCNv6 : setConfig(): %s", json));

        params = {
            method: "PUT",
            postBody: json,
            requestHeaders: [
                'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
                'X-WSSE', wsse_header,
                'Content-type', 'application/json'
            ],
            onFailure: function(httpObj) {
                var status = httpObj.status;

                this.hide_indicator('indicator_settings');

                switch (status) {
                case 401:
                    alert("Authentication failed @ setConfig. (401)");
                    load_module('auth', 'content', true);
                    break;

                default:
                    alert($jq.sprintf("Error %d.", status));
                    break;
                }
            }.bind(this),
            onSuccess: function(httpObj) {
                this.hide_indicator('indicator_settings');

                alert("更新しました。");
                mod_ocnipv6.getStatus(true, true);
            }.bind(this)
        };

        this.show_indicator('indicator_settings');
        new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Request (Connect)
    //--------------------------------------------
    reqConnect : function(render) {
        var auth_data;
        var url, params, wsse_header;

        auth_data = mod_auth.getAccountInfo();
        wsse_header = wsseHeader(auth_data.account, auth_data.digest);

        url = "/service/conf/net/ocnv6";

        params = {
            method: "POST",
            postBody: 'command=connect',
            requestHeaders: [
                'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
                'X-WSSE', wsse_header
            ],
            onFailure: function(httpObj) {
                var status = httpObj.status;

                this.hide_indicator('indicator_status');

                switch (status) {
                case 401:
                    alert("Authentication failed @ reqConnect. (401)");
                    load_module('auth', 'content', true);
                    break;

                default:
                    alert($jq.sprintf("Error %d.", status));
                    break;
                }
            }.bind(this),
            onSuccess: function(httpObj) {
                this.hide_indicator('indicator_status');

                if (render == true) {
                    //debug("'render' == true, call render_settings()");
                    this.render_settings();
                } else {
                    //debug("'render' == false, call getStatus()");
                    this.getStatus(false, false);
                }
            }.bind(this)
        };

        this.show_indicator('indicator_status');
        new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Request (Disconnect)
    //--------------------------------------------
    reqDisconnect : function(render) {
        var auth_data;
        var url, params, wsse_header;

        auth_data = mod_auth.getAccountInfo();
        wsse_header = wsseHeader(auth_data.account, auth_data.digest);

        url = "/service/conf/net/ocnv6";

        params = {
            method: "POST",
            postBody: 'command=disconnect',
            requestHeaders: [
                'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
                'X-WSSE', wsse_header
            ],
            onFailure: function(httpObj) {
                var status = httpObj.status;

                this.hide_indicator('indicator_status');

                switch (status) {
                case 401:
                    alert("Authentication failed @ reqDisconnect. (401)");
                    load_module('auth', 'content', true);
                    break;

                default:
                    alert($jq.sprintf("Error %d.", status));
                    break;
                }
            }.bind(this),
            onSuccess: function(httpObj) {
                this.hide_indicator('indicator_status');

                if (render == true)
                    this.render_settings();
                else
                    this.getStatus(false, false);
            }.bind(this)
        };

        this.show_indicator('indicator_status');
        new Ajax.Request(url, params);
    }
};
