//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// Ping疎通テスト
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2007-2010 Century Systems Co., Ltd.
//
// Last Modified: 2010/05/28 15:06:14 kikuchi
//==============================================================================

mod_ping = {
    //--------------------------------------------
    // HTML template (Main)
    //--------------------------------------------
    template_main : {
	    HTMLtemplate : [
	        "<h1 class='title'>Ping疎通テスト</h1>",
	        "<table id='tbl_test' class='zebra'>",
	        "<tr>",
	        "  <th id='th_sel_host'>ホスト選択</th>",
	        "  <td class='noborder'>",
	        "    <select id='sel_host' class='select' style='width:140px;'>",
	        "      <option value=-1>手入力</option>",
	        "      <:for i in hostlist:>",
	        "      <option value=${i} ",
	        "       <:if i==hostsel :>selected='selected'<:/if:> >",
	        "        <:if hostlist[i].name != '':>",
	        "         ${hostlist[i].name}",
	        "        <:/if:>",
	        "        <:else:>",
	        "         IP: ${hostlist[i].addr}",
	        "        <:/else:>",
	        "      </option>",
	        "      <:/for:>",
	        "    </select>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th id='th_ipaddr'>アドレス指定</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='txt_ipaddr' class='text' style='width:160px;'",
	        "     <:if hostsel != -1:>value='${hostlist[hostsel].address.escapeHTML()}'",
	        "      readonly='readonly'",
	        "     <:/if:>>",
	        "  </td>",
	        "  <td class='noborder'>",
	        "    <input type='button' id='btn_ping' class='button' value='実行'/>",
	        "    <img id='indicator' src='img/indicator.gif' style='visibility: hidden;' />",
	        "  </td>",
	        "</tr>",
	        "</table>",
	        "<br/><h2>ホスト設定</h2>",
	        "<table id='tbl_regist' class='zebra'>",
	        "<thead>",
	        "<tr>",
	        "  <td colspan='3' class='noborderright'>",
	        "    <input type='button' id='btn_add' value='追加' class='button' style='width:50px;' ",
	        "     onClick='mod_ping.onAddEntry()' />",
	        "    <input type='button' id='btn_update' value='設定' class='button' style='width:50px;' ",
	        "     onClick='mod_ping.onUpdateEntry()' />",
	        "  </td>",
	        "<tr>",
	        "  <th class='header'>No.</th>",
	        "  <th class='header' style='width:120px;'>IPアドレス</th>",
	        "  <th class='header' style='width:200px;'>備考</th>",
	        "</tr>",
	        "</thead>",
	        "<tbody>",
	        "<:if hostlist.length == 0:>",
	        "<tr>",
	        "  <td colspan='3' class='centering'>",
	        "    ホストが登録されておりません。",
	        "  </td>",
	        "</tr>",
	        "<:/if:>",
	        "<:else:>",
	        "<:for i in hostlist:>",
	        "<tr>",
	        "  <td class='numeric'>${i + 1}</td>",
	        "  <td>${hostlist[i].address.escapeHTML()}</td>",
	        "  <td>${hostlist[i].name.escapeHTML()}</td>",
	        "  <td class='noborder'>",
	        "    <input type='button' value='編集' class='button' style='width:50px;' ",
	        "     onClick='mod_ping.onEditEntry(${i})' />",
	        "    <input type='button' value='削除' class='button' style='width:50px;' ",
	        "     onClick='mod_ping.onEraseEntry(${i})' />",
	        "  </td>",
	        "</tr>",
	        "<:/for:>",
	        "<:/else:>",
	        "</table>"
	    ].join("\n"),
	    //------------------------------
	    // Event Handlers
	    //------------------------------
	    handlers : [
	        [
		        // <SELECT> "ホスト選択"
		        'sel_host', 'change', function() {
		            var hostsel = parseInt($('sel_host').value, 10);

		            debug($jq.sprintf("hostsel : %d", hostsel));

		            mod_ping.data.hostsel = hostsel;
		            mod_ping.data.result = '未実行';
		            mod_ping.render();
		        } ],
	        [
		        // "Ping !" button
		        'btn_ping', 'click', function() {
		            var target = $('txt_ipaddr').value.strip();
		            debug($jq.sprintf("Ping to host '%s'.", target.escapeHTML()));

		            if (mod_ping.validator.checkIPAddress(target) == false &&
			            mod_ping.validator.checkFQDN(target) == false) {
			            alert("アドレスが不正です。");
			            return;
		            }

		            mod_ping.ajax_doPing(target);
		        }]
	    ],
	    //------------------------------
	    // Tooltips
	    //------------------------------
	    tooltips : [
	        [
		        //
		        'th_sel_host', 'Note', "登録してあるホストから選択、もしくは手入力を選択してください。"
	        ],
	        [
		        //
		        'th_ipaddr', 'Note', "手入力の場合、ここにIPアドレスを入力してください。"
	        ],
	        // 			[
	        // 				//
	        // 				'btn_ping', 'Note', "Do Ping! Ping! Ping!"
	        // 				],
	        [
		        // '追加' button
		        'btn_add', 'Note', "ホストを追加します。" ],
	        [
		        // '設定' button
		        'btn_update', 'Note', $jq.sprintf("ホストリストを %s に保存します。", MA4xx_conf.kinds) ]
	    ]
    },

    // dummy data
    data : {
	    hostlist : [
	        {
		        addr : '192.168.0.2',
		        name : '留守モニタ'
	        },{
		        addr : '192.168.0.3',
		        name : '音声ユニット'
	        },{
		        addr : '192.168.0.1',
		        name : 'Broad Band Rooter'
	        } ],
	    hostsel : 1,
	    result : "未実行",

	    edit_host : {
	        addr : '',
	        name : ''
	    }
    },

    //--------------------------------------------
    // HTML template (対象ホスト Edit Dialog)
    //--------------------------------------------
    template_host : {
	    HTMLtemplate : [
	        "<center>",
	        "<h2>ホストの編集</h2><br/>",
	        "<form>",
	        "<table class='zebra'>",
	        "<tr>",
	        "  <th class='header' id='th_ipaddr2'>IPアドレス</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='host_addr' class='text' style='width:140px;' ",
	        "    <:if operation=='edit':>value='${address}'<:/if:> tabindex=1 />",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th class='header' id='th_notes'>備考</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='host_note' class='text' style='width:140px;'",
	        "    <:if operation=='edit':>value='${note}'<:/if:> tabindex=2 />",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan='2' class='noborderright'>",
	        "    <input type='button' id='btn_ok' value='適用' class='button' tabindex=3 />",
	        "    <input type='button' id='btn_cancel' value='中止' class='button' tabindex=4 />",
	        "  </td>",
	        "</tr>",
	        "</table>",
	        "</form>",
	        "</center>"
	    ].join("\n"),
	    handlers : [
	        [
		        // "OK" button handler
		        'btn_ok', 'click', function() {
		            mod_ping.onHostEditOK();
		        }],
	        [
		        // "Cancel" button handler
		        'btn_cancel', 'click', function() {
		            Windows.close('hostDialog');
		        }]
	    ],
	    tooltips : [
	        [
		        // "IPアドレス"
		        'th_ipaddr2', 'Note', "IPアドレスを指定して下さい。<br/>IPv4アドレスのみ登録可能です。"
	        ],
	        [
		        // "備考"
		        'th_notes', 'Note', "ホストの説明などに使用して下さい。"
	        ]
	    ]
    },

    //----------------------------------
    // dummy data (監視対象 Edit Dialog)
    //----------------------------------
    host_dialog_data : {
	    operation : 'new',	// 'new' or 'edit'

	    entryNo : 0,
	    address : '192.168.0.0',
	    note    : ''
    },

    //--------------------------------------------
    // Initialize
    //--------------------------------------------
    init : function(elem) {
	    var auth_data;
	    this.elem = elem;

	    // Auth check
	    auth_data = mod_auth.getAccountInfo();
	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);

	        return;
	    }

	    // Validator
	    if (!this.validator)
	        this.validator = new validateUtil();

	    this.ajax_getHostList();
	    //		this.render();
    },

    //--------------------------------------------
    // Render HTML (Main)
    //--------------------------------------------
    render : function() {
	    var html, parser, template;

	    template = this.template_main;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template, true);
    },

    //================================================================
    //
    // Event Handlers
    //
    //================================================================

    //--------------------------------------------
    // Add Entry
    //--------------------------------------------
    onAddEntry : function() {
	    var dialog_data;

	    debug("add_host() clicked.");

	    dialog_data = this.host_dialog_data;

	    dialog_data.operation = 'new';
	    dialog_data.entryNo   = this.data.hostlist.length;
	    dialog_data.address   = '';
	    dialog_data.note      = '';

	    this.showHostEditDialog();
    },

    //--------------------------------------------
    // Edit Entry
    //--------------------------------------------
    onEditEntry : function(no) {
	    var dialog_data;

	    debug($jq.sprintf("edit_host(%d) clicked.", no + 1));

	    dialog_data = this.host_dialog_data;

	    dialog_data.operation = 'edit';
	    dialog_data.entryNo   = no;
	    dialog_data.address   = this.data.hostlist[no].address;
	    dialog_data.note      = this.data.hostlist[no].name;

	    this.showHostEditDialog();
    },

    //--------------------------------------------
    // Edit host dialog
    //--------------------------------------------
    showHostEditDialog : function() {
	    var win, param, parser, template, html;

	    param = {
	        className   : 'alphacube',
	        title       : 'Ping 対象ホストの編集',
	        width       : 300,
	        height      : 150,
	        resizable   : false,
	        draggable   : true,
	        closable    : true,
	        minimizable : false,
	        maximizable : false,
	        showEffect  : Element.show,
	        hideEffect  : Element.hide,

	        destroyOnClose: true
	    };

	    win = new Window('hostDialog', param);

	    template = this.template_host;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.host_dialog_data);

	    win.getContent().innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template, false);

	    win.showCenter(true);	// Modal window
    },

    //--------------------------------------------
    // Add/Edit 'OK' clicked
    //--------------------------------------------
    onHostEditOK : function() {
	    var addr, note, newHost, operation;

	    // Form validation
	    if (this.validate_dialog() == false)
	        return false;

	    operation = this.host_dialog_data.operation;

	    addr = strip_escapeHTML($('host_addr').value);
	    note = strip_escapeHTML($('host_note').value);

	    // when no note, use addr instead.
	    if (note == "")
	        note = $jq.sprintf("IP: %s", addr);

	    newHost = {
	        address : addr,
	        name    : note
	    };

	    if (operation == 'new')
	        // New
	        this.data.hostlist = this.data.hostlist.insertByIndex(
		        this.host_dialog_data.entryNo, Object.clone(newHost));
	    else
	        // Edit
	        this.data.hostlist = this.data.hostlist.replaceByIndex(
		        this.host_dialog_data.entryNo, Object.clone(newHost));

	    Windows.close('hostDialog');

	    this.render();
    },
    
    //--------------------------------------------
    // Erase Entry
    //--------------------------------------------
    onEraseEntry : function(no) {
	    var params, msg;

	    debug($jq.sprintf("delete_host(%d) clicked.", no + 1));

	    params = {
	        className : "alphacube",
	        width: 300,
	        showEffect     : Element.show,
	        hideEffect     : Element.hide,

	        onOk : function() {
		        debug("Confirm: OK");
		        this.data.hostlist = this.data.hostlist.removeByIndex(no);

		        debug($jq.sprintf("hostlist.len = %d", this.data.hostlist.length));

		        // "ホスト選択" init
		        this.data.hostsel = -1;
		        this.render();

		        return true;
	        }.bind(this),
	        onCancel : function() {
		        debug("Confirm: Cancel");

		        return true;
	        }
	    };

	    msg = "No." + (no + 1) + " のホストを<br/>リストから外してよろしいですか ?"
	    Dialog.confirm(msg, params);
    },

    //--------------------------------------------
    // Update Entry
    //--------------------------------------------
    onUpdateEntry : function() {
	    debug("ping: onUpdateEntry()");

	    this.ajax_updateEntry();
    },

    //--------------------------------------------
    // Form validation
    //--------------------------------------------
    validate_dialog : function() {
	    var ipaddr;

	    ipaddr = strip_escapeHTML($('host_addr').value);

	    if (this.validator.checkIPAddress(ipaddr) == false) {
	        alert("・IPアドレスが不正です");
	        return false;
	    }

	    return true;
    },

    //================================================================
    //
    // Ajax Functions
    //
    //================================================================

    //--------------------------------------------
    // Get Entry
    //--------------------------------------------
    ajax_getHostList : function() {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/admin/ping";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ ajax_getHostList. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var res = eval('(' + httpObj.responseText + ')');

		        debug($jq.sprintf("getHostList() --> %s", httpObj.responseText));

		        if (res.result.length > 0) {
		            this.data.hostlist = res.result;
		            this.data.hostsel  = 0;
		        } else {
		            this.data.hostlist = new Array;
		            this.data.hostsel  = -1;
		        }

		        mod_ping.render();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Update Entry
    //--------------------------------------------
    ajax_updateEntry : function() {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/admin/ping";

	    json = Object.toJSON({hostlist : this.data.hostlist});
	    debug($jq.sprintf("Ping : ajax_updateEntry(): %s", json));

	    params = {
	        method: "PUT",
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ ajax_updateEntry. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        alert("更新しました。");
	        }
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // do Ping!
    //--------------------------------------------
    ajax_doPing : function(addr) {
	    var auth_data, post_data;
	    var url, params, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/admin/ping";

	    params = {
	        method: "POST",
	        postBody: 'addr=' + addr,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        this.hideIndicator();

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ ajax_doPing. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", httpObj.status));
		            this.render();
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var res = eval('(' + httpObj.responseText + ')')
		        debug(httpObj.responseText);

		        this.hideIndicator();

		        this.showResult(res.message);
	        }.bind(this)
	    };

	    // Ping実行待ち ...
	    this.showIndicator();

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // show Ping Result Window
    //--------------------------------------------
    showResult : function(res) {
	    var win, dialog_params, html, i;

	    dialog_params = {
	        className : "alphacube",
	        title     : "Ping 実行結果",
	        closable  : true,
	        draggable : true,
	        width     : 440,
	        //			height    : 250,
	        okLabel   : "OK",
	        showEffect: Element.show,
	        hideEffect: Element.hide
	    };

	    html = "<p align='left'>";

	    for (i = 0; i < res.length; i++)
	        html += res[i] + '<br/>';

	    html += "</p>";

	    Dialog.alert(html, dialog_params);
    },

    //--------------------------------------------
    // show / hide indicator
    //--------------------------------------------
    showIndicator : function() {
	    $('indicator').style.visibility = 'visible';
    },

    hideIndicator : function() {
	    $('indicator').style.visibility = 'hidden';
    }
};
