//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// PPP(発信) 設定
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2008-2010 Century Systems Co., Ltd.
//
// Last Modified: 2012/12/10 12:01:34 kikuchi
//==============================================================================

mod_ppp_out = {
    //--------------------------------------------
    // HTML template (Main)
    //--------------------------------------------
    template_main : {
	    HTMLtemplate : [
	        "<h1 class='title'>PPP(発信)設定</h1>",
	        "<h3>編集されるファイル&nbsp;<img src='img/ark_help.png' id='help_file' /></h3><br/>",

	        "<h3>利用可能デバイス一覧</h3><br/>",
	        "<table id='tbl_devices' class='zebra'>",
	        " <tr>",
	        "  <td colspan='4' class='noborderright'>",
	        "   <img id='indicator_devices' src='img/indicator.gif' ",
	        "    style='visibility: hidden;' />",
	        "   <input id='btn_reload_device' type='button' class='button'",
	        "    style='width:50px;' value='更新' />",
	        "  </td>",
	        " </tr>",
	        " <tr>",
	        "  <th class='header'>名称</th>",
	        "  <th class='header'>デバイス</th>",
	        "  <th class='header'>種別</th>",
	        "  <th class='header'>着信可否</th>",
	        " </tr>",
	        "<:for idx in available_devices:>",
	        " <%var dev=available_devices[idx]; %>",
	        " <tr>",
	        "  <td>${dev.devname}</td>",
	        "  <td>${dev.device}</td>",
	        "  <td>",
	        "   <:if dev.modem==true:>",
	        "    モデム",
	        "   <:/if:>",
	        "   <:else:>",
	        "    PPPoE",
	        "   <:/else:>",
	        "  </td>",
	        "  <td class='centering'>",
	        "   <:if dev.dialin==true:>",
	        "    可",
	        "   <:/if:>",
	        "   <:else:>",
	        "    不可",
	        "   <:/else:>",
	        "  </td>",
	        " </tr>",
	        "<:/for:>",
	        "</table><br/>",

	        "<h3>",
	        " PPP設定/状態 &nbsp;",
	        "</h3><br/>",
	        "<table id='ppp_stat' class='zebra'>",

	        "<tr>",
	        " <td colspan='7' class='noborderright'>",
	        "  <img id='indicator_settings' src='img/indicator.gif' ",
	        "   style='visibility: hidden;' />",
	        "  <input id='btn_add' type='button' class='button'",
	        "   style='width:50px;' value='追加' />",
	        "  <input id='btn_reload' type='button' class='button'",
	        "   style='width:50px;' value='更新' />",
	        " </td>",
	        "</tr>",

	        "<tr>",
	        " <th class='header'>No.</th>",
	        " <th class='header'>接続名称</th>",
	        " <th class='header'>デバイス</th>",
	        " <th class='header'>接続状態</th>",
	        " <th class='header'>Local IP</th>",
	        " <th class='header'>Remote IP</th>",
	        " <th class='header'>制御</th>",
	        "</tr>",

	        "<:if ppp_status.length==0:>",
	        "<tr>",
	        " <td class='centering' colspan='7'>",
	        "  PPP(発信) は登録されておりません。",
	        " </td>",
	        "</tr>",
	        "<:/if:>",

	        "<:else:>",
	        "<:for idx in ppp_status:>",

	        "<%var pppconf=ppp_status[idx]; %>",

	        "<tr>",
	        " <td class='numeric'>${pppconf.unit}</td>",
	        " <td>${pppconf.conn_name}</td>",
	        " <td>${pppconf.dev_name}</td>",
	        " <td>${pppconf.status.string}</td>",
	        " <td class='centering'>",
	        "  <:if pppconf.status.address.local:>${pppconf.status.address.local}<:/if:>",
	        "  <:else:>---<:/else:>",
	        " </td>",
	        " <td class='centering'>",
	        "  <:if pppconf.status.address.peer:>${pppconf.status.address.peer}<:/if:>",
	        "  <:else:>---<:/else:>",
	        " </td>",
	        " <td class='centering'>",
	        "  <:if pppconf.status.value=='2' || pppconf.status.value=='4':>",
	        "   <input type='button' value='接続' class='button' style='width:50px;' ",
	        "    onClick='mod_ppp_out.onStartConn(${pppconf.unit})' />",
	        "  <:/if:>",
	        "  <:if pppconf.status.value=='4' || pppconf.status.value=='6':>",
	        "   <input type='button' value='切断' class='button' style='width:50px;' ",
	        "    onClick='mod_ppp_out.onStopConn(${pppconf.unit})' />",
	        "  <:/if:>",
	        "  <:if pppconf.status.value=='1' || pppconf.status.value=='3' || pppconf.status.value=='7':>",
	        "   <input type='button' value='停止' class='button' style='width:50px;' ",
	        "    onClick='mod_ppp_out.onStopConn(${pppconf.unit})' />",
	        "  <:/if:>",
	        "  <:if pppconf.status.value=='0' || pppconf.status.value=='5':>",
	        "   制御不可",
	        "  <:/if:>",
	        " </td>",
	        " <td class='noborder'>",
 	        "  <input type='button' id='btn_edit_${idx}' value='編集' class='button' style='width:50px;' ",
 	        "   <:if pppconf.status.value=='0' || pppconf.status.value=='2' || pppconf.status.value=='5':>",
 	        "    onClick='mod_ppp_out.onEditPPP(${idx})'",
 	        "   <:/if:>",
 	        "   <:else:>disabled='disabled'<:/else:>>",
	        "  </input>",
 	        "  <input type='button' id='btn_del_${idx}' value='削除' class='button' style='width:50px;' ",
 	        "   <:if pppconf.status.value=='0' || pppconf.status.value=='2' || pppconf.status.value=='5':>",
 	        "    onClick='mod_ppp_out.onDeletePPP(${idx})'",
 	        "   <:/if:>",
 	        "   <:else:>disabled='disabled'<:/else:>>",
	        "  </input>",
 	        " </td>",
	        "</tr>",

	        "<:/for:>",
	        "<:/else:>",

	        "</table>"
	    ].join(''),

	    //------------------------------
	    // Event Handlers
	    //------------------------------
	    handlers : [
	        [
		        // update available devices
		        'btn_reload_device', 'click', function() {
		            mod_ppp_out.GET_Available_devices(true);
		        }],
	        [
		        // add PPP
		        'btn_add', 'click', function() {
		            mod_ppp_out.onEditPPP(-1);
		        }],
	        [
		        // reload PPP
		        'btn_reload', 'click', function() {
		            mod_ppp_out.GET_PPP_status();
		        }]
	    ],
	    //------------------------------
	    // Tooltips
	    //------------------------------
	    tooltips : [
	        [
		        // --- 編集されるファイル ---
		        'help_file', 'Note', [ "下記のファイルが編集対象です。<br/>",
				                       "/etc/ppp/peers/ppp?<br/>",
				                       "/etc/ppp/chatscripts/ppp?<br/>",
				                       "/etc/ppp/chap-secrets<br/>",
				                       "/etc/ppp/pap-secrets" ].join('\n')
	        ]
	    ]
    },

    //----------------------------------
    // dummy data (Main)
    //----------------------------------
    data : {
	    available_devices : {},
	    ppp_status : {},

	    ppp_conf : {},

	    dial_type : {
	        0 : 'パルス',
	        1 : 'トーン'
	    },

	    pdp_type : {
	        0 : 'PPP',
	        1 : 'IP'
	    }
    },

    //--------------------------------------------
    // Initialize
    //--------------------------------------------
    init: function(elem) {
	    var auth_data;
	    this.elem = elem;

	    // Auth check
	    auth_data = mod_auth.getAccountInfo();
	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);

	        return;
	    }

	    this.elem.module = this;

	    // Initial data
	    this.GET_Available_devices(true);
	    //this.GET_PPP_status();
    },

    //--------------------------------------------
    // Render HTML (Main)
    //--------------------------------------------
    render: function() {
	    var html, parser, template;

	    template = this.template_main;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template);
    },

    //--------------------------------------------
    // HTML template (add/edit PPP)
    //--------------------------------------------
    template_PPP : {
	    HTMLtemplate : [
	        "<center>",
	        "<h2>PPP設定</h2><br/>",
	        "<form>",
	        "<table class='zebra'>",

	        "<tr>",
	        "<td class='noborder' valign='top'>",

	        "<fieldset><legend>接続名称</legend>",
	        "<table class='zebra'>",
	        "<tr>",
	        " <th class='header' style='width:100px;' >PPP No.</th>",
	        " <td class='noborder'>",
	        "  <input type='text' class='text' style='width:140px;' readonly='readonly'",
	        "   value='${ppp_conf.unit}' />",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header' style='width:100px;' >デバイス</th>",
	        " <:if ppp_conf.action=='add':>",
	        "  <td class='noborder'>",
	        "   <select name='sel_device' id='sel_device' class='select'",
	        "    style='width:180px;' onChange='mod_ppp_out.onChangeDevice()' />",
	        "   <:for idx in available_devices:>",
	        "    <option value=${idx}",
	        "     <:if ppp_conf.dev_idx==idx:>selected='selected'<:/if:>>${available_devices[idx].devname}",
	        "    </option>",
	        "   <:/for:>",
	        "  </td>",
	        " <:/if:>",
	        " <:else:>",
	        "  <td class='noborder'>",
	        "   <input type='text' class='text' style='width:140px;' readonly='readonly'",
	        "    value='${ppp_conf.dev_name}' />",
	        "  </td>",
	        " <:/else:>",
	        "</tr>",
	        "<tr>",
	        " <th class='header' style='width:100px;' >接続名称</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_conn_name' class='text' style='width:140px;'",
	        "   tabindex='1' value='${ppp_conf.conn_name}' />",
	        " </td>",
	        "</tr>",
	        "</table>",
	        "</fieldset>",
	        "<br/>",

	        "<fieldset><legend>モデム系設定</legend>",
	        "<table class='zebra'>",
	        "<tr>",
	        " <th class='header' id='th_conn_type'>接続方式</th>",
	        " <td class='noborder'>",
	        "  <select name='sel_conn_type' id='sel_conn_type' class='select'",
	        "   tabindex='2' style='width:100px;'",
	        "    <:if ppp_conf.is_modem==false:>disabled='disabled'<:/if:>",
	        "   />",
	        "   <option value=0",
	        "    <:if ppp_conf.conn_type==0:>selected<:/if:>>通常",
	        "   </option>",
	        "   <:if ppp_conf.no_persist==false:>",
	        "    <option value=1",
	        "     <:if ppp_conf.conn_type==1:>selected<:/if:>>PERSIST",
	        "    </option>",
	        "   <:/if:>",
	        "   <option value=2",
	        "    <:if ppp_conf.conn_type==2:>selected<:/if:>>DEMAND",
	        "   </option>",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header' id='th_dialtype'>ダイアルタイプ</th>",
	        " <td class='noborder'>",
	        "  <select name='sel_dialtype' id='sel_dialtype' class='select'",
	        "   tabindex='3' style='width:100pdx;'",
	        "    <:if ppp_conf.is_modem==false || ppp_conf.pulseok==false:>",
	        "     disabled='disabled'",
	        "     <%ppp_conf.tone = true; %>",
	        "    <:/if:> />",
	        "   <:for idx in dial_type:>",
	        "    <option value='${idx}'",
	        "     <:if ppp_conf.tone==idx:>",
	        "      selected='selected'",
	        "     <:/if:>>${dial_type[idx]}",
	        "    </option>",
	        "   <:/for:>",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header' id='th_idletime'>アイドル検知時間 [秒]</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_idletime' class='text' style='width:60px;'",
	        "   tabindex='4' value='${ppp_conf.idle_time}'",
	        "   <:if ppp_conf.is_modem==false:>disabled='disabled'<:/if:> />",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header' id='th_modeminit'>モデム初期化コマンド</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_modeminit' class='text' style='width:120px;'",
	        "   tabindex='5' value='${ppp_conf.modeminit.escapeHTML()}'",
	        "   <:if ppp_conf.is_modem==false:>disabled='disabled'<:/if:> />",
	        " </td>",
	        "</tr>",
	        "<tr id='tr_phonenumber' ",
	        " <:if ppp_conf.need_apn == true:>style='display: none;'<:/if:>>",
	        " <th class='header' id='th_phonenumber'>電話番号</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_phonenumber' class='text' style='width:120px;'",
	        "   tabindex='6' value='${ppp_conf.phone_number.escapeHTML()}'",
	        "   <:if ppp_conf.is_modem==false || ppp_conf.need_apn==true:>",
	        "    disabled='disabled'<:/if:> />",
	        " </td>",
	        "</tr>",
	        "<tr id='tr_apn' ",
	        " <:if ppp_conf.need_apn == false:>style='display: none;'<:/if:>>",
	        " <th class='header' id='th_apn'>APN</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_apn' class='text' style='width:120px;'",
	        "   <:if ppp_conf.need_apn==false:>disabled<:/if:>",
	        "   tabindex='7' value='${ppp_conf.apn.escapeHTML()}'/>",
	        " </td>",
	        "</tr>",

	        "<tr id='tr_pdptype' ",
	        " <:if ppp_conf.need_apn == false:>style='display: none;'<:/if:>>",
	        " <th class='header' id='th_pdptype'>PDPTYPE</th>",
	        " <td class='noborder'>",
	        "  <select name='sel_pdptype' id='sel_pdptype' class='select'",
	        "   tabindex='8' style='width:100pdx;'",
	        "   <:if ppp_conf.need_apn==false:>disabled<:/if:> />",
	        "   <:for idx in pdp_type:>",
	        "    <option value='${idx}'",
	        "     <:if ppp_conf.pdptype==idx:>",
	        "      selected='selected'",
	        "     <:/if:>>${pdp_type[idx]}",
	        "    </option>",
	        "   <:/for:>",

	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header'>Deflate圧縮</th>",
	        " <td class='noborder'>",
	        "  <ul style='list-style-type: none;'>",
	        "   <li>",
	        "    <label for='chk_deflatecomp'>",
	        "     <input type='checkbox' id='chk_deflatecomp' tabindex='9'",
	        "      <:if ppp_conf.deflatecomp==true:>checked='checked'<:/if:>",
	        "      <:if ppp_conf.is_modem==false:>disabled='disabled'<:/if:>",
	        "      />&nbsp;使用する<br/>",
	        "    </label>",
	        "   </li>",
	        "  </ul>",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header'>VJ圧縮</th>",
	        " <td class='noborder'>",
	        "  <ul style='list-style-type: none;'>",
	        "   <li>",
	        "    <label for='chk_vjcomp'>",
	        "     <input type='checkbox' id='chk_vjcomp' tabindex='10'",
	        "      <:if ppp_conf.vjcomp==true:>checked='checked'<:/if:>",
	        "      <:if ppp_conf.is_modem==false:>disabled='disabled'<:/if:>",
	        "      />&nbsp;使用する<br/>",
	        "    </label>",
	        "   </li>",
	        "  </ul>",
	        " </td>",
	        "</tr>",
	        "</table>",
	        "</fieldset><br/>",

	        "<fieldset>",
	        "<legend>LCP ECHOによる接続確認</legend>",
	        "<table class='zebra'>",
	        "<tr>",
	        " <th class='header'>接続確認</th>",
	        " <td class='noborder'>",
	        "  <ul style='list-style-type: none;'>",
	        "   <li>",
	        "    <label for='chk_lcp_check'>",
	        "     <input type='checkbox' id='chk_lcp_check' tabindex='11'",
	        "      <:if ppp_conf.force_lcp_check==true:>disabled<:/if:>",
	        "      <:if ppp_conf.lcp_check==true:>checked='checked'<:/if:>",
	        "      />&nbsp;使用する<br/>",
	        "    </label>",
	        "   </li>",
	        "  </ul>",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header'>送信間隔 [秒]</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_lcp_interval' class='text' style='width:120px;'",
	        "   tabindex='12' value='${ppp_conf.lcp_interval}' />",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        "<tr>",
	        " <th class='header'>切断判定回数</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_lcp_failure' class='text' style='width:120px;'",
	        "   tabindex='13' value='${ppp_conf.lcp_failure}' />",
	        " </td>",
	        "</tr>",
	        "</table>",
	        "</fieldset>",

	        "</td>",

	        // Right
	        "<td class='noborder' style='vertical-align: top;'>",

	        "<fieldset>",
	        "<legend>一般設定</legend>",
	        "<table class='zebra'>",
	        "<tr>",
	        " <th class='header'>DNSサーバ</th>",
	        " <td class='noborder'>",
	        "  <ul style='list-style-type: none;'>",
	        "   <li>",
	        "    <label for='chk_usepeerdns'>",
	        "     <input type='checkbox' id='chk_usepeerdns' tabindex='14'",
	        "      <:if ppp_conf.usepeerdns==true:>checked='checked'<:/if:>",
	        "      />&nbsp;取得する<br/>",
	        "    </label>",
	        "   </li>",
	        "  </ul>",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header'>デフォルトルート</th>",
	        " <td class='noborder'>",
	        "  <ul style='list-style-type: none;'>",
	        "   <li>",
	        "    <label for='chk_defaultroute'>",
	        "     <input type='checkbox' id='chk_defaultroute' tabindex='15'",
	        "      <:if ppp_conf.defaultroute==true:>checked='checked'<:/if:>",
	        "      />&nbsp;設定する<br/>",
	        "    </label>",
	        "   </li>",
	        "  </ul>",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header' id='th_ip_local'>ローカルIP</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_ip_local' class='text' style='width:120px;'",
	        "   tabindex='16' value='${ppp_conf.ip_local}' />",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header' id='th_ip_remote'>リモートIP</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_ip_remote' class='text' style='width:120px;'",
	        "   tabindex='17' value='${ppp_conf.ip_remote}' />",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header' id='th_netmask'>サブネットマスク</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_netmask' class='text' style='width:120px;'",
	        "   tabindex='18' value='${ppp_conf.ip_netmask}'/>",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header' id='th_mtu'>MTU</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_mtu' class='text' style='width:120px;'",
	        "   tabindex='19' value='${ppp_conf.mtu}' />",
	        " </td>",
	        "</tr>",
	        "</table>",
	        "</fieldset><br/>",

	        "<fieldset>",
	        "<legend>アカウント設定</legend>",
	        "<table class='zebra'>",
	        "<tr>",
	        " <th class='header' id='th_useaccount'>自己証明</th>",
	        " <td class='noborder'>",
	        "  <ul style='list-style-type: none;'>",
	        "   <li>",
	        "    <label for='chk_useaccount'>",
	        "     <input type='checkbox' id='chk_useaccount' tabindex='20'",
	        "      <:if ppp_conf.useaccount==true:>checked<:/if:> ",
	        "     />&nbsp;証明する<br/>",
	        "    </label>",
	        "   </li>",
	        "  </ul>",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header' id='th_account'>アカウント</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_account' class='text' style='width:120px;'",
	        "   tabindex='21' value='${ppp_conf.account}' />",
	        " </td>",
	        "</tr>",
	        //			"<tr>",
	        //			" <th class='header' id='th_domain'>ドメイン</th>",
	        //			" <td class='noborder'>",
	        //			"  <input type='text' id='txt_domain' class='text' style='width:120px;'",
	        //			"   tabindex='22' value='${ppp_conf.domain}' />",
	        //			" </td>",
	        //			"</tr>",
	        //			"<tr>",
	        //			" <th class='header' id='th_acname'>AC名</th>",
	        //			" <td class='noborder'>",
	        //			"  <input type='text' id='txt_acname' class='text' style='width:120px;'",
	        //			"   tabindex='23' value='${ppp_conf.acname}' />",
	        //			" </td>",
	        //			"</tr>",
	        //			"<tr>",
	        //			" <th class='header'>サービス名</th>",
	        //			" <td class='noborder'>",
	        //			"  <input type='text' id='txt_servicename' class='text' style='width:120px;'",
	        //			"   tabindex='24' value='${ppp_conf.servicename}' />",
	        //			" </td>",
	        //			"</tr>",
	        "<tr>",
	        " <th class='header' id='th_password'>パスワード</th>",
	        " <td class='noborder'>",
	        "  <input type='password' id='txt_password' class='text' style='width:120px;'",
	        "   tabindex='25' value='${ppp_conf.password}' />",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header' id='th_password2'>パスワード (確認)</th>",
	        " <td class='noborder'>",
	        "  <input type='password' id='txt_password_confirm' class='text' style='width:120px;'",
	        "   tabindex='26' value='${ppp_conf.password}' />",
	        " </td>",
	        "</tr>",
	        "</table>",
	        "</fieldset>",
	        "<br/>",

	        "<fieldset id='cipl_setting' ",
	        "	<:if ppp_conf.cipl_usable == false:>style='display: none;'<:/if:>>",
	        "<legend>CIPL設定</legend>",
	        "<table class='zebra'>",
	        "<tr>",
	        " <th class='header' id='th_useaccount'>SMS受信</th>",
	        " <td class='noborder'>",
	        "  <ul style='list-style-type: none;'>",
	        "   <li>",
	        "    <label for='chk_cipl_sms'>",
	        "     <input type='checkbox' id='chk_cipl_sms' tabindex='27'",
	        "      <:if ppp_conf.cipl_sms == true:>checked<:/if:> ",
	        "     />&nbsp;SMSを受信したらPPP接続を行う。<br/>",
	        "    </label>",
	        "   </li>",
	        "  </ul>",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header' id='th_cipl_domain'>ドメイン名</th>",
	        " <td class='noborder'>",
	        "  <input type='text' id='txt_cipl_domain' class='text' style='width:120px;'",
	        "   tabindex='28' value='${ppp_conf.cipl_domain}' />",
	        " </td>",
	        "</tr>",
	        "</table>",
	        "</fieldset>",

	        "</td>",
	        "</tr>",

	        "<tr>",
	        "<td colspan=2 class='noborderright'>",
	        " <input type='button' id='bt_ok' value='OK' tabindex='29' class='button' />",
	        " <input type='button' id='bt_cancel' value='Cancel' tabindex='30' class='button' />",
	        "</td>",
	        "</tr>",

	        "</table>",
	        "</form>",
	        "</center>"
	    ].join(''),
	    //------------------------------
	    // Event Handler
	    //------------------------------
	    handlers : [
	        [
		        // "OK" button handler
		        'bt_ok', 'click', function() {
		            $(mod_ppp_out.data.ppp_conf.btn_id).disabled = false;
		            mod_ppp_out.onPPPEditOK();
		        }],
	        [
		        // "Cancel" button handler
		        'bt_cancel', 'click', function() {
		            $(mod_ppp_out.data.ppp_conf.btn_id).disabled = false;
		            Windows.close('pppDialog');
		        }]
	    ],
	    //------------------------------
	    // Tooltip
	    //------------------------------
	    tooltips : [
	        [
		        // 接続方式
		        'th_conn_type', 'Note', ["通常: 切断後、再接続しません。<br/>",
					                     "PERSIST: 相手から切断されると、<br/>",
					                     "再接続を行います。<br/>",
					                     "DEMAND: 通信が発生した際に<br/>",
					                     "接続を開始します。"].join('\n')
	        ],
	        [
		        // 'ローカルIP'
		        'th_ip_local', 'Note', ["自IPを設定します。<br/>",
					                    "自分から指定しない場合、<br/>",
					                    "'0.0.0.0' に設定して下さい。"].join('\n')
	        ],
	        [
		        // 'リモートIP'
		        'th_ip_remote', 'Note', ["相手IPを設定します。<br/>",
					                     "自分から指定しない場合、<br/>",
					                     "'0.0.0.0' に設定して下さい。"].join('\n')
	        ],
	        [
		        // 'MTU'
		        'th_mtu', 'Note', ["リンクの MTU を設定します。<br/>",
				                   "NTT の Flet's をご使用の場合、<br/>",
				                   "1454 に設定して下さい。"].join('\n')
	        ]
	    ]
    },

    //================================================================
    //
    // Ajax Functions
    //
    //================================================================

    //--------------------------------------------
    // GET PPP available devices
    //--------------------------------------------
    GET_Available_devices : function(chain) {
	    var auth_data;
	    var url, params, configs, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/ppp/callout/devices";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @GET_Available_devices (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("GET_Available_devices: %s", httpObj.responseText));

		        result = eval("(" + httpObj.responseText + ")");
		        this.data.available_devices = result['devices'];

		        if (chain == true)
		            this.GET_PPP_status();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // GET PPP settings
    //--------------------------------------------
    GET_PPP_status : function() {
	    var auth_data;
	    var url, params, configs, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/ppp/callout/status";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @GET_PPP_status (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("GET_PPP_status: %s", httpObj.responseText));
		        result = eval("(" + httpObj.responseText + ")");
		        this.data.ppp_status = result['status'];

		        this.render();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Update PPP settings
    //--------------------------------------------
    ajax_updatePPP : function(newPPP) {
	    var auth_data;
	    var url, params, configs, wsse_header;
	    var method, json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    if (newPPP.action == 'add') {
	        method = 'POST';
	        url = "/service/conf/net/ppp/callout/conf";
	    } else if (newPPP.action == 'edit') {
	        method = 'PUT';
	        url = $jq.sprintf("/service/conf/net/ppp/callout/conf/ppp%d",
			              newPPP.unit);
	    } else {
	        alert("ajax_updatePPP: action error.")
	        return;
	    }

	    json = Object.toJSON(newPPP);
	    debug($jq.sprintf("json: '%s'", json));

	    params = {
	        method: method,
	        contentType: 'application/json',
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        this.hide_indicator('indicator_settings');

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ajax_updatePPP (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        this.hide_indicator('indicator_settings');

		        debug($jq.sprintf("ajax_updatePPP: %s", httpObj.responseText));

		        // reload
		        this.GET_PPP_status();
	        }.bind(this)
	    };

	    this.show_indicator('indicator_settings');
	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Delete PPP settings
    //--------------------------------------------
    ajax_deletePPP : function(unit) {
	    var auth_data;
	    var url, params, configs, wsse_header;
	    var method, json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = $jq.sprintf("/service/conf/net/ppp/callout/conf/ppp%d", unit);

	    params = {
	        method: "DELETE",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        this.hide_indicator('indicator_settings');

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ajax_deletePPP (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        this.hide_indicator('indicator_settings');

		        debug($jq.sprintf("ajax_deletePPP: %s", httpObj.responseText));

		        // reload
		        this.GET_PPP_status();
	        }.bind(this)
	    };

	    this.show_indicator('indicator_settings');
	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Send PPP command (connect, disconnect, ...)
    //--------------------------------------------
    ajax_sendPPPCommand : function(unit, command) {
	    var auth_data;
	    var url, params, configs, wsse_header;
	    var method, json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = $jq.sprintf("/service/conf/net/ppp/callout/conf/ppp%d", unit);

	    params = {
	        method: 'POST',
	        postBody: $jq.sprintf('command=%s', command),
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        this.hide_indicator('indicator_settings');

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ajax_sendPPPCommand (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        this.hide_indicator('indicator_settings');
		        debug($jq.sprintf("ajax_sendPPPCommand: %s", httpObj.responseText));

		        result = eval("(" + httpObj.responseText + ")");
		        alert(result.msg);

		        // reload
		        this.GET_PPP_status();
	        }.bind(this)
	    };

	    this.show_indicator('indicator_settings');
	    new Ajax.Request(url, params);
    },

    //================================================================
    //
    // Utility functions
    //
    //================================================================

    // AJAX 処理開始
    show_indicator : function(elem) {
	    $(elem).style.visibility = 'visible';
    },

    // AJAX 処理完了
    hide_indicator : function(elem) {
	    $(elem).style.visibility = 'hidden';
    },

    //================================================================
    //
    // Event Handlers
    //
    //================================================================

    //--------------------------------------------
    // start PPP connection
    //--------------------------------------------
    onStartConn : function(unit) {
	    this.ajax_sendPPPCommand(unit, 'start');
    },

    //--------------------------------------------
    // stop PPP connection
    //--------------------------------------------
    onStopConn : function(unit) {
	    this.ajax_sendPPPCommand(unit, 'stop');
    },

    //--------------------------------------------
    // add/edit PPP configuration
    //--------------------------------------------
    onEditPPP : function(idx) {
	    var win, param, parser, template, html;
	    var ppp_conf, btn_id;

	    if (idx == -1)
	        btn_id = 'btn_add';
	    else
	        btn_id = $jq.sprintf('btn_edit_%d', idx);

	    $(btn_id).disabled = true;

	    param = {
	        className : "alphacube",
	        title     : "PPP(発信) 設定編集",
	        width     : 640,
	        height    : 550,
	        resizable : false,
	        closable    : true,
	        minimizable : false,
	        maximizable : false,
	        showEffect  : Element.show,
	        hideEffect  : Element.hide,

	        destroyOnClose : true
	    };

	    if (idx == -1) {
	        // add entry
	        var units, i, new_unit, total_len;

	        units = new Array;
	        new_unit = -1;

	        total_len = mod_ppp_out.data.ppp_status.length;

	        if (total_len >= 50) {
		        alert("PPPは50個までしか設定できません。");
		        $(btn_id).disabled = false;
		        return;
	        }

	        for (i = 0; i < total_len; i++)
		        units.push(mod_ppp_out.data.ppp_status[i].unit);

	        // 空きPPP unit検索
	        for (i = 0; i < 50; i++) {
		        if (units.indexOf(i) == -1) {
		            new_unit = i;
		            break;
		        }
	        }

	        if (new_unit == -1) {
		        alert("PPP設定に空きがありません。");
		        $(btn_id).disabled = false;
		        return;
	        }

	        var initialDevice = mod_ppp_out.data.available_devices[2];

	        mod_ppp_out.data.ppp_conf = {
		        'action'       : 'add',
		        'unit'         : new_unit,
		        'name'         : $jq.sprintf("ppp%d", new_unit),
		        'dev_idx'      : 2,
		        'dev_node'     : initialDevice.device,
		        'need_apn'     : initialDevice.need_apn,
		        'force_lcp_check' : initialDevice.force_lcp_check,
		        'no_persist'   : initialDevice.no_persist,
		        'conn_name'    : '',
		        'tone'         : true,
		        'usepeerdns'   : true,
		        'idle_time'    : 0,
		        'lcp_failure'  : 3,
		        'defaultroute' : false,
		        'lcp_interval' : 30,
		        'ip_remote'    : '0.0.0.0',
		        'ip_local'     : '0.0.0.0',
		        'ip_netmask'   : '0.0.0.0',
		        'conn_type'    : 1,
		        'modeminit'    : 'AT&FS0=0',
		        'phone_number' : '',
		        'apn'          : '',
                'pdptype'      : 0,	// PPP
		        'lcp_check'    : true,
		        'deflatecomp'  : true,
		        'useaccount'   : true,
		        'password'     : '',
		        'account'      : '',
		        'mtu'          : 1500,
		        'vjcomp'       : true,
		        'zone'         : 'net',
		        'is_pppoe'     : false,
		        'cipl_usable'  : (initialDevice.type == 2),
		        'cipl_sms'     : false,
		        'cipl_domain'  : false,
		        'btn_id'       : btn_id
	        };
	    } else {
	        // edit entry
	        mod_ppp_out.data.ppp_conf = Object.clone(this.data.ppp_status[idx]);
	        ppp_conf = mod_ppp_out.data.ppp_conf;

	        ppp_conf.action = 'edit';
	        ppp_conf.btn_id = btn_id;
	    }

	    win = new Window('pppDialog', param);

	    template = this.template_PPP;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    win.getContent().innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template);

	    win.showCenter(true);
    },

    //--------------------------------------------
    // delete PPP configuration
    //--------------------------------------------
    onDeletePPP : function(pppNo) {
	    var unit;

	    unit = mod_ppp_out.data.ppp_status[pppNo].unit;

	    if (confirm($jq.sprintf("PPP No.%d の設定を削除してよろしいですか？", unit)))
	        mod_ppp_out.ajax_deletePPP(unit);
    },

    //--------------------------------------------
    // change device
    //--------------------------------------------
    onChangeDevice : function() {
	    var dev_idx, is_pppoe, account_default;
	    var need_apn, no_persist, force_lcp_check, pulse_ok, cipl_usable;

	    dev_idx = parseInt($('sel_device').value, 10);
	    is_pppoe = !mod_ppp_out.data.available_devices[dev_idx].modem;
	    no_persist = mod_ppp_out.data.available_devices[dev_idx].no_persist;
	    force_lcp_check = mod_ppp_out.data.available_devices[dev_idx].force_lcp_check;
	    account_default = mod_ppp_out.data.available_devices[dev_idx].account_default;
	    cipl_usable = (mod_ppp_out.data.available_devices[dev_idx].type == 2);

	    // Modem or PPPoE
	    $('sel_conn_type').disabled   = is_pppoe;
	    $('sel_dialtype').disabled    = is_pppoe;
	    $('txt_idletime').disabled    = is_pppoe;
	    $('txt_modeminit').disabled   = is_pppoe;
	    $('txt_phonenumber').disabled = is_pppoe;
	    $('chk_deflatecomp').disabled = is_pppoe;
	    $('chk_vjcomp').disabled      = is_pppoe;
	    $('txt_apn').disabled         = is_pppoe;

	    if (is_pppoe) {
	        // PPPoE
	        $('sel_conn_type').value     = 1;	// Persist
	        $('txt_modeminit').value     = '';
	        $('txt_phonenumber').value   = '';
	        $('chk_deflatecomp').checked = false;
	        $('chk_vjcomp').checked      = false;
	        $('txt_mtu').value           = 1454;	// Flet's
	    } else {
	        // Modem
	        pulseok = mod_ppp_out.data.available_devices[dev_idx].pulseok;
	        if (pulseok == false) {
		        $('sel_dialtype').value    = 1;	// 強制トーンダイアル
		        $('sel_dialtype').disabled = true;
	        } else
		        $('sel_dialtype').disabled = false;

	        need_apn = mod_ppp_out.data.available_devices[dev_idx].need_apn;
	        if (need_apn) {
		        $('sel_conn_type').value = 2; // Demand
                $('sel_pdptype').disabled = false;
		        $('txt_apn').disabled = false;
		        $('tr_apn').style.display = '';
		        $('tr_pdptype').style.display = '';
		        $('txt_phonenumber').disabled = true;
		        $('tr_phonenumber').style.display = 'none';
	        } else {
                $('sel_pdptype').disabled = true;
		        $('txt_apn').value = '';
		        $('txt_apn').disabled = true;
		        $('tr_apn').style.display = 'none';
		        $('tr_pdptype').style.display = 'none';
		        $('txt_phonenumber').disabled = false;
		        $('tr_phonenumber').style.display = '';
	        }

	        $('txt_mtu').value             = 1500;
	    }

	    /* LCP ECHO 強制か */
	    $('chk_lcp_check').disabled = false;
	    if (force_lcp_check) {
	        $('chk_lcp_check').checked = true;
	        $('chk_lcp_check').disabled = true;
	    }

	    /* CIPL利用可能か */
	    if (cipl_usable)
	        $('cipl_setting').style.display = '';
	    else
	        $('cipl_setting').style.display = 'none';

	    // デフォルトのプロバイダ設定有り ?
	    if (account_default.account != null)
	        $('txt_account').value = account_default.account;

	    if (account_default.password != null) {
	        $('txt_password').value = account_default.password;
	        $('txt_password_confirm').value = account_default.password;
	    }

	    if (account_default.phone_no != null)
	        $('txt_phonenumber').value = account_default.phone_no;
	    else
	        $('txt_phonenumber').value = '';

	    if (account_default.modeminit != null)
	        $('txt_modeminit').value = account_default.modeminit;
    },

    //--------------------------------------------
    // Add/Edit PPP finish handler
    //--------------------------------------------
    onPPPEditOK : function() {
	    var ppp_conf, devices;
	    var newPPP, action;
	    var is_modem, dev_idx, password = [];
	    var force_lcp_check, no_persist, need_apn;

	    ppp_conf = mod_ppp_out.data.ppp_conf;
	    devices = mod_ppp_out.data.available_devices;

	    action = ppp_conf.action;

	    // check Modem or PPPoE
	    if (action == 'add') {
	        dev_idx = parseInt($('sel_device').value, 10);

	        is_modem = devices[dev_idx].modem;
	        pulseok  = devices[dev_idx].pulseok;
	        force_lcp_check = devices[dev_idx].force_lcp_check;
	        no_persist = devices[dev_idx].no_persist;
	        need_apn = devices[dev_idx].need_apn;
	    } else {
	        is_modem = ppp_conf.is_modem;
	        pulseok  = ppp_conf.pulseok;
	        force_lcp_check = ppp_conf.force_lcp_check;
	        no_persist = ppp_conf.no_persist;
	        need_apn = ppp_conf.need_apn;
	    }

	    newPPP = new Object;

	    newPPP.action   = action;
	    newPPP.is_modem = is_modem;
	    newPPP.pulseok  = pulseok;
	    newPPP.force_lcp_check = force_lcp_check;
	    newPPP.no_persist = no_persist;
	    newPPP.need_apn = need_apn;

	    if (action == 'add') {
	        newPPP.dev_name = devices[dev_idx].devname;
	        newPPP.dev_node = devices[dev_idx].device;
	        newPPP.cipl_usable = (devices[dev_idx].type == 2);
	    } else {
	        newPPP.dev_name = ppp_conf.dev_name;
	        newPPP.dev_node = ppp_conf.dev_node;
	        newPPP.cipl_usable = ppp_conf.cipl_usable;
	    }

	    newPPP.unit = parseInt(ppp_conf.unit, 10);
	    newPPP.name = $jq.sprintf("ppp%d", newPPP.unit);

	    newPPP.conn_name = strip_escapeHTML($('txt_conn_name').value);
	    newPPP.is_modem  = is_modem;

	    if (is_modem == true) {
	        // Modem
	        newPPP.conn_type = parseInt($('sel_conn_type').value, 10);

	        if (parseInt($('sel_dialtype').value, 10) == 1)
		        newPPP.tone = true;
	        else
		        newPPP.tone = false;

	        newPPP.idle_time    = parseInt($('txt_idletime').value.strip(), 10);
	        newPPP.modeminit    = $('txt_modeminit').value.strip();
	        newPPP.phone_number = $('txt_phonenumber').value.strip();
	        newPPP.deflatecomp  = $('chk_deflatecomp').checked;
	        newPPP.vjcomp       = $('chk_vjcomp').checked;
	        newPPP.apn          = strip_escapeHTML($('txt_apn').value);
            newPPP.pdptype      = parseInt($('sel_pdptype').value, 10);
	    } else {
	        // PPPoE
	        newPPP.conn_type    = 1;	// 'PERSIST' 強制
	        newPPP.tone         = false;
	        newPPP.idle_time    = 0;
	        newPPP.modeminit    = '';
	        newPPP.phone_number = '';
	        newPPP.deflatecomp  = false;
	        newPPP.vjcomp       = false;
	    }

	    // LCP Echo
	    newPPP.lcp_check = $('chk_lcp_check').checked;

	    if (newPPP.lcp_check == true) {
	        newPPP.lcp_interval = parseInt($('txt_lcp_interval').value.strip(), 10);
	        newPPP.lcp_failure  = parseInt($('txt_lcp_failure').value.strip(), 10);
	    } else {
	        newPPP.lcp_interval = 30;
	        newPPP.lcp_failure  = 0;
	    }

	    // 一般設定
	    newPPP.usepeerdns   = $('chk_usepeerdns').checked;
	    newPPP.defaultroute = $('chk_defaultroute').checked;
	    newPPP.ip_local     = strip_escapeHTML($('txt_ip_local').value);
	    newPPP.ip_remote    = strip_escapeHTML($('txt_ip_remote').value);
	    newPPP.ip_netmask   = strip_escapeHTML($('txt_netmask').value);
	    newPPP.mtu          = parseInt($('txt_mtu').value.strip(), 10);

	    // アカウント設定
	    newPPP.useaccount = $('chk_useaccount').checked;
	    if (newPPP.useaccount) {
	        password[0] = $('txt_password').value.strip();
	        password[1] = $('txt_password_confirm').value.strip();

	        if (password[0] != password[1]) {
		        alert("パスワードが一致しません。");
		        return false;
	        }

	        newPPP.useaccount = true;
	        newPPP.account  = strip_escapeHTML($('txt_account').value);
	        newPPP.password = password[0];
	    } else {
	        newPPP.useaccount = false;
	        newPPP.account = "";
	        newPPP.password = "";
	    }

	    if (newPPP.cipl_usable) {
	        newPPP.cipl_sms = $('chk_cipl_sms').checked;
	        newPPP.cipl_domain = $('txt_cipl_domain').value.strip();
	    } else {
	        newPPP.cipl_sms = false;
	        newPPP.cipl_domain = '';
	    }

	    newPPP.zone = ppp_conf.zone;
	    newPPP.type = 1;	// PPP

	    if (this.validatePPP(newPPP) == false)
	        return false;

	    Windows.close('pppDialog');

	    this.ajax_updatePPP(newPPP);
    },

    //--------------------------------------------
    // Validate PPP configuration
    //--------------------------------------------
    validatePPP : function(newPPP) {
	    var result, errMsgArray = [], errMsg;

	    result = true;

	    if (newPPP.no_persist && newPPP.conn_type == 1)
	        errMsgArray.push("・このデバイスではPERSISTは選択できません。");

	    // account/password
	    if (newPPP.useaccount) {
	        if (newPPP.account == '')
		        errMsgArray.push("・アカウントを設定して下さい。");

	        if (newPPP.password == '')
		        errMsgArray.push("・パスワードを設定して下さい。");
	    }

	    // Modem
	    if (newPPP.is_modem == true) {
	        // 接続方式 : Demand
	        if (newPPP.conn_type == 2) {
		        if (newPPP.idle_time <= 0)
		            errMsgArray.push("・アイドル検知時間を設定して下さい。");
	        }

	        if (newPPP.phone_number == '')
		        errMsgArray.push("・電話番号を設定して下さい。");

	        if (newPPP.need_apn) {
		        if (newPPP.apn == '')
		            errMsgArray.push("・APNを設定してください。");
	        }
	    }

	    if (newPPP.lcp_check == true) {
	        if (newPPP.lcp_interval <= 0)
		        errMsgArray.push("・LCP ECHO 送信間隔を設定して下さい。");
	        if (newPPP.lcp_failure <= 0)
		        errMsgArray.push("・LCP ECHO 切断判定回数を設定して下さい。");
	    }

	    if (newPPP.is_modem == true) {
	        // Modem
	        if (newPPP.mtu < 128 || newPPP.mtu > 1500)
		        errMsgArray.push("・MTUの値が不正です。");
	    } else {
	        // PPPoE
	        if (newPPP.mtu < 128 || newPPP.mtu > 1492)
		        errMsgArray.push("・MTUの値が不正です。");
	    }

	    if (errMsgArray.length > 0) {
	        errMsg = errMsgArray.join('\n');
	        alert(errMsg);

	        result = false;
	    }

	    return result;
    }
};
