//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// Static Routing設定
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2007-2010 Century Systems Co.,Ltd.
//
// Last Modified: 2010/05/28 15:06:40 kikuchi
//==============================================================================

mod_routes = {
    //--------------------------------------------
    // HTML template (Main)
    //--------------------------------------------
    templateMain : {
	    HTMLtemplate : [
	        "<h1 class='title'>静的ルーティング設定</h1>",
	        "<h3>編集されるファイル&nbsp;<img src='img/ark_help.png' id='help_file' /></h3><br/>", 

	        "<h3>ネットワークの設定情報</h3><br/>",
	        "<table id='netinfo_table' class='zebra'>",
	        "<tr>",
	        " <th class='header'>インターフェース</th>",
	        " <th class='header'>IPアドレス</th>",
	        " <th class='header'>ネットマスク</th>",
	        "</tr>",
	        "<:for idx in conf:>",
	        "<tr>",
	        " <td class='centering'>${conf[idx].interface}</td>",
	        " <:if conf[idx]['type'] == 'Ethernet':>",
	        "  <% dhcp = conf[idx].config.use_dhcp; %>",
	        "  <:if dhcp != null && dhcp == true:>",
	        "   <td colspan='2' class='centering'>",
	        "    DHCPにより設定",
	        "   </td>",
	        "  <:/if:>",
	        "  <:else:>",
	        "   <td class='centering' style='width:100px;'>",
	        "    ${conf[idx].config.address}",
	        "   </td>",
	        "   <td class='centering' style='width:100px;'>",
	        "    ${conf[idx].config.netmask}",
	        "   </td>",
	        "  <:/else:>",
	        " <:/if:>",
	        " <:elseif conf[idx]['type'] == 'GRE':>",
	        "  <td colspan='2' class='centering'>",
	        "   GREトンネル",
	        "   <:if conf[idx].config.conn_name == '':>",
	        "    (remote=${conf[idx].config.remote_ip})",
	        "   <:/if:>",
	        "   <:else:>",
	        "    (${conf[idx].config.conn_name})",
	        "   <:/else:>",
	        "  </td>",
	        " <:/elseif:>",
	        " <:else:>",
	        "  <td colspan='2' class='centering'>",
	        "   PPP(${conf[idx].config.conn_name})",
	        "  </td>",
	        " <:/else:>",
	        "</tr>",
	        "<:/for:>",
	        "</table><br/>",

	        "<form id='routes_form'>",
	        "<table id='routes_table' class='zebra' cellpadding='0' border='0' >",
	        "<tr>",
	        "  <td colspan=5 class='noborderright'>",
	        "    <img id='indicator' src='img/indicator.gif' ",
	        "     style='visibility: hidden;' />",
	        "    <input type='button' id='bt_add' value='追加' class='button' />",
	        "    <input type='button' id='bt_update' value='設定' class='button' />",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th class='header'>No.</th>",
	        "  <th class='header'>IPアドレス</th>",
	        "  <th class='header'>ネットマスク</th>",
	        "  <th class='header'>インターフェース</th>",
	        "  <th class='header'>ゲートウェイ</th>",
	        "  <td class='noborder'></td>",
	        "</tr>",
	        "<:if routes.length == 0:>",
	        "<tr>",
	        "  <td colspan='5' class='centering'>",
	        "    静的ルートは登録されておりません。",
	        "  </td>",
	        "</tr>",
	        "<:/if:>",
	        "<:else:>",
	        "<:for idx in routes:>",
	        "<tr id='row_${idx}'>",
	        "  <td class='numeric'>${idx + 1}</td>",
	        "  <td>${routes[idx].address}</td>",
	        "  <td>${routes[idx].netmask}</td>",
	        "  <td class='centering'>${routes[idx].gw_dev}</td>",
	        "  <:if routes[idx].gw_address != '':>",
	        "   <td>",
	        "    ${routes[idx].gw_address}",
	        "   </td>",
	        "  <:/if:>",
	        "  <:else:>",
	        "   <td class='centering'>",
	        "    --",
	        "   </td>",
	        "  <:/else:>",
	        "  <td class='noborder'>",
	        "    <input type='button' id='bt_edit' value='編集' class='button'",
	        "     onClick='mod_routes.onEditRow(this)' />",
	        "    <input type='button' id='bt_del' value='削除' class='button'",
	        "     onClick='mod_routes.onDeleteRow(this)' />",
	        "  </td>",
	        "</tr>",
	        "<:/for:>",
	        "<:/else:>",
	        "</table>",
	        "</form>"
	    ].join("\n"),
	    //------------------------------
	    // Event Handlers
	    //------------------------------
	    handlers : [
	        [
		        // "追加"(Add) button Handler
		        'bt_add', 'click', function() {
		            var mod = mod_routes;

		            mod.dialog_data.operation = 'new';
		            mod.dialog_data.entryNo   = mod.data.routes.length;	// New
		            mod.dialog_data.type      = 'Ethernet';

		            mod.editDialog();
		        }],
	        [
		        // "適用"(Update) button handler
		        'bt_update', 'click', function() {
		            mod_routes.ajax_updateSettings();
		        }]
	    ],
	    //------------------------------
	    // Tooltips
	    //------------------------------
	    tooltips : [
	        [
		        // "Add" button
		        'bt_add', 'Note', "エントリを追加します。"
	        ],
	        [
		        // "Update" button
		        'bt_update', 'Note', "変更内容を装置へ反映します。"
	        ],
	        [
		        // --- 編集されるファイル ---
		        'help_file', 'Note', [ "下記のファイルが編集対象です。<br/>",
				                       "/etc/conf.d/net" ].join('\n')
	        ]
	    ]
    },

    //----------------------------------
    // dummy data (Main)
    //----------------------------------
    data : {
	    routes : [{
	        address : '192.168.0.0',
	        netmask : '255.255.255.0',
	        intf    : 'eth0',
	        gateway : '192.168.253.2'
	    }],

	    intf_table : [ 'eth0', 'eth1' ],

	    // Network setting info (from /service/conf/net/ethernet)
	    conf : {}
    },

    //--------------------------------------------
    // HTML template (Edit Dialog)
    //--------------------------------------------
    templateDialog : {
	    HTMLtemplate : [
	        "<center>",
	        "<h2>ルーティングテーブルの編集</h2><br/>",
	        "<form>",
	        "<table class='zebra'>",
	        "<tr>",
	        "  <th id='th_ipaddr' class='header'>アドレス</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='txt_address' class='text'",
	        "     tabindex=1 style='width:140px;' ",
	        "    <:if operation=='edit':>value='${route.address}'<:/if:>/>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th id='th_netmask' class='header'>ネットマスク</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='txt_netmask' class='text'",
	        "     tabindex=2 style='width:140px;'",
	        "    <:if operation=='edit':>value='${route.netmask}'<:/if:>/>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th id='th_interface' class='header'>インターフェース</th>",
	        "  <td class='noborder'>",
	        "    <select name='sel_intf' id='sel_intf' class='select'",
	        "     tabindex=3 style='width:80px;' />",
	        "    <:for idx in intf_table:>",
	        "     <option value=${idx}",
	        "      <:if operation=='new' && idx==0:>",
	        "       selected='selected'",
	        "      <:/if:>",
	        "      <:elseif (operation=='edit') && (route.gw_dev==intf_table[idx].interface):>",
	        "       selected='selected'",
	        "      <:/elseif:> >${intf_table[idx].interface}",
	        "     </option>",
	        "    <:/for:>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <th id='th_gateway' class='header'>ゲートウェイ</th>",
	        "  <td class='noborder'>",
	        "    <input type='text' id='txt_gateway' class='text'",
	        "     tabindex=4 style='width:140px;'",
	        "    <:if operation=='edit':>value='${route.gw_address}'<:/if:>",
	        "    <:if type == 'PPP' || type == 'PPP_In' || type == 'GRE':>",
	        "     disabled='disabled'",
	        "    <:/if:>/>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan='2' class='noborderright'>",
	        "    <input type='button' id='bt_ok' value='適用'",
	        "     class='button' tabindex=5 />",
	        "    <input type='button' id='bt_cancel' value='中止'",
	        "     class='button' tabindex=6 />",
	        "  </td>",
	        "</tr>",
	        "</table>",
	        "</form>",
	        "</center>"
	    ].join("\n"),
	    handlers : [
	        [
		        // Interface Select handler
		        'sel_intf', 'change', function() {
		            mod_routes.onChangeInterface();
		        }],
	        [
		        // "OK" button handler
		        'bt_ok', 'click', function() {
		            mod_routes.onRouteEditOk();
		        }],
	        [
		        // "Cancel" button handler
		        'bt_cancel', 'click', function() {
		            Windows.close('routeDialog');
		        }]
	    ],
	    tooltips : [
	        [
		        // "IPアドレス"
		        'th_ipaddr', 'Note', "宛先のアドレスを設定して下さい。"
	        ],
	        [
		        // "ネットマスク"
		        'th_netmask', 'Note', "宛先のサブネットマスクを設定して下さい。"
	        ],
	        [
		        // "Interface"
		        'th_interface', 'Note', [ "インターフェースを選択して下さい。",
					                      "DHCP設定ではないインターフェースのみ選択できます。" ].join('\n')
	        ],
	        [
		        // "Gateway"
		        'th_gateway', 'Note', "ゲートウェイのIPアドレスを設定して下さい。"
	        ]
	    ]
    },

    //----------------------------------
    // dummy data (Edit Dialog)
    //----------------------------------
    dialog_data : {
	    operation : 'new',	// 'new' or 'edit'

	    route : {
	        address : '192.168.0.0',
	        netmask : '255.255.255.0',
	        intf    : 'eth0',
	        gateway : '192.168.253.2'
	    },

	    entryNo : 0,

	    intf_table : [],
	    type : 'Ethernet'
    },

    //--------------------------------------------
    // Initialize
    //--------------------------------------------
    init : function(elem) {
	    var auth_data;
	    this.elem = elem;

	    auth_data = mod_auth.getAccountInfo();

	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);

	        return;
	    }

	    if (!this.validator)
	        this.validator = new validateUtil();

	    // Get All Interface information (Ajax)
	    this.ajax_getAllInterfaceInfo(true, this.ajax_getSettings);

	    // Get settings (Ajax)
	    //this.ajax_getSettings();
    },

    //--------------------------------------------
    // Render HTML (Main)
    //--------------------------------------------
    render : function() {
	    var template, html, parser;

	    template = this.templateMain;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template, true);
    },

    //--------------------------------------------
    // Edit Dialog
    //--------------------------------------------
    editDialog : function() {
	    var win, param, parser, template, html;

	    this.dialog_data.intf_table = this.data.intf_table;

	    param = {
	        //			className   : "mac_os_x",
	        className   : "alphacube",
	        title       : "ルーティングテーブルの編集",
	        width       : 340,
	        height      : 200,
	        resizable   : false,
	        closable    : true,
	        minimizable : false,
	        maximizable : false,
	        showEffect  : Element.show,
	        hideEffect  : Element.hide,

	        destroyOnClose: true
	    };

	    win = new Window('routeDialog', param);

	    template = this.templateDialog;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.dialog_data);

	    win.getContent().innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template, false);

	    win.showCenter(true);	// Modal window
    },

    //==========================================================================
    //
    // Ajax functions
    //
    //==========================================================================

    //------------------------------------------------------
    // All Interface 情報取得 (GET)
    //------------------------------------------------------
    ajax_getAllInterfaceInfo: function(chain, func) {
	    var auth_data;
	    var url, params, configs, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @getAllInterfaceInfo. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var ifaces = eval("(" + httpObj.responseText + ")");
		        var idx, intf, conf;

		        debug($jq.sprintf("getAllInterfaceInfo: '%s'", httpObj.responseText));

		        this.data.conf = ifaces.all;
		        this.data.intf_table = [];

		        // shortcut
		        conf = this.data.conf;

		        for (idx = 0; idx < ifaces.all.length; idx++) {
		            intf = ifaces.all[idx];
		            this.data.intf_table.push(intf);
		        }

		        if (chain)
		            func();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Get settings (routes)
    //--------------------------------------------
    ajax_getSettings : function() {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/route";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ ajax_getSettings. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Routes: Error %d.", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var res = eval('(' + httpObj.responseText + ')');
		        debug($jq.sprintf("ajax_getSetings() --> %s", httpObj.responseText));

		        if (res.nums == 0) {
		            debug("length == 0");
		            mod_routes.data.routes = [];
		        } else
		            mod_routes.data.routes = res.routes;

		        mod_routes.render();
	        }
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Update
    //--------------------------------------------
    ajax_updateSettings : function() {
	    var auth_data, put_data;
	    var url, params, wsse_header;
	    var send_data, json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/route";

	    send_data = {'routes' : this.data.routes};
	    json = Object.toJSON(send_data);
	    debug($jq.sprintf("Routes : ajax_updateSettings(): %s", json));

	    params = {
	        method: "PUT",
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        this.hide_indicator();

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ ajax_updateSettings. (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("ajax_updateSettings: error %d.", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        this.hide_indicator();

		        alert("更新しました。");
	        }.bind(this)
	    };

	    this.show_indicator();
	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Reboot
    //--------------------------------------------
    rebootNTPServer : function() {
	    alert("reboot button clicked.");
    },

    //================================================================
    //
    // Utility functions
    //
    //================================================================

    // StaticRoute 設定中
    show_indicator : function() {
	    $('indicator').style.visibility = 'visible';
    },

    // StaticRoute 設定完了
    hide_indicator : function() {
	    $('indicator').style.visibility = 'hidden';
    },

    //================================================================
    //
    // Event Handlers
    //
    //================================================================

    //--------------------------------------------
    // Edit Entry handler
    //--------------------------------------------
    onEditRow : function(editRow) {
	    var idx, gw_dev, dev_idx;

	    Element.extend(editRow);

	    idx = editRow.up().up().rowIndex - 2;

	    this.dialog_data.operation = 'edit';
	    this.dialog_data.route     = Object.clone(this.data.routes[idx]);
	    this.dialog_data.entryNo   = idx;

	    gw_dev = this.dialog_data.route.gw_dev;

	    for (dev_idx = 0; dev_idx < this.data.conf.length; dev_idx++) {
	        if (this.data.conf[dev_idx].interface == gw_dev)
		        this.dialog_data.type  = this.data.conf[dev_idx].type;
	    }

	    this.editDialog();
    },

    //--------------------------------------------
    // Delete Entry handler
    //--------------------------------------------
    onDeleteRow : function(eraseRow) {
	    var idx, row;

	    Element.extend(eraseRow);

	    row = eraseRow.up().up();
	    idx = row.rowIndex - 2;

	    new Effect.Fade(row);

	    if (confirm("No." + (idx + 1) + " のRouteを\n消してよろしいですか ?")) {
	        this.data.routes = this.data.routes.removeByIndex(idx);
	        this.render();
	    } else
	        new Effect.Appear(row);
    },

    //--------------------------------------------
    // Change Interface handler
    //--------------------------------------------
    onChangeInterface : function() {
	    var idx = parseInt($('sel_intf').value, 10);

	    $('txt_gateway').value = '';

	    debug($jq.sprintf("onChangeInterface: intf_index = %d", idx));

	    if (this.data.conf[idx].type == 'PPP' ||
	        this.data.conf[idx].type == 'PPP_In' ||
	        this.data.conf[idx].type == 'GRE')
	        $('txt_gateway').disabled = true;
	    else
	        $('txt_gateway').disabled = false;
    },

    //--------------------------------------------
    // Add/Edit route finish handler
    //--------------------------------------------
    onRouteEditOk : function() {
	    var newRoute, operation, where;
	    var address, netmask, intf, gateway;

	    operation = this.dialog_data.operation;

	    address = strip_escapeHTML($('txt_address').value);
	    netmask = strip_escapeHTML($('txt_netmask').value);
	    intf    = parseInt($('sel_intf').value, 10);
	    gateway = strip_escapeHTML($('txt_gateway').value);

	    newRoute = {
	        address    : address,
	        netmask    : netmask,
	        intf       : intf,
	        gw_address : gateway,
	        gw_dev     : this.data.intf_table[intf].interface,
	        prefixlen  : -1
	    };

	    // route validation
	    if (this.validate_newRoute(operation, newRoute) == false)
	        return false;

	    if (operation == 'new')
	        this.data.routes = this.data.routes.insertByIndex(
		        this.dialog_data.entryNo, Object.clone(newRoute));
	    else
	        this.data.routes = this.data.routes.replaceByIndex(
		        this.dialog_data.entryNo, Object.clone(newRoute));

	    Windows.close('routeDialog');

	    this.render();
    },

    //--------------------------------------------
    // Validate new route
    //--------------------------------------------
    validate_newRoute : function(operation, newRoute) {
	    var errMsgArray = [], errMsg;
	    var addr, netmask, conf, idx, dhcp, p2p;

	    // check Network address
	    if (newRoute.address == '')
	        errMsgArray.push("・アドレスが設定されていません。");
	    else if (this.validator.checkNetworkAddress(newRoute.address) == false)
	        errMsgArray.push("・アドレスが不正です。");

	    // check Netmask
	    if (newRoute.netmask == '')
	        errMsgArray.push("・ネットマスクが設定されていません。");
	    else if (this.validator.checkNetmask(newRoute.netmask) == false)
	        errMsgArray.push("・ネットマスクが不正です。");

	    // check Route target
	    if (errMsgArray.length == 0)
	        if (this.validator.checkRouteTarget(newRoute.address, newRoute.netmask) == false)
		        errMsgArray.push("・ルーティング先アドレスが不正です。");

	    conf = mod_routes.data.conf;
	    idx = newRoute.intf;

	    if (conf[idx].type == 'PPP' || conf[idx].type == 'PPP_In' ||
	        conf[idx].type == 'GRE')
	        p2p = true;
	    else
	        p2p = false;

	    dhcp = conf[idx].config.use_dhcp;

	    // check Gateway reachability
	    if (dhcp == true)
	        errMsgArray.push("・DHCP設定になっているので静的ルートの登録はできません。");
	    else if (newRoute.gateway == '' && p2p == false)
	        errMsgArray.push("・ゲートウェイが設定されていません。");
	    else {
	        addr    = conf[idx].config.address;
	        netmask = conf[idx].config.netmask;

	        if (p2p == false)
		        if (this.validator.checkReachability(addr, netmask, newRoute.gw_address) == false)
		            errMsgArray.push("・ゲートウェイが到達不可能なアドレスに設定されています。");
	    }

	    if (errMsgArray.length > 0) {
	        errMsg = errMsgArray.join('\n');
	        alert(errMsg);

	        return false;
	    }

	    debug("validate_newRoute: OK");
	    return true;
    }
};
