//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// ser2net 設定
// Copyright (C) 2008-2010 Century Systems Co., Ltd.
//==============================================================================

mod_ser2net = {
    template_main : {
	    HTMLtemplate : [
	        "<h1 class='title'>ser2net設定</h1>",
	        "<h3>編集されるファイル&nbsp;",
	        "<img src='img/ark_help.png' id='help_file'/>",
	        "</h3><br/>",

	        "<h3>利用可能デバイス一覧</h3><br/>",
	        "<table id='tbl_devices' class='zebra'>",
	        "<tr>",
	        "<td colspan='2' class='noborderright'>",
	        "<img id='indicator_devices' src='img/indicator.gif'",
	        "style='visibility: hidden;' />",
	        "<input id='btn_reload_device' type='button'",
	        "class='button' style='width:50px;' value='更新' />",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header' style='width:160px'>名称</th>",
	        "<th class='header' style='width:160px'>デバイス</th>",
	        "</tr>",
	        "<:for idx in available_devices:>",
	        "<%var dev=available_devices[idx]; %>",
	        "<tr>",
	        "<td>${dev.devname}</td>",
	        "<td>${dev.device}</td>",
	        "</tr>",
	        "<:/for:>",
	        "</table><br/>",

	        "<h3>サービス設定</h3><br/>",
	        "<table id='service_form' class='zebra'>",
	        "<tr>",
	        "<td colspan='2' class='noborderright'>",
	        "<img id='indicator_service' src='img/indicator.gif'",
	        "style='visibility: hidden;' />",
	        "<input id='btn_submit_service' type='button'",
	        "class='button' style='width:50px;' value='設定' />",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header' style='width:120px;'>サービス</th>",
	        "<td style='width:200px;'>",
	        "<ul style='list-style-type: none;'>",
	        "<li>",
	        "<label for='chk_service'>",
	        "<input type='checkbox' id='chk_service'",
	        "<:if server.service != 0:>checked<:/if:>",
	        "/>&nbsp;使用する<br/>",
	        "</label>",
	        "</li>",
	        "</ul>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>制御ポート</th>",
	        "<td>",
	        "<ul style='list-style-type: none;'>",
	        "<li>",
	        "<label for='chk_control_port'>",
	        "<input type='checkbox' id='chk_control_port'",
	        "<:if server.controller != 0:>checked<:/if:>",
	        "/>&nbsp;使用する<br/>",
	        "</label>",
	        "</li>",
	        "</ul>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>制御ポート番号</th>",
	        "<td>",
	        "<input type='text' id='txt_control_port' class='text'",
	        "style='width:100px;' value='${server.port}'/>",
	        "</td>",
	        "</tr>",
	        "</table>",

	        "<br/>",

	        "<h3>ポート設定</h3><br/>",
	        "<table id='port_list' class='zebra'>",
	        "<tr>",
	        "<td colspan='3' class='noborderright'>",
	        "<img id='indicator_ports' src='img/indicator.gif'",
	        "style='visibility: hidden;'/>",
	        "<input id='btn_add' type='button' class='button'",
	        "style='width:50px;' value='追加'/>",
	        "</td>",
	        "</tr>",

	        "<tr>",
	        "<th class='header' style='width:160px;'>デバイス</th>",
	        "<th class='header' style='width:80px;'>モード</th>",
	        "<th class='header' style='width:80px;'>ポート番号</th>",
	        "</tr>",

	        "<:if ports.length == 0:>",
	        "<tr>",
	        "<td class='centering' colspan='3'>",
	        "ポートは登録されておりません。",
	        "</td>",
	        "</tr>",
	        "<:/if:>",

	        "<:else:>",
	        "<:for idx in ports:>",
	        "<%var port=ports[idx]; %>",
	        "<tr>",
	        "<td>${port.dev_name}</td>",
	        "<td>",
	        "<:if port.state == 0:>off<:/if:>",
	        "<:elseif port.state == 1:>raw<:/elseif:>",
	        "<:elseif port.state == 2:>rawlp<:/elseif:>",
	        "<:elseif port.state == 3:>telnet<:/elseif:>",
	        "</td>",
	        "<td>${port.port}</td>",
	        "<td class='noborder'>",
	        "<input type='button' id='btn_edit_${idx}' value='編集'",
	        "class='button' style='width:50px;'",
	        "onClick='mod_ser2net.onEditPort(${idx})'/>",
	        "<input type='button' id='btn_del_${idx}' value='削除'",
	        "class='button' style='width:50px;'",
	        "onClick='mod_ser2net.onDeletePort(${idx})'/>",
	        "</td>",
	        "</tr>",
	        "<:/for:>",
	        "<:/else:>",

	        "</table>",
	    ].join(' '),

	    handlers : [
	        [
		        'btn_submit_service', 'click', function() {
		            mod_ser2net.onSubmitService();
		        }
	        ],
	        [
		        'btn_add', 'click', function() {
		            mod_ser2net.onEditPort(-1);
		        }
	        ]
	    ],

	    tooltips : [
	        [
		        'help_file', 'Note', [ "下記のファイルが編集対象です。<br/>",
				                       "/etc/conf.d/ser2net<br/>",
				                       "/etc/ser2net.conf" ].join('\n')
	        ]
	    ]
    },

    data : {
	    available_devices : [
	        {'devname': 'PORT0', 'device': '/dev/ttymxc0'},
	        {'devname': 'PORT1', 'device': '/dev/ttymxc1'}
	    ],
	    server : {},
	    ports : [],
	    port_conf : {},
	    bpslist: [300, 1200, 2400, 4800, 9600, 19200, 38400, 57600, 115200]
    },

    init: function(elem) {
	    var auth_data;
	    this.elem = elem;

	    auth_data = mod_auth.getAccountInfo();
	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);
	        return;
	    }

	    this.elem.module = this;

	    this.GET_configuration();
    },

    render: function() {
	    var html, parser, template;

	    template = this.template_main;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template);
    },

    //--------------------------------------------
    // HTML template (add/edit port)
    //--------------------------------------------
    template_port : {
	    HTMLtemplate : [
	        "<center>",
	        "<form>",
	        "<table class='zebra'>",

	        "<tr>",
	        "<th class='header'>デバイス</th>",
	        "<td class='noborder'>",
	        "<select name='sel_device' id='sel_device' class='select'",
	        "style='width:140px;'/>",
	        "<:for devidx in available_devices:>",
	        "<option value='${devidx}'",
	        "<:if port_conf.dev_node == available_devices[devidx].device:>",
	        "selected<:/if:>",
	        ">${available_devices[devidx].devname}</option>",
	        "<:/for:>",
	        "</select>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>動作モード</th>",
	        "<td class='noborder'>",
	        "<select name='sel_mode' id='sel_mode' class='select'",
	        "style='width:100px;'/>",
	        "<option value=0",
	        "<:if port_conf.state == 0:>selected<:/if:>",
	        ">off</option>",
	        "<option value=1",
	        "<:if port_conf.state == 1:>selected<:/if:>",
	        ">raw</option>",
	        "<option value=2",
	        "<:if port_conf.state == 2:>selected<:/if:>",
	        ">rawlp</option>",
	        "<option value=3",
	        "<:if port_conf.state == 3:>selected<:/if:>",
	        ">telnet</option>",
	        "</select>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>ポート番号</th>",
	        "<td class='noborder'>",
	        "<input type='text' class='text' id='txt_port' ",
	        "style='width:120px;' value='${port_conf.port}'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>タイムアウト</th>",
	        "<td class='noborder'>",
	        "<input type='text' class='text' id='txt_timeout' ",
	        "style='width:120px;' value='${port_conf.timeout}'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>BPS</th>",
	        "<td class='noborder'>",
	        "<select name='sel_bps' id='sel_bps' class='select'",
	        "style='width:120px;'/>",
	        "<:foreach bps in bpslist:>", 
	        "<option value=${bps}",
	        "<:if port_conf.bps == bps:>selected<:/if:>",
	        ">${bps}</option>",
	        "<:/foreach:>",
	        "</select>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>パリティ</th>",
	        "<td class='noborder'>",
	        "<select name='sel_parity' id='sel_parity' class='select'",
	        "style='width:100px;'/>",
	        "<option value='NONE'",
	        "<:if port_conf.parity == 'NONE':>selected<:/if:>",
	        ">なし</option>",
	        "<option value='EVEN'",
	        "<:if port_conf.parity == 'EVEN':>selected<:/if:>",
	        ">偶数</option>",
	        "<option value='ODD'",
	        "<:if port_conf.parity == 'ODD':>selected<:/if:>",
	        ">奇数</option>",
	        "</select>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>ストップビット</th>",
	        "<td class='noborder'>",
	        "<select name='sel_stopbits' id='sel_stopbits' class='select'",
	        "style='width:100px;'/>",
	        "<option value=1",
	        "<:if port_conf.stopbits == 1:>selected<:/if:>",
	        ">1</option>",
	        "<option value=2",
	        "<:if port_conf.stopbits == 2:>selected<:/if:>",
	        ">2</option>",
	        "</select>&nbsp;bits",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>データ長</th>",
	        "<td class='noborder'>",
	        "<select name='sel_databits' id='sel_databits' class='select'",
	        "style='width:100px;'/>",
	        "<option value=7",
	        "<:if port_conf.databits == 7:>selected<:/if:>",
	        ">7</option>",
	        "<option value=8",
	        "<:if port_conf.databits == 8:>selected<:/if:>",
	        ">8</option>",
	        "</select>&nbsp;bits",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>フロー制御</th>",
	        "<td class='noborder'>",
	        "<select name='sel_flow' id='sel_flow' class='select'",
	        "style='width:160px;'/>",
	        "<option value='NONE'",
	        "<:if port_conf.flow == 'NONE':>selected<:/if:>",
	        ">なし</option>",
	        "<option value='SOFT'",
	        "<:if port_conf.flow == 'SOFT':>selected<:/if:>",
	        ">Software Flow</option>",
	        "<option value='HARD'",
	        "<:if port_conf.flow == 'HARD':>selected<:/if:>",
	        ">Hardware Flow</option>",
	        "</select>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>モデム制御ライン</th>",
	        "<td class='noborder'>",
	        "<ul style='list-style-type: none;'>",
	        "<li>",
	        "<label for='chk_local'>",
	        "<input type='checkbox' id='chk_local'",
	        "<:if port_conf.local:>checked<:/if:>",
	        "/>&nbsp;使用する<br/>",
	        "</label>",
	        "</li>",
	        "</ul>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>リモートコントロール</th>",
	        "<td class='noborder'>",
	        "<ul style='list-style-type: none;'>",
	        "<li>",
	        "<label for='chk_remctl'>",
	        "<input type='checkbox' id='chk_remctl'",
	        "<:if port_conf.remctl:>checked<:/if:>",
	        "/>&nbsp;使用する<br/>",
	        "</label>",
	        "</li>",
	        "</ul>",
	        "</td>",
	        "</tr>",

	        "<tr>",
	        "<td colspan=2 class='noborderright'>",
	        "<input type='button' id='bt_ok' value='OK' tabindex='24'",
	        "class='button' />",
	        "<input type='button' id='bt_cancel' value='Cancel' tabindex='25'",
	        "class='button' />",
	        "</td>",
	        "</tr>",


	        "</table>",
	        "</form>"
	    ].join(' '),

	    handlers : [
	        [
		        'bt_ok', 'click', function() {
		            $(mod_ser2net.data.port_conf.btn_id).disabled = false;
		            mod_ser2net.onPortEditOK();
		        }
	        ],
	        [
		        'bt_cancel', 'click', function() {
		            $(mod_ser2net.data.port_conf.btn_id).disabled = false;
		            Windows.close('portDialog');
		        }
	        ]
	    ],

	    tooltips : [
	    ]
    },

    //--------------------------------------------
    // submit service
    //--------------------------------------------
    onSubmitService : function() {
	    var param;

	    param = {
	        service: $('chk_service').checked,
	        controller: $('chk_control_port').checked,
	        port: parseInt($('txt_control_port').value.strip(), 10)
	    };

	    if (this.validateService(param) == false)
	        return false;

	    this.ajax_updateService(param);
    },

    //--------------------------------------------
    // add/edit port configuration
    //--------------------------------------------
    onEditPort : function(idx) {
	    var win, param, parser, template, html;
	    var port_conf, btn_id;

	    if (idx == -1)
	        btn_id = 'btn_add';
	    else
	        btn_id = $jq.sprintf('btn_edit_%d', idx);

	    $(btn_id).disabled = true;

	    param = {
	        className      : "alphacube",
	        title          : "ser2net 設定編集",
	        width          : 370,
	        height         : 370,
	        resizable      : false,
	        closable       : true,
	        minimizable    : false,
	        maximizable    : false,
	        showEffect     : Element.show,
	        hideEffect     : Element.hide,
	        destroyOnClose : true
	    };

	    if (idx == -1) {
	        // add entry
	        var units, i, new_unit, total_len;

	        // entry数チェック

	        // 初期値
	        mod_ser2net.data.port_conf = {
		        'action': 'add',
		        'port' : 2001,
		        'timeout': 600,
		        'bps': 115200,
		        'stopbits': 1,
		        'databits': 8,
		        'btn_id': btn_id
	        };
	    } else {
	        // edit entry
	        mod_ser2net.data.port_conf = Object.clone(this.data.ports[idx]);
	        port_conf = mod_ser2net.data.port_conf;
	        port_conf.action = 'edit';
	        port_conf.btn_id = btn_id;
	    }

	    win = new Window('portDialog', param);

	    template = this.template_port;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    win.getContent().innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template);

	    win.showCenter(true);
    },

    //--------------------------------------------
    // add/edit port finish handler
    //--------------------------------------------
    onPortEditOK : function() {
	    var port_conf, devices;
	    var newPort;
	    
	    port_conf = mod_ser2net.data.port_conf;
	    devices = mod_ser2net.data.available_devices;

	    action = port_conf.action;

	    newPort = new Object;
	    newPort.action = action;

	    /* ser2net_seq */
	    if (action == 'edit') {
	        newPort.ser2net_seq = port_conf.ser2net_seq;
	    }

	    /* device */
	    dev_idx = parseInt($('sel_device').value, 10);
	    newPort.dev_name = devices[dev_idx].devname;
	    newPort.dev_node = devices[dev_idx].device;

	    /* state */
	    newPort.state = parseInt($('sel_mode').value.strip(), 10);

	    /* port */
	    newPort.port = parseInt($('txt_port').value.strip(), 10);

	    /* timeout */
	    newPort.timeout = parseInt($('txt_timeout').value.strip(), 10);

	    /* bps */
	    newPort.bps = parseInt($('sel_bps').value.strip(), 10);

	    /* parity */
	    newPort.parity = $('sel_parity').value.strip();

	    /* stopbits */
	    newPort.stopbits = parseInt($('sel_stopbits').value.strip(), 10);

	    /* databits */
	    newPort.databits = parseInt($('sel_databits').value.strip(), 10);

	    /* flow */
	    newPort.flow = $('sel_flow').value.strip();

	    /* local */
	    newPort.local = $('chk_local').checked;

	    /* remctl */
	    newPort.remctl = $('chk_remctl').checked;
	    
	    if (this.validatePort(newPort) == false)
	        return false;

	    Windows.close('portDialog');

	    this.ajax_updatePort(newPort);
    },

    //--------------------------------------------
    // Validate service
    //--------------------------------------------
    validateService : function(service) {
	    var result, errMsgArray = [], errMsg;

	    result = true;

	    if (service.controller &&
	        (isNaN(service.port) || (service.port < 0) ||
	         (service.port > 65535))) {
	        errMsgArray.push("・ポート番号が不正です。");
	    }

	    if (errMsgArray.length > 0) {
	        errMsg = errMsgArray.join('\n');
	        alert(errMsg);

	        result = false;
	    }

	    return result;
    },

    //--------------------------------------------
    // Validate port configuration
    //--------------------------------------------
    validatePort : function(newPort) {
	    var result, errMsgArray = [], errMsg;
	    var ports = mod_ser2net.data.ports;

	    result = true;

	    /* port */
	    if (!("port" in newPort) || isNaN(newPort.port) ||
	        (newPort.port < 0) || (newPort.port > 65535)) {
	        errMsgArray.push("・ポート番号が不正です。");
	    }
	    
	    /* timeout */
	    if (!("timeout" in newPort) || isNaN(newPort.timeout) ||
	        (newPort.timeout < 0)) {
	        errMsgArray.push("・タイムアウトが不正です。");
	    }

	    for (var i = 0; i < ports.length; i++) {
	        if (("ser2net_seq" in newPort) &&
		        (newPort.ser2net_seq == ports[i].ser2net_seq)) {
		        continue;
	        }
	        if (newPort.port == ports[i].port) {
		        errMsgArray.push("・ポートが重複します。");
		        break;
	        }
	    }

	    if (errMsgArray.length > 0) {
	        errMsg = errMsgArray.join('\n');
	        alert(errMsg);

	        result = false;
	    }

	    return result;
    },

    //--------------------------------------------
    // delete port configuration
    //--------------------------------------------
    onDeletePort : function(idx) {
	    var seq, port;
	    seq = mod_ser2net.data.ports[idx].ser2net_seq;
	    port = mod_ser2net.data.ports[idx].port;

	    if (confirm($jq.sprintf("ポート番号(%d)の設定を削除してよろしいですか？", port)))
	        mod_ser2net.ajax_deletePort(seq);
    },

    //================================================================
    //
    // Ajax Functions
    //
    //================================================================

    //--------------------------------------------
    // update service configuration
    //--------------------------------------------
    ajax_updateService : function(service) {
	    var auth_data;
	    var url, params, wsse_header;
	    var method, json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    method = 'PUT';
	    url = "/service/apps/ser2net/service";

	    json = Object.toJSON(service);
	    debug($jq.sprintf("json: '%s'", json));

	    params = {
	        method: method,
	        contentType: 'application/json',
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;
		        this.hide_indicator('indicator_service');

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ajax_updateService (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        this.hide_indicator('indicator_service');
		        debug($jq.sprintf("ajax_updateService: %s", httpObj.responseText));

		        alert("サービス設定を登録しました。");

		        // reload
		        this.GET_configuration();
	        }.bind(this)
	    };

	    this.show_indicator('indicator_service');
	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // GET configuration
    //--------------------------------------------
    GET_configuration : function() {
	    var auth_data;
	    var url, params, configs, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/apps/ser2net/conf";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @GET_configration (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("GET_configuration: %s", httpObj.responseText));
		        result = eval("(" + httpObj.responseText + ")");
		        this.data.server = result['server'];
		        this.data.ports = result['ports'];

		        this.render();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // add/update port configuration
    //--------------------------------------------
    ajax_updatePort : function(newPort) {
	    var auth_data;
	    var url, params, wsse_header;
	    var method, json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    if (newPort.action == 'add') {
	        method = 'POST';
	        url = "/service/apps/ser2net/port";
	    } else if (newPort.action == 'edit') {
	        method = 'PUT';
	        url = "/service/apps/ser2net/port";
	    } else {
	        alert("ajax_updatePort: action error.");
	        return;
	    }

	    json = Object.toJSON(newPort);
	    debug($jq.sprintf("json: '%s'", json));

	    params = {
	        method: method,
	        contentType: 'application/json',
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;
		        this.hide_indicator('indicator_ports');

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ajax_updatePort (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        this.hide_indicator('indicator_ports');

		        debug($jq.sprintf("ajax_updatePort: %s", httpObj.responseText));

		        // reload
		        this.GET_configuration();
	        }.bind(this)
	    };

	    this.show_indicator('indicator_ports');
	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // delete port configuration
    //--------------------------------------------
    ajax_deletePort : function(seq) {
	    var auth_data;
	    var url, params, configs, wsse_header;
	    var method, json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = $jq.sprintf("/service/apps/ser2net/port/%d", seq);

	    params = {
	        method: "DELETE",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        this.hide_indicator('indicator_ports');

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ajax_deletePort (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result;

		        this.hide_indicator('indicator_ports');

		        debug($jq.sprintf("ajax_deletePort: %s", httpObj.responseText));

		        // reload
		        this.GET_configuration();
	        }.bind(this)
	    };

	    this.show_indicator('indicator_ports');
	    new Ajax.Request(url, params);
    },

    //================================================================
    //
    // Utility functions
    //
    //================================================================

    // AJAX 処理開始
    show_indicator : function(elem) {
	    $(elem).style.visibility = 'visible';
    },

    // AJAX 処理完了
    hide_indicator : function(elem) {
	    $(elem).style.visibility = 'hidden';
    }

};
