//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// Firewall(shorewall) 設定
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2007-2010 Century Systems Co., Ltd.
//
// Last Modified: 2010/05/28 15:06:52 kikuchi
//==============================================================================

mod_shorewall = {
    //--------------------------------------------
    // HTML template
    //--------------------------------------------
    template_main : {
	    HTMLtemplate : [
	        "<h1 class='title'>ファイアウォール設定</h1>",
	        "<h3>編集されるファイル&nbsp;<img src='img/ark_help.png' id='help_file' /></h3><br/>", 

	        "<table id='firewall_conf' class='zebra'>",
	        "<tr>",
	        "  <th>全体設定</th>",
	        "  <td>",
	        "   <ul style='list-style-type: none;'>",
	        "    <li>",
	        "    <label for='use_fw'>",
	        "    <input id='use_fw' type=checkbox ",
	        "     <:if data.settings.use_fw == true:>checked='checked'<:/if:> />",
	        "     ファイアウォール機能を使用する",
	        "    </label>",
	        "    </li>",
	        "   </ul>",
	        "  </td>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan='2' class='noborderright'>",
	        "    <img id='indicator' src='img/indicator.gif' ",
	        "     style='visibility: hidden;' />",
	        "    <img id='indicator' src='img/indicator.gif' style='visibility: hidden;' />",
	        "    <input id='bt_update' type='button' value='設定' class='button' />",
	        "  </td>",
	        "</tr>",
	        "</table><br/>",

	        "<div id='dhtmlgoodies_tabView1'>",
	        //--------------------------
	        // Tab No.2 Zone設定
	        //--------------------------
	        "<div class='dhtmlgoodies_aTab'>",
	        "<h2>ゾーン設定</h2><br/>",
	        "<table id='zone_table' class='zebra'>",
	        "  <tr>",
	        "    <th class='header'>No.</th>",
	        "    <th class='header'>インターフェース</th>",
	        "    <th class='header' id='th_zone'>ゾーン</th>",
	        "  </tr>",
	        "  <% var intf=data.interfaces; %>",
	        "  <:for i in intf:>",
	        "  <tr>",
	        "	 <td class='numeric'>${i + 1}</td>",						// No.
	        "    <td class='centering'>${intf[i].name}",					// Interface
	        "    <td class='noborder'>",
	        "     <select name='sel_zone_${i}' id='sel_zone_${i}' class='select'",
	        "      style='width:120px;' onChange='mod_shorewall.onChangeZone(${i})' />",
	        "     <:for idx in table.zone_tr:>",
	        "      <option value='${idx}'",
	        "       <:if intf[i].zone==idx:>selected='selected'<:/if:>",
	        "      >${table.zone_tr[idx]}</option>",
	        "     <:/for:>",
	        "    </td>",
	        "  </tr>",
	        "  <:/for:>",
	        "</table>",
	        "</div>",

	        //--------------------------
	        // Tab No.3 NAPT設定
	        //--------------------------
	        "<div class='dhtmlgoodies_aTab'>",
	        "<h2>NAPT設定</h2><br/>",
	        "<table id='napt_table' class='zebra'>",
	        "  <thead>",
	        "  <tr>",
	        "    <td class='noborderright' colspan='3'>",
	        "      <input type='button' id='bt_napt_add' value='追加' class='button' />",
	        //			"      <input type='button' id='bt_napt_update' value='設定' class='button' />",
	        "    </td>",
	        "  </tr>",
	        "  <tr>",
	        "    <th class='header'>No.</th>",
	        "    <th class='header'>変換先(dst) I/F</th>",
	        "    <th class='header'>変換元(src) I/F</th>",
	        "  </tr>",
	        "  </thead>",

	        "  <tbody>",
	        "  <:if data.napt.length == 0:>",
	        "  <tr>",
	        "    <td colspan='3' class='centering'>",
	        "      NAPT設定は登録されていません。",
	        "    </td>",
	        "  </tr>",
	        "  <:/if>",

	        "  <:else:>",
	        "  <% var napt=data.napt; %>",
	        "  <:for i in napt:>",
	        "  <tr>",
	        "    <td class='numeric'>${i + 1}</td>",			// No.
	        "    <td class='centering'>${napt[i].dst_if}</td>",	// Destination I/F
	        "    <td class='centering'>${napt[i].src_if}</td>",	// Source I/F
	        "    <td class='noborder'>",
	        "      <input type='button' value='編集' class='button' style='width:50px;' ",
	        "       onClick='mod_shorewall.onEditNAPT(${i})' />",
	        "      <input type='button' value='削除' class='button' style='width:50px;' ",
	        "       onClick='mod_shorewall.onEraseNAPT(${i})' />",
	        "    </td>",
	        "  </tr>",
	        "  <:/for:>",
	        "  <:/else:>",
	        "  </tbody>",
	        "</table>",
	        "</div>",

	        //--------------------------
	        // Tab No.4 Rule設定
	        //--------------------------
	        "<div class='dhtmlgoodies_aTab'>",
	        "<h2>フィルタ/DNATルール設定</h2>",
	        "<table id='firewall_rule' class='zebra'>",
	        "<thead>",
	        "  <tr>",
	        //			"    <td colspan=6 class='noborderright'>",
	        "    <td colspan=5 class='noborderright'>",
	        "      <input id='bt_insert' type='button' value='先頭へ追加' class='button'",
	        "       style='width:90px;' />",
	        "      <input id='bt_append' type='button' value='末尾へ追加' class='button'",
	        "       style='width:90px;' />",
	        //			"      <input id='bt_rule_update' type='button' value='設定' class='button' />",
	        "    </td>",
	        "  </tr>",
	        "  <tr id='tr_firewall_rule'>",
	        "    <th class='header'>No.</th>",
	        "    <th class='header'>サービス</th>",
	        "    <th class='header'>アクション</th>",
	        //			"    <th class='header'>ログを取る</th>",
	        "    <th class='header'>送信元アドレス:ポート</th>",
	        "    <th class='header'>転送先アドレス:ポート</th>",
	        "  </tr>",
	        "</thead>",

	        "<tbody>",

	        "<:if data.rules.length == 0:>",
	        "<tr>",
	        "  <td colspan='6' class='centering'>",
	        "    フィルタ/NAPTルールは登録されておりません。",
	        "  </td>",
	        "</tr>",
	        "<:/if:>",

	        "<:else:>",
	        "<:for i in data.rules:>",
	        "<tr>",
	        "  <td class='numeric' id='row_${i}'>${i + 1}</td>",
	        "  <% var rule = data.rules[i]; %>",
	        "  <td>",
	        "   <:if rule.svc_macro != '':>",
	        "    ${rule.svc_macro}",
	        "   <:/if:>",
	        "   <:else:>",
	        "    ${rule.svc_protocol.toUpperCase()}(${rule.svc_port})&nbsp;",
	        "   <:/else:>",
	        "  </td>",
	        "  <td>",
	        "    ${table.actions_tr[rule.action]}",
	        "  </td>",
	        "  <td>",
	        "   <:if rule.src_address + 0 != 0 :>",
	        "    ${rule.src_address}&nbsp;:&nbsp;",
	        "     <:if rule.src_port + 0 > 0:>",
	        "      ${rule.src_port}",
	        "     <:/if:>",
	        "     <:else:>",
	        "      ANY",
	        "     <:/else:>",
	        "   <:/if:>",
	        "   <:else:>",
	        "    &nbsp;",
	        "   <:/else:>",
	        "  </td>",
	        "  <td>",
	        "   <:if rule.dst_address != null:>",
	        "    ${rule.dst_address}",
	        "     <:if rule.original_dest != '':>",
	        "     (${rule.original_dest})",
	        "     <:/if:>",
	        "     <:if (rule.dst_port + 0) > 0:>",
	        "      &nbsp;:&nbsp; ${rule.dst_port}",
	        "     <:/if:>",
	        "     <:else:>",
	        "      &nbsp;",
	        "     <:/else:>",
	        "   <:/if:>",
	        "   <:else:>",
	        "    &nbsp;",
	        "   <:/else:>",
	        "  </td>",
	        "  <td class='noborder'>",
	        "    <input type='button' value='編集' class='button' style='width:50px;' ",
	        "     onClick='mod_shorewall.onEditRulesRow(this)' />",
	        "    <input type='button' value='削除' class='button' style='width:50px;' ",
	        "     onClick='mod_shorewall.onEraseRulesRow(this)' />",
	        "  </td>",
	        "</tr>",
	        "<:/for:>",
	        "<:/else:>",
	        "</tbody>",
	        "</table>",
	        "</div>",

	        //--------------------------
	        // 1対1NAT設定
	        //--------------------------
	        "<div class='dhtmlgoodies_aTab'>",
	        "<h2>1対1NAT設定</h2><br/>",
	        "<table id='nat_table' class='zebra'>",
	        "<thead>",
	        "<tr>",
	        "<td colspan=4 class='noborderright'>",
	        "<input id='bt_nat_add' type='button' value='追加'",
	        "class='button' style='width:50px;'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>No.</th>",
	        "<th class='header'>仮想IPアドレス</th>",
	        "<th class='header'>インターフェース</th>",
	        "<th class='header'>実アドレス</th>",
	        "</tr>",
	        "</thead>",

	        "<tbody>",
	        "<:if data.nat.length == 0:>",
	        "<tr>",
	        "<td colspan='5' class='centering'>",
	        "NAT設定は登録されていません。",
	        "</td>",
	        "</tr>",
	        "<:/if:>",

	        "<:else:>",
	        "<:for i in data.nat:>",
	        "<tr>",
	        "<td class='numeric'>${i+1}</td>",
	        "<td>${data.nat[i].ext_address}</td>",
	        "<td>${data.nat[i].interface}</td>",
	        "<td>${data.nat[i].int_address}</td>",
	        "<td class='noborder'>",
	        "<input type='button' value='編集' class='button'",
	        "style='width:50px;'",
	        "onClick='mod_shorewall.onEditNatRow(${i})'/>",
	        "<input type='button' value='削除' class='button'",
	        "style='width:50px;'",
	        "onClick='mod_shorewall.onEraseNatRow(${i})'/>",
	        "</td>",
	        "</tr>",
	        "<:/for:>",
	        "<:/else:>",
	        "</tbody>",
	        "</table>",
	        "</div>",

	        "</div>"
	    ].join("\n"),
	    //------------------------------
	    // Event Handlers
	    //------------------------------
	    handlers : [
	        //----------------
	        // [Tab No.1]
	        [
		        'use_fw', 'click', function(evt) {
		            var use_fw = $('use_fw').checked;

		            mod_shorewall.data.data.settings.use_fw = use_fw;
		        }
	        ],
	        [
		        // 全体設定の反映
		        'bt_update', 'click', function(evt) {
		            mod_shorewall.show_indicator();
		            mod_shorewall.PUTdata();
		        }
	        ],
	        //----------------
	        // [Tab No.2] Zone

	        //----------------
	        // [Tab No.3] NAPT
	        [
		        // Add NAPT
		        'bt_napt_add', 'click', function(evt) {
		            mod_shorewall.onEditNAPT(-1);
		        }
	        ],

	        //----------------
	        // [Tab No.4] Rule
	        [
		        // 先頭へルール追加
		        'bt_insert', 'click', function(evt) {
		            //Event.stop(evt);

		            $('bt_insert').disabled = true;
		            mod_shorewall.onAddRule(0)
		            $('bt_insert').disabled = false;
		        }
	        ],
	        [
		        // 末尾へルール追加
		        'bt_append', 'click', function(evt) {
		            //Event.stop(evt);

		            $('bt_append').disabled = true;
		            mod_shorewall.onAddRule(-1)
		            $('bt_append').disabled = false;
		        }
	        ],

	        //----------------
	        // NAT
	        [
		        'bt_nat_add', 'click', function(evt) {
		            mod_shorewall.onEditNatRow(-1);
		        }
	        ]
	    ],
	    //------------------------------
	    // Tooltips
	    //------------------------------
	    tooltips : [
	        [
		        // 'Zone'
		        'th_zone', 'Note', ["ローカル側 :<br/>　ポリシー 'ACCEPT' に設定<br/>",
				                    "インターネット側 :<br/>　ポリシー 'DROP' に設定"].join('')
	        ],
	        [
		        // "Insert" button
		        'bt_insert', 'Note', 'フィルタルールを先頭へ追加します。'
	        ],
	        [
		        // "Append" button
		        'bt_append', 'Note', 'フィルタルールを末尾へ追加します。'
	        ],
	        [
		        // "Firewall rule" table
		        'tr_firewall_rule', 'Note', 'No.欄のDrag & Dropにより、フィルタルールの並べ変えが可能です。'
	        ],
	        [
		        // --- 編集されるファイル ---
		        'help_file', 'Note', [ "下記のファイルが編集対象です。<br/>",
				                       "/etc/shorewall/*" ].join('\n')
	        ]
	    ]
    },

    // dummy data
    data : {
	    // for AJAX
	    data : {
	        // [Tab No.1]
	        settings : {
		        use_fw : true
	        },

	        // [Tab No.2] Zone Table
	        interfaces : {},

	        // [Tab No.3] NAPT Table
	        napt : {},

	        // [Tab No.4] Rule Table
	        rules : {},

	        // NAT
	        nat : {}
	    },
	    
	    table : {
	        actions_tr : { 'ACCEPT' : '許可',
			               'REJECT' : '拒否',
			               'DNAT'   : 'ポート転送'
			               //						   'DROP'   : '無視(DROP)'
			             },
	        zone_tr : { 'loc' : 'ローカル側',
			            'net' : 'インターネット側'
			            //						'dmz' : 'DMZ'
		              }
	    }
    },

    // status
    status : {
	    addRow   : 0,
	    editRow  : 0,
	    eraseRow : 0
    },

    // window
    win : {
	    naptDialog : null,
	    ruleDialog : null,
	    natDialog : null
    },

    //--------------------------------------------
    // [Tab No.3] "Add/Edit NAPT" Dialog
    //--------------------------------------------
    template_editNAPT : {
	    HTMLtemplate : [
	        "<center>",
	        "<h2>NAPT 編集</h2>",
	        "<form>",
	        "<table class='zebra'>",
	        "<tr>",
	        " <th class='header'>変換先(dst) I/F</th>",
	        " <td class='noborder'>",
	        "  <select name='sel_dst_if' id='sel_dst_if' class='select'",
	        "   style='width:80px;' />",
	        "  <:for idx in interfaces:>",
	        "   <option value='${idx}'",
	        "    <:if dst==idx:>selected='selected'<:/if:>",
	        "   >${interfaces[idx].name}</option>",
	        "  <:/for:>",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        " <th class='header'>変換元(src) I/F</th>",
	        " <td class='noborder'>",
	        "  <select name='sel_src_if' id='sel_src_if' class='select'",
	        "   style='width:80px;' />",
	        "  <:for idx in interfaces:>",
	        "   <option value='${idx}'",
	        "    <:if src==idx:>selected='selected'<:/if:>",
	        "   >${interfaces[idx].name}</option>",
	        "  <:/for:>",
	        " </td>",
	        "</tr>",
	        "<tr>",
	        "<td colspan=2 class='noborderright'>",
	        " <input type='button' id='bt_napt_ok' value='OK' class='button' />",
	        " <input type='button' id='bt_napt_cancel' value='Cancel' class='button' />",
	        "</td>",
	        "</tr>",
	        "</table>",
	        "</form>",
	        "</center>"
	    ].join('\n'),
	    //------------------------------
	    // Event Handlers
	    //------------------------------
	    handlers : [
	        [
		        // Edit OK
		        'bt_napt_ok', 'click', function() {
		            mod_shorewall.onNAPTEditOK();
		        }],
	        [
		        // Edit Cancel
		        'bt_napt_cancel', 'click', function() {
		            Windows.close('naptDialog');
		        }]
	    ]
    },

    editNAPT_data : {
	    action : 'add',
	    src : 0,
	    dst : 1,
	    interfaces : {}
    },

    //--------------------------------------------
    // [Tab No.4] "Add/Edit Rule" Dialog
    //--------------------------------------------
    template_addRule : {
	    HTMLtemplate : [
	        "<center>",
	        "<h2>フィルタ/NAPTルール編集</h2><br/>",
	        "<form>",
	        "<table class='zebra'>",
	        "  <tr>",
	        "    <th class='header' id='th_sel_service'>サービス</th>",
	        "    <td class='noborder'>",
	        "     <select name='sel_service' id='sel_service' class='select'",
	        "      style='width:100%;' tabindex='1'>",
	        "     <% var macro = setting.svc_macro; %>",
	        "     <:for i in services:>",
	        "      <option value=${i} ",
	        "       <:if operation=='new' && i == 0:>",
	        "        selected='selected'",
	        "       <:/if:>",
	        "       <:elseif operation=='edit':>",
	        "        <:if (macro == '' && i == 0) || macro == services[i]:>",
	        "         selected='selected'",
	        "        <:/if:>",
	        "       <:/elseif:> >${services[i]}",
	        "      </option>",
	        "     <:/for:>",
	        "     </select>",
	        "    </td>",
	        "  </tr>",
	        "  <tr id='tr_port'",
	        "   <:if setting.svc_macro != '':>style='display:none;'<:/if:> >",
	        "    <th class='header' id='th_portNo'>ポート番号</th>",
	        "    <td class='noborder'>",
	        "      <input type='text' id='portNo' style='width:100%;' ",
	        "       value='${setting.svc_port}'",
	        "      <:if operation == 'edit' && macro != '':>",
	        "       disabled='disabled'",
	        "      <:/if:>",
	        "      <:else:>",
	        "       tabindex='2'",
	        "      <:/else:> />",
	        "    </td>",
	        "  </tr>",
	        "  <tr id='tr_proto'",
	        "   <:if setting.svc_macro != '':>style='display:none;'<:/if:> >",
	        "    <th class='header' id='th_sel_protocol'>プロトコル</th>",
	        "    <td class='noborder'>",
	        "     <select id='sel_protocol' class='select' style='width:100%;'",
	        "      <:if operation == 'edit' && macro != '':>",
	        "        disabled='disabled'",
	        "      <:/if:>",
	        "      <:else:>",
	        "       tabindex='3'",
	        "      <:/else:> >",
	        "     <:for i in protocols:>",
	        "      <option value=${i} ",
	        "       <:if operation=='new' && i == 0:>",
	        "        selected='selected'",
	        "       <:/if:>",
	        "       <:elseif operation=='edit':>",
	        "        <% var protocol = setting.svc_protocol; %>",
	        "        <:if macro == '' && protocol.toUpperCase() == protocols[i].toUpperCase():>",
	        "         selected='selected'",
	        "        <:/if:>",
	        "       <:/elseif:> >${protocols[i].toUpperCase()}",
	        "       </option>",
	        "      <:/for:>",
	        "      </select>",
	        "    </td>",
	        "  </tr>",
	        "  <tr>",
	        "    <th class='header' id='th_sel_action'>アクション</th>",
	        "    <td class='noborder'>",
	        "     <select name='sel_action' id='sel_action' class='select'",
	        "      style='width:100%;' tabindex='4'>",
	        "     <% var action = setting.action; %>",
	        "     <:for i in actions :>",
	        "      <option value=${i} ",
	        "       <:if operation=='new' && i == 0:>",
	        "        selected='selected'",
	        "       <:/if:>",
	        "       <:elseif operation=='edit':>",
	        "        <:if (action == '' && i == 0) || action == actions[i]:>",
	        "         selected='selected'",
	        "        <:/if:>",
	        "       <:/elseif:> >${actions_tr[i]}",
	        "      </option>",
	        "     <:/for:>",
	        "     </select>",
	        "    </td>",
	        "  </tr>",
	        "  <tr>",
	        "    <th colspan='2' class='header' id='th_src_info'>送信元</th>",
	        "  </tr>",
	        "  <tr>",
	        "    <th class='header' id='th_src_address'>アドレス</th>",
	        "    <td class='noborder'>",
	        "      <input type='text' id='src_address'",
	        "      <:if setting.src_address != '':>",
	        "      value='${setting.src_address}'",
	        "      <:/if:> tabindex='6'/>",
	        "    </td>",
	        "  </tr>",
	        "  <tr>",
	        "    <th class='header' id='th_src_port'>ポート</th>",
	        "    <td class='noborder'>",
	        "      <input type='text' id='src_port'",
	        "      <:if setting.src_port != '':>",
	        "      value='${setting.src_port}'",
	        "      <:/if:> tabindex='7'/>",
	        "    </td>",
	        "  </tr>",
	        "  <tr>",
	        "    <th colspan='2' class='header' id='th_dst_info'>転送先</th>",
	        "  </tr>",
	        "  <tr>",
	        "    <th class='header' id='th_dst_address'>アドレス</th>",
	        "    <td class='noborder'>",
	        "      <input type='text' id='dst_address'",
	        "      <:if setting.dst_address != '':>",
	        "      value='${setting.dst_address}'",
	        "      <:/if:> tabindex='8'/>",
	        "    </td>",
	        "  </tr>",
	        "  <tr>",
	        "    <th class='header' id='th_dst_port'>ポート</th>",
	        "    <td class='noborder'>",
	        "      <input type='text' id='dst_port'",
	        "      <:if setting.dst_port != '':>",
	        "      value='${setting.dst_port}'",
	        "      <:/if:> tabindex='9'/>",
	        "    </td>",
	        "  </tr>",
	        "  <tr>",
	        "    <th class='header' id='th_original_dest'>変換前アドレス</th>",
	        "    <td class='noborder'>",
	        "      <input type='text' id='original_dest'",
	        "      <:if setting.original_dest != '':>",
	        "      value='${setting.original_dest}'",
	        "      <:/if:> tabindex='10'/>",
	        "    </td>",
	        "  </tr>",
	        "  <tr>",
	        "    <td colspan='2' class='noborderright'>",
	        "      <input type='button' id='bt_ok' value='OK'",
	        "       class='button' tabindex='11'/>",
	        "      <input type='button' id='bt_cancel' value='Cancel'",
	        "       class='button' tabindex='12'/>",
	        "    </td>",
	        "  </tr>",
	        "</table>",
	        "</form></center>"
	    ].join("\n"),
	    //------------------------------
	    // Event Handlers
	    //------------------------------
	    handlers : [
	        [
		        // SELECT "Service" changes
		        'sel_service', 'change', function() {
		            mod_shorewall.updateRuleDialog();
		        }],
	        [
		        // SELECT "Action" changes
		        'sel_action', 'change', function() {
		            mod_shorewall.updateRuleDialog();
		        }],
	        [
		        // Button "Ok" clicked
		        'bt_ok', 'click', function() {
		            $('bt_ok').disabled = true;

		            mod_shorewall.onRuleEditOk();
		        }],
	        [
		        // Button "Cancel" clicked
		        'bt_cancel', 'click', function() {
		            $('bt_cancel').disabled = true;

		            Windows.close('ruleDialog');
		        }]
	    ],
	    //------------------------------
	    // Tooltips
	    //------------------------------
	    tooltips : [
	        [
		        'th_sel_service', 'Note', [ "マクロで指定する場合、プロトコル名を選択して下さい。<br/>",
					                        "マニュアルで指定する場合、'Port/Protocol' を選択し、",
					                        "下の'ポート番号' 'プロトコル' にて指定して下さい。" ].join('')
	        ]
	    ]
    },

    // rules
    addRule_data : {
	    ruleNo : 0,
	    operation : 'new',
	    services : [ 'Port/Protocol', 'Amanda', 'Auth', 'BitTorrent', 'CVS', 'DNS',
		             'Distcc','Edonkey', 'FTP', 'Finger', 'GRE', 'Gnutella',
		             'HTTP', 'HTTPS', 'ICQ', 'IMAP', 'IMAPS', 'IPIP', 'IPP',
		             'IPPserver', 'IPsec', 'IPsecah', 'IPsecnat', 'Jetdirect',
		             'L2TP', 'LDAP', 'LDAPS', 'MySQL', 'NNTP', 'NNTPS', 'NTP', 'NTPbrd',
		             'PCA', 'POP3', 'POP3S', 'Ping', 'PostgreSQL', 'Printer', 'RDP',
		             'Rdate', 'Rsync', 'SMB', 'SMBBI', 'SMBswat', 'SMTP', 'SMTPS',
		             'SNMP', 'SPAMD', 'SSH', 'SVN', 'SixXS', 'Submission', 'Syslog',
		             'TFTP', 'Telnet', 'Telnets', 'Time', 'VNC', 'VNCL', 'Web',
		             'Webmin','Whois' ],
	    protocols : [ 'TCP', 'UDP', 'ICMP' ],
	    //		actions : [ 'ACCEPT', 'DROP', 'REJECT', 'DNAT' ],
	    actions : [ 'ACCEPT', 'REJECT', 'DNAT' ],
	    //		actions_tr: [ '許可(ACCEPT)', '無視(DROP)', '拒否(REJECT)', 'ポート転送(DNAT)' ],
	    actions_tr: [ '許可(ACCEPT)', '拒否(REJECT)', 'ポート転送(DNAT)' ],
	    setting : {

	    }
    },

    //--------------------------------------------
    // NAPT Dialog
    //--------------------------------------------
    template_editNAT : {
	    HTMLtemplate : [
	        "<center>",
	        "<h2>1対1NAT 編集</h2>",
	        "<form>",
	        "<table class='zebra'>",
	        "<tr>",
	        "<th class='header'>仮想IPアドレス</th>",
	        "<td class='noborder'>",
	        "<input type='text' id='ext_address' ",
	        "value='${setting.ext_address}'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>インターフェース</th>",
	        "<td class='noborder'>",
	        "<select name='sel_ext_if' id='sel_ext_if' class='select'",
	        "style='width:80px;'/>",
	        "<:for idx in interfaces:>",
	        "<option value='${interfaces[idx].name}'",
	        "<:if setting.interface == interfaces[idx].name:>",
	        "selected='selected'",
	        "<:/if:>",
	        ">${interfaces[idx].name}</option>",
	        "<:/for:>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<th class='header'>実アドレス</th>",
	        "<td class='noborder'>",
	        "<input type='text' id='int_address' ",
	        "value='${setting.int_address}'/>",
	        "</td>",
	        "</tr>",
	        "<tr>",
	        "<td colspan=2 class='noborderright'>",
	        "<input type='button' id='bt_nat_ok' value='OK'",
	        "class='button'/>",
	        "<input type='button' id='bt_nat_cancel' value='Cancel'",
	        "class='button'/>",
	        "</td>",
	        "</tr>",
	        "</table>",
	        "</form>",
	        "</center>",
	    ].join(' '),

	    //------------------------------
	    // Event Handlers
	    //------------------------------
	    handlers : [
	        [
		        // Edit OK
		        'bt_nat_ok', 'click', function() {
		            mod_shorewall.onNATEditOK();
		        }
	        ],
	        [
		        // Edit Cancel
		        'bt_nat_cancel', 'click', function() {
		            Windows.close('natDialog');
		        }
	        ]
	    ]
    },

    editNAT_data : {
	    natNo : 0,
	    operation : 'add',
	    setting : {}
    },

    //--------------------------------------------
    // Initialize
    //--------------------------------------------
    init : function(elem) {
	    var auth_data;
	    this.elem = elem;

	    // Auth check
	    auth_data = mod_auth.getAccountInfo();
	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);

	        return;
	    }

	    if (!this.validator)
	        this.validator = new validateUtil();

	    this.createNAPTDialog();	// Tab No.3
	    this.createRuleDialog();	// Tab No.4
	    this.createNATDialog();

	    this.elem.module = this;

	    // Initial data
	    this.GETdata();
    },

    //--------------------------------------------
    // Destructor
    //--------------------------------------------
    exit : function() {
	    if (this.win.naptDialog != null) {
	        debug("destructor: naptDialog.destroy()");
	        this.win.naptDialog.destroy();
	        this.win.naptDialog = null;
	    }
	    if (this.win.ruleDialog != null) {
	        debug("destructor: ruleDialog.destroy()");
	        this.win.ruleDialog.destroy();
	        this.win.ruleDialog = null;
	    }
	    if (this.win.natDialog != null) {
	        debug("destructor: natDialog.destroy()");
	        this.win.natDialog.destroy();
	        this.win.natDialog = null;
	    }
    },

    //--------------------------------------------
    // Render HTML (Main)
    //--------------------------------------------
    render : function(pane) {
	    var table, tableDnD, html, parser, template;

	    template = this.template_main;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    if (!pane || pane == undefined)
	        pane = 0;

	    initTabs('dhtmlgoodies_tabView1',
		         //				 Array('全体設定', 'ゾーン設定', 'NAPT設定', 'ルール設定'),
		         //				 pane, 600, "", Array(false, false, false, false));
		         Array('ゾーン設定', 'NAPT設定', 'ルール設定', '1対1NAT設定'),
		         pane, 600, "", Array(false, false, false, false));

	    set_handlers(template);
	    set_tooltips(template, true);

	    if (this.data.data.rules.length > 1) {
	        table = $('firewall_rule');
	        tableDnD = new TableDnD();

	        tableDnD.init(table);
	        tableDnD.onDrop = this.onDropRulesRow;
	    }
    },

    //================================================================
    //
    // Ajax Functions
    //
    //================================================================

    //--------------------------------------------
    // GET all firewall settings
    //--------------------------------------------
    GETdata : function() {
	    this.GET_interfaces(true);
    },

    //--------------------------------------------
    // GET Zone information
    //--------------------------------------------
    GET_interfaces : function(chain) {
	    var auth_data;
	    var url, params, configs, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/firewall/interface";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @GET_interfaces (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("GET_interfaces: %s", httpObj.responseText));

		        result = eval("(" + httpObj.responseText + ")");

		        this.data.data.interfaces = result['interface'];

		        if (chain == true)
		            mod_shorewall.GET_napt(true);
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // Update Zone information
    //--------------------------------------------
    PUT_interfaces : function(chain) {
	    var auth_data;
	    var url, params, configs, wsse_header;
	    var data = {}, json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/firewall/interface";

	    json = Object.toJSON({interface : mod_shorewall.data.data.interfaces})
	    debug($jq.sprintf("PUT_interfaces: json = '%s'", json));

	    params = {
	        method: "PUT",
	        contentType: 'application/json',
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @PUT_interfaces (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("PUT_interfaces: %s", httpObj.responseText));
		        result = eval("(" + httpObj.responseText + ")");

		        if (chain == true)
		            this.PUT_napt(true);
		        else
		            this.hide_indicator();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // GET NAPT information
    //--------------------------------------------
    GET_napt : function(chain) {
	    var auth_data;
	    var url, params, configs, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/firewall/masq";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @GET_napt (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("GET_napt: %s", httpObj.responseText));

		        result = eval("(" + httpObj.responseText + ")");

		        this.data.data.napt = result['masq'];

		        if (chain == true)
		            mod_shorewall.GET_rules(true);
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // PUT NAPT information
    //--------------------------------------------
    PUT_napt : function(chain) {
	    var auth_data;
	    var url, params, configs, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/firewall/masq";

	    json = Object.toJSON({masq : mod_shorewall.data.data.napt})
	    debug($jq.sprintf("PUT_napt: json = '%s'", json));

	    params = {
	        method: "PUT",
	        contentType: 'application/json',
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @PUT_napt (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("PUT_napt: %s", httpObj.responseText));
		        result = eval("(" + httpObj.responseText + ")");

		        if (chain == true)
		            mod_shorewall.PUT_rules(true);
		        else
		            mod_shorewall.hide_indicator();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // GET Rules information
    //--------------------------------------------
    GET_rules : function(chain) {
	    var auth_data;
	    var url, params, configs, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/firewall/rule";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @GET_rules (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("GET_rules: %s", httpObj.responseText));

		        result = eval("(" + httpObj.responseText + ")");

		        this.data.data.rules = result['rule'];

		        if (chain == true)
		            mod_shorewall.GET_nat(true);
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // PUT Rules information
    //--------------------------------------------
    PUT_rules : function(chain) {
	    var auth_data;
	    var url, params, configs, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/firewall/rule";

	    json = Object.toJSON({rule : mod_shorewall.data.data.rules})
	    debug($jq.sprintf("PUT_rules: json = '%s'", json));

	    params = {
	        method: "PUT",
	        contentType: 'application/json',
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @PUT_rules (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("PUT_rules: %s", httpObj.responseText));
		        result = eval("(" + httpObj.responseText + ")");

		        if (chain == true)
		            this.PUT_nat(true);
		        else
		            mod_shorewall.hide_indicator();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // GET nat information
    //--------------------------------------------
    GET_nat : function(chain) {
	    var auth_data;
	    var url, params, configs, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/firewall/nat";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @GET_nat (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("GET_nat: %s", httpObj.responseText));

		        result = eval("(" + httpObj.responseText + ")");

		        this.data.data.nat = result['nat'];

		        if (chain == true)
		            mod_shorewall.GET_confs(true);
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // PUT NAT configurations
    //--------------------------------------------
    PUT_nat : function(chain) {
	    var auth_data;
	    var url, params, configs, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/firewall/nat";

	    json = Object.toJSON({nat : mod_shorewall.data.data.nat});
	    debug($jq.sprintf("PUT_nat: json = '%s'", json));

	    params = {
	        method: "PUT",
	        contentType: 'application/json',
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @PUT_nat (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("PUT_nat: %s", httpObj.responseText));
		        result = eval("(" + httpObj.responseText + ")");

		        if (chain == true)
		            this.PUT_confs();
		        else
		            mod_shorewall.hide_indicator();
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // GET generic configurations
    //--------------------------------------------
    GET_confs : function(render) {
	    var auth_data;
	    var url, params, configs, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/firewall/conf";

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @GET_confs (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result;

		        debug($jq.sprintf("GET_confs: %s", httpObj.responseText));

		        result = eval("(" + httpObj.responseText + ")");

		        this.data.data.settings = result['conf'];

		        if (render == true)
		            mod_shorewall.render(0);
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // PUT generic configurations
    //--------------------------------------------
    PUT_confs : function() {
	    var auth_data;
	    var url, params, configs, wsse_header;
	    var json;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = "/service/conf/net/firewall/conf";

	    json = Object.toJSON({conf : mod_shorewall.data.data.settings})
	    debug($jq.sprintf("PUT_confs: json = '%s'", json));

	    params = {
	        method: "PUT",
	        contentType: 'application/json',
	        postBody: json,
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header,
		        'Content-type', 'application/json'
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        switch (status) {
		        case 401:
		            alert("Authentication failed @PUT_confs (401)");
		            load_module('auth', 'content', true);
		            break;

		        default:
		            alert($jq.sprintf("Error %d", status));
		            break;
		        }
	        },
	        onSuccess: function(httpObj) {
		        var result;

		        this.hide_indicator();

		        debug($jq.sprintf("PUT_confs: %s", httpObj.responseText));
		        result = eval("(" + httpObj.responseText + ")");

		        alert("ファイアウオール設定を更新しました。");
	        }.bind(this)
	    };

	    new Ajax.Request(url, params);
    },

    //--------------------------------------------
    // PUT all Firewall configurations
    //--------------------------------------------
    PUTdata : function() {
	    this.PUT_interfaces(true);
    },

    //--------------------------------------------
    // show / hide indicator
    //--------------------------------------------
    showIndicator : function() {
	    $('indicator').style.visibility = 'visible';
    },

    hideIndicator : function() {
	    $('indicator').style.visibility = 'hidden';
    },

    //--------------------------------------------
    // Enable / Disable button
    //--------------------------------------------
    enable_button : function(button_id) {
	    var button = $(button_id);

	    if (button != undefined)
	        button.disabled = false;
    },

    disable_button : function(button_id) {
	    var button = $(button_id);

	    if (button != undefined)
	        button.disabled = true;
    },

    //================================================================
    //
    // Utility functions
    //
    //================================================================

    // Firewall 設定中
    show_indicator : function() {
	    $('use_fw').disabled = true;
	    $('bt_update').disabled = true;
	    $('indicator').style.visibility = 'visible';
    },

    // Firewall 設定完了
    hide_indicator : function() {
	    $('bt_update').disabled = false;
	    $('use_fw').disabled = false;
	    $('indicator').style.visibility = 'hidden';
    },

    //================================================================
    //
    // Event Handlers (Main)
    //
    //================================================================

    //--------------------------------------------
    // [Tab No.2] Zone Change handler
    //--------------------------------------------
    onChangeZone : function(idx) {
	    var new_zone;

	    new_zone = $($jq.sprintf('sel_zone_%d', idx)).value;
	    mod_shorewall.data.data.interfaces[idx].zone = new_zone;
    },

    //--------------------------------------------
    // [Tab No.3] add/edit NAPT handler
    //--------------------------------------------
    onEditNAPT : function(idx) {
	    var action, data, editNAPT_data;

	    data = mod_shorewall.data.data;

	    editNAPT_data = mod_shorewall.editNAPT_data;
	    editNAPT_data.interfaces = mod_shorewall.data.data.interfaces;

	    if (idx == -1) {
	        action = 'add';
	        editNAPT_data.src   = 0;
	        editNAPT_data.dst   = 1;
	        editNAPT_data.place = data.napt.length;
	    } else {
	        action = 'edit';
	        editNAPT_data.src   = this.searchIFindex(editNAPT_data.interfaces, data.napt[idx].src_if);
	        editNAPT_data.dst   = this.searchIFindex(editNAPT_data.interfaces, data.napt[idx].dst_if);
	        editNAPT_data.place = idx;
	    }

	    editNAPT_data.action = action;

	    this.naptDialog();
    },

    //--------------------------------------------
    // [Tab No.3] erase NAPT handler
    //--------------------------------------------
    onEraseNAPT : function(idx) {
	    var msg, data;

	    data = mod_shorewall.data.data;
	    msg = $jq.sprintf("No.%d の NAPT ルールを\n消してよろしいですか ?", (idx + 1));

	    if (confirm(msg)) {
	        data.napt = data.napt.removeByIndex(idx);
	        //			this.render(2);
	        this.render(1);
	    }
    },

    // internal function
    searchIFindex : function(table, intf) {
	    var idx;

	    for (idx in table) {
	        if (table[idx].name == intf)
		        return idx;
	    }

	    return -1;
    },

    //--------------------------------------------
    // [Tab No.3] Add/Edit NAPT Dialog "OK" handler
    //--------------------------------------------
    onNAPTEditOK : function() {
	    var src_idx, dst_idx, interfaces, action, idx;
	    var data;
	    var entry = {};

	    interfaces = mod_shorewall.data.data.interfaces;

	    src_idx = parseInt($('sel_src_if').value, 10);
	    dst_idx = parseInt($('sel_dst_if').value, 10);

	    action = mod_shorewall.editNAPT_data.action;
	    idx    = mod_shorewall.editNAPT_data.place;

	    entry.src_if = interfaces[src_idx].name;
	    entry.dst_if = interfaces[dst_idx].name;

	    // shortcut
	    data = this.data.data;

	    if (action == 'add')
	        data.napt = data.napt.insertByIndex(idx, entry);
	    else
	        data.napt = data.napt.replaceByIndex(idx, entry);

	    Windows.close('naptDialog');

	    //		this.render(2);
	    this.render(1);
    },

    //--------------------------------------------
    // [Tab No.4] Rules Table row onDrop handler
    //--------------------------------------------
    onDropRulesRow : function(table, droppedRow) {
	    var i, rows, rule_no, new_rules, old_rules;

	    rows = $('firewall_rule').tBodies[0].rows;
	    new_rules = new Array();
	    old_rules = mod_shorewall.data.data.rules;

	    for (i = 0; i < rows.length; i++) {
	        rule_no = rows[i].cells[0].innerHTML - 1;

	        new_rules.push(old_rules[rule_no]);
	        rows[i].cells[0].innerHTML = i + 1;
	    }

	    mod_shorewall.data.data.rules = new_rules;
    },

    //--------------------------------------------
    // [Tab No.4] Rules Table Row Erase handler
    //--------------------------------------------
    onEraseRulesRow : function(eraseRow) {
	    var rule_no, row, params, msg;
	    var data;

	    if (mod_shorewall.editOK("erase") == false)
	        return;

	    // 削除中
	    //this.status.eraseRow = true;

	    Element.extend(eraseRow);
	    row = eraseRow.up().up();
	    rule_no = row.rowIndex - 2;

	    new Effect.Fade(row);

	    // shortcut
	    data = mod_shorewall.data;

	    params = {
	        className : "alphacube",
	        width: 300,
	        showEffect : Element.show,
	        hideEffect : Element.hide,

	        onOk : function() {
		        //debug("Confirm: OK");
		        data.data.rules = data.data.rules.removeByIndex(rule_no);
		        //				mod_shorewall.render(3);
		        mod_shorewall.render(2);

		        mod_shorewall.status.eraseRow = 0;
		        return true;
	        },
	        onCancel : function() {
		        //debug("Confirm: Cancel");
		        new Effect.Appear(row);

		        mod_shorewall.status.eraseRow = 0;
		        return true;
	        }
	    };

	    msg = "No." + (rule_no + 1) + " のルールを<br/>消してよろしいですか ?"
	    Dialog.confirm(msg, params);
    },

    //--------------------------------------------
    // [Tab No.4] Rules Table Row Edit handler
    //--------------------------------------------
    onEditRulesRow : function(editRow) {
	    var ruleNo, addRule;

	    if (mod_shorewall.editOK("edit") == false)
	        return;

	    // 編集中
	    //this.status.editRow = true;

	    Element.extend(editRow);
	    ruleNo = editRow.up().up().rowIndex - 2;

	    //debug($jq.sprintf("onEditRow: ruleNo = %d", ruleNo));

	    addRule = mod_shorewall.addRule_data;

	    addRule.operation = 'edit';
	    addRule.ruleNo    = ruleNo;
	    addRule.setting   = Object.clone(mod_shorewall.data.data.rules[ruleNo]);

	    mod_shorewall.ruleDialog();

	    this.status.editRow = 0;
    },

    //--------------------------------------------
    // Add rule handler
    //--------------------------------------------
    onAddRule : function(place) {
	    var where;
	    var addRule_data;

	    if (mod_shorewall.editOK("add") == false)
	        return;

	    // 追加中
	    //this.status.addRow = true;
	    
	    // disable insert/append buttons
	    $('bt_insert').disabled = true;
	    $('bt_append').disabled = true;

	    if (place == -1)
	        where = this.data.data.rules.length;
	    else
	        where = 0;

	    // shortcut
	    addRule_data = this.addRule_data;

	    // initialize rules
	    addRule_data.ruleNo    = where;
	    addRule_data.operation = 'new';
	    addRule_data.setting   = {
	        service : {
		        macro : '',
		        port  : '',
		        protocol : ''
	        },
	        action  : '',
	        logging : false,
	        source  : {
		        address : '',
		        port    : ''
	        },
	        dest    : {
		        address : '',
		        port    : ''
	        }
	    };

	    mod_shorewall.ruleDialog();

	    // enable insert/append buttons
	    $('bt_insert').disabled = false;
	    $('bt_append').disabled = false;

	    this.status.addRow = 0;
    },

    //--------------------------------------------
    // Add/Edit/Erase OK?
    //--------------------------------------------
    editOK : function(action) {
	    var atomic = 0;

	    if (action == 'add')
	        atomic += ++(this.status.addRow);
	    else
	        atomic += this.status.addRow;

	    if (action == 'edit')
	        atomic += ++(this.status.editRow);
	    else
	        atomic += this.status.editRow;

	    if (action == 'erase')
	        atomic += ++(this.status.eraseRow);
	    else
	        atomic += this.status.eraseRow;

	    if (atomic != 1) {
	        alert("editOK: add/edit/erase now!");
	        return false;
	    }

	    return true;
    },

    //--------------------------------------------
    // NAT Table Row Edit handler
    //--------------------------------------------
    onEditNatRow : function(idx) {
	    var info;

	    info = mod_shorewall.editNAT_data;
	    info.interfaces = mod_shorewall.data.data.interfaces;

	    if (idx < 0) {
	        info.operation = 'add';
	        info.natNo = mod_shorewall.data.data.nat.length;
	        info.setting = {
		        'ext_address' : '',
		        'interface' : '',
		        'int_address' : ''
	        };
	    } else {
	        info.operation = 'edit';
	        info.natNo = idx;
	        info.setting = Object.clone(mod_shorewall.data.data.nat[idx]);
	    }
	    mod_shorewall.natDialog();
    },

    onEraseNatRow : function(idx) {
	    var data;

	    data = mod_shorewall.data.data;

	    if (confirm($jq.sprintf("No.%dのNATルールを\n消してよろしいですか?",
			                (idx + 1)))) {
	        data.nat = data.nat.removeByIndex(idx);
	        this.render(3);
	    }
    },

    //================================================================
    //
    // Dialog Functions
    //
    //================================================================

    //--------------------------------------------
    // [Tab No.3] Create Add/Edit NAPT Dialog
    //--------------------------------------------
    createNAPTDialog : function() {
	    var params;

	    params = {
	        //			className   : "mac_os_x",
	        className   : "alphacube",
	        title       : "Add/Edit NAPT",
	        width       : 220,
	        height      : 140,
	        resizable   : false,
	        closable    : true,
	        minimizable : false,
	        maximizable : false,
	        showEffect  : Element.show,
	        hideEffect  : Element.hide,

	        destroyOnClose: false
	    };

	    this.win.naptDialog = new Window('naptDialog', params);
    },

    //--------------------------------------------
    // [Tab No.3] Show Add/Edit NAPT Dialog
    //--------------------------------------------
    naptDialog : function() {
	    var win, params, parser, template, html;

	    win = this.win.naptDialog;

	    if (win == null)
	        return;
	    else
	        this.win.naptDialog = null;

	    template = this.template_editNAPT;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(mod_shorewall.editNAPT_data);

	    win.getContent().innerHTML = html;

	    set_handlers(template);
	    //		set_tooltips(template, false);

	    win.showCenter(true);	// Modal window

	    this.win.naptDialog = win;
    },

    //--------------------------------------------
    // [Tab No.4] Create Add/Edit rule Dialog
    //--------------------------------------------
    createRuleDialog : function() {
	    var params;

	    params = {
	        //			className   : "mac_os_x",
	        className   : "alphacube",
	        title       : "Add/Edit Firewall Rule",
	        width       : 360,
	        height      : 400,
	        resizable   : false,
	        closable    : true,
	        minimizable : false,
	        maximizable : false,
	        showEffect  : Element.show,
	        hideEffect  : Element.hide,

	        destroyOnClose: false
	    };

	    this.win.ruleDialog = new Window('ruleDialog', params);
    },

    //--------------------------------------------
    // [Tab No.4] show Add/Edit rule Dialog
    //--------------------------------------------
    ruleDialog : function() {
	    var win, params, parser, template, html;

	    win = this.win.ruleDialog;

	    if (win == null)
	        return;
	    else
	        this.win.ruleDialog = null;

	    template = this.template_addRule;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.addRule_data);

	    win.getContent().innerHTML = html;

	    set_handlers(template);
	    set_tooltips(template, false);

	    win.showCenter(true);	// Modal window

	    this.updateRuleDialog();

	    this.win.ruleDialog = win;
    },

    //--------------------------------------------
    // [Tab No.4] Finish Add/Edit rule
    //--------------------------------------------
    onRuleEditOk : function() {
	    var newRule, val, where, operation;
	    var services, protocols, action_value, actions;
	    var data;

	    if (mod_shorewall.validate_ruleDialog() == false) {
	        $('bt_ok').disabled = false;
	        return false;
	    }

	    newRule   = new Object();
	    services  = this.addRule_data.services;
	    protocols = this.addRule_data.protocols;
	    actions   = this.addRule_data.actions;

	    // Service / Port,Protocol
	    val = parseInt($('sel_service').value, 10);

	    if (val > 0) {
	        newRule.svc_macro    = services[val];
	        newRule.svc_port     = 0;
	        newRule.svc_protocol = '';
	    } else {
	        newRule.svc_macro    = '';
	        newRule.svc_port     = parseInt($('portNo').value.strip(), 10);
	        newRule.svc_protocol = protocols[parseInt($('sel_protocol').value, 10)];
	    }

	    // Action
	    action_value   = parseInt($('sel_action').value);
	    newRule.action = actions[action_value];

	    // Logging
	    //		if ($('chk_logging') != undefined)
	    //			newRule.logging = $('chk_logging').checked;
	    //		else
	    //			newRule.logging	= false;

	    // Source Address / Port
	    newRule.src_address = strip_escapeHTML($('src_address').value);

	    val = parseInt($('src_port').value.strip(), 10);

	    if (val > 0)
	        newRule.src_port = val;
	    else
	        newRule.src_port = 0;

	    // Destination Address / Port
	    newRule.dst_address = strip_escapeHTML($('dst_address').value);
	    val = parseInt($('dst_port').value.strip(), 10);
	    if (val > 0) 
	        newRule.dst_port = val;
	    else
	        newRule.dst_port = 0;
	    newRule.original_dest = strip_escapeHTML($('original_dest').value);

	    dbgObj = Object.clone(newRule);

	    // shortcuts
	    operation = this.addRule_data.operation;
	    where     = this.addRule_data.ruleNo;
	    data      = this.data.data;

	    if (operation == 'new')
	        data.rules = data.rules.insertByIndex(where, Object.clone(newRule));
	    else
	        data.rules = data.rules.replaceByIndex(where, Object.clone(newRule));

	    Windows.close('ruleDialog');

	    //		this.render(3);
	    this.render(2);
    },

    //--------------------------------------------
    // [Tab No.4] Validate Rule Dialog
    //--------------------------------------------
    validate_ruleDialog : function() {
	    var service, portNo, protocol, action;
	    var src_address, src_port_str, src_port;
	    var dst_address, dst_port_str, src_port;
	    var errMsgArray = [], errMsg;

	    service  = parseInt($('sel_service').value, 10);
	    portNo   = parseInt($('portNo').value.strip(), 10);
	    action   = parseInt($('sel_action').value, 10);

	    src_address   = strip_escapeHTML($('src_address').value);
	    dst_address   = strip_escapeHTML($('dst_address').value);
	    src_port_str  = strip_escapeHTML($('src_port').value);
	    dst_port_str  = strip_escapeHTML($('dst_port').value);
	    src_port      = parseInt(src_port_str, 10);
	    dst_port      = parseInt(dst_port_str, 10);
	    original_dest = strip_escapeHTML($('original_dest').value);

	    debug($jq.sprintf("serivce = '%s'", service));

	    // 'Port/Protocol'
	    if (service == 0) {
	        if (portNo < 1 || portNo > 65535 || isNaN(portNo)) {
		        errMsgArray.push("・正しいポート番号を指定して下さい。");
	        }
	    }

	    // src address
	    if (src_address != "") {
	        if (this.validator.checkIPAddress(src_address) == false &&
		        this.validator.checkCIDR(src_address) == false)
		        errMsgArray.push("・送信元アドレスが不正です。");

	        // src port
	        if (src_port_str != "") {
		        if (src_port < 0 || src_port > 65535 || isNaN(src_port))
		            errMsgArray.push("・送信元ポートが不正です。");
	        }
	    } else {
	        if (src_port_str != "")
		        errMsgArray.push("・送信元ポートのみの指定はできません。");

	        // insure
	        $('src_address').value = '';
	        $('src_port').value    = '';
	    }

	    debug($jq.sprintf("action = %d", action));

	    if (dst_address != "") {
	        if (this.validator.checkIPAddress(dst_address) == false)
		        errMsgArray.push("・転送先アドレスが不正です。");

	        // dst port
	        if (dst_port_str != "")
		        if (dst_port < 0 || dst_port > 65535 || isNaN(dst_port))
		            errMsgArray.push("・転送先ポートが不正です。");

	        if (original_dest != "")
		        if (this.validator.checkIPAddress(original_dest) == false)
		            errMsgArray.push("・変換前アドレスが不正です。");
	    } else {
	        // insure
	        $('dst_address').value   = '';
	        $('dst_port').value      = '';
	        $('original_dest').value = '';
	    }

	    debug(errMsgArray.length);

	    if (errMsgArray.length > 0) {
	        errMsg = errMsgArray.join("\n");

	        alert(errMsg);
	        return false;
	    }

	    return true;
    },

    //--------------------------------------------
    // NAT Dialog
    //--------------------------------------------
    createNATDialog : function() {
	    var params;

	    params = {
	        className   : "alphacube",
	        title       : "Add/Edit One-to-one NAT",
	        width       : 360,
	        height      : 160,
	        resizable   : false,
	        closable    : true,
	        minimizable : false,
	        maximizable : false,
	        showEffect  : Element.show,
	        hideEffect  : Element.hide,

	        destroyOnClose: false
	    };

	    this.win.natDialog = new Window('natDialog', params);
    },

    natDialog : function() {
	    var win, parser, template, html;

	    win = this.win.natDialog;

	    if (win == null)
	        return;
	    else
	        this.win.natDialog = null;

	    template = this.template_editNAT;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(mod_shorewall.editNAT_data);

	    win.getContent().innerHTML = html;

	    set_handlers(template);

	    win.showCenter(true);

	    this.win.natDialog = win;
    },

    onNATEditOK : function() {
	    var data, action, idx;
	    var entry = {};

	    data = mod_shorewall.data.data;
	    action = mod_shorewall.editNAT_data.action;
	    idx = mod_shorewall.editNAT_data.natNo;

	    entry.ext_address = strip_escapeHTML($('ext_address').value);
	    entry.interface = strip_escapeHTML($('sel_ext_if').value);
	    entry.int_address = strip_escapeHTML($('int_address').value);

	    if (action == 'add')
	        data.nat = data.nat.insertByIndex(idx, entry);
	    else
	        data.nat = data.nat.replaceByIndex(idx, entry);

	    Windows.close('natDialog');

	    this.render(3);
    },

    //================================================================
    //
    // Event Handlers (RuleDialog)
    //
    //================================================================

    //--------------------------------------------
    // [Tab No.4] update 'INPUT' enable/disable
    //--------------------------------------------
    updateRuleDialog : function() {
	    var service, action;

	    // 'サービス'
	    service = parseInt($('sel_service').value, 10);

	    switch (service) {
	    case 0:
	        $('portNo').disabled       = false;
	        $('sel_protocol').disabled = false;
	        new Effect.Appear($('tr_port'));
	        new Effect.Appear($('tr_proto'));
	        break;

	    default:
	        $('portNo').disabled = 'disabled';
	        $('sel_protocol').disabled = 'disabled';
	        new Effect.Fade($('tr_port'));
	        new Effect.Fade($('tr_proto'));
	        break;
	    }

	    // 'アクション'
	    action = parseInt($('sel_action').value, 10);
	    //debug($jq.sprintf("action = '%d'", action));

	    /*
		  switch (action) {
		  case 0:
		  case 1:
		  // ACCEPT/REJECT
		  $('dst_address').disabled = true;
		  $('dst_port').disabled    = true;
		  $('dst_address').value    = '';
		  $('dst_port').value       = '';
		  break;

		  case 2:
		  // DNAT
		  $('dst_address').disabled = false;
		  $('dst_port').disabled    = false;
		  break;

		  default:
		  debug("BUG!");
		  break;
		  }
		*/
    }
};
