//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// サイドバー(メニュー)
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2007-2010 Century Systems Co., Ltd.
//
// Last Modified: 2010/05/28 15:07:00 kikuchi
//==============================================================================

mod_sidebar = {
    //--------------------------------------------
    // HTML template
    //--------------------------------------------
    template : {
	    HTMLtemplate : [
	        "<dl class='sidemenu' id='sidemenu'>",
	        "  <:foreach category in categories:>",
	        "    <dt id='${category.id}_dt'>",
	        "      ${category.desc}",
	        "    </dt>",
	        "    <ul id='${category.id}_ul'>",
	        "    <:foreach module in category.modules:>",
	        "     <:if module.confirmDialog==false:>",
	        "      <:if module.href==null:>",
	        "       <li id='li_${module.name}'",
	        "        onClick='mod_sidebar.loadModule(\"${module.name}\",\"${elem}\",true)'>",
	        "         ${module.title}",
	        "       </li>",
	        "      <:/if:>",
	        "      <:else:>",
	        "       <li id='li_${module.name}'",
	        "        onClick=\"location.href='${module.href}'\">",
	        "         ${module.title}",
	        "       </li>",
	        "      <:/else:>",
	        "     <:/if:>",
	        "     <:else:>",
	        "      <li",
	        "       onClick='mod_sidebar.confirmLogout(\"${module.name}\",\"${elem}\",true)'>",
	        "        ${module.title}",
	        "      </li>",
	        "     <:/else:>",
	        "    <:/foreach:>",
	        "    </ul>",
	        "  <:/foreach:>",
	        "</dl>"
	    ].join('\n')
    },

    // サイドバーメニュー定義
    data : {
	    elem : "content",
	    categories : [
	        {
		        desc : "基本設定",
		        id   : "basic",
		        modules : [
		            {
			            title : "インターフェース設定",
			            name  : "network",
			            confirmDialog : false
		            },{
			            title : "GRE設定",
			            name  : "gre",
			            confirmDialog : false
		            },{
			            title : "PPP(発信)設定",
			            name  : "ppp_out",
			            confirmDialog : false
		            },{
			            title : "PPP(着信)設定",
			            name  : "ppp_in",
			            confirmDialog : false
		            },{
 			            title : "DHCPサーバ設定",
 			            name  : "dnsmasq",
 			            confirmDialog : false
		            },{
			            title : "静的ルーティング設定",
			            name  : "routes",
			            confirmDialog : false
		            },{
			            title : "ファイアウォール設定",
			            name  : "shorewall",
			            confirmDialog : false
		                // },{
		                // 	title : "OCN IPv6設定",
		                // 	name  : "ocnipv6",
		                // 	confirmDialog : false
		            },{
			            title : "日付・時刻設定",
			            name  : "datetime",
			            confirmDialog : false
		            }
		        ]
	        },

	        // {
	        // 	desc : "モジュール設定",
	        // 	id   : "module",
	        // 	modules : [
	        // 	    {
	        // 		title : "通信モジュール設定",
	        // 		name  : "commodule",
	        // 		confirmDialog : false
	        // 	    }
	        // 	]
	        // },

	        {
		        desc : "サービス設定",
		        id   : "service",
		        modules : [
		            {
			            title : "NTP設定",
			            name  : "ntp",
			            confirmDialog : false
		            }
		        ]
	        },

	        {
 		        desc : "アプリケーション設定",
 		        id   : "application",
 		        modules : [
		            {
 			            title : "死活監視設定",
 			            name  : "monitor",
 			            confirmDialog : false
		            // },
		            // {
 		    	    //     title : "データロガー",
 		     	    //     name  : "logger",
 		     	    //     confirmDialog : false
		            }
 		        ]
	        },

	        {
		        desc : "シリアルポート設定",
		        id   : "serial",
		        modules : [
		            {
			            title : "ser2net設定",
			            name  : "ser2net",
			            confirmDialog : false
		            }
		        ]
	        },

	        {
		        desc : "保守・運用",
		        id   : "maintenance",
		        modules : [
		            {
			            title : "WebUIパスワード設定",
			            name  : "account",
			            confirmDialog : false
		            },{
			            title : "Syslog確認",
			            name  : "syslog",
			            confirmDialog : false
		            },{
			            title : "Ping疎通テスト",
			            name  : "ping",
			            confirmDialog : false
		            },{
			            title : "設定データ管理",
			            name  : "config",
			            confirmDialog : false
		            },{
			            title : "ファームウェア更新",
			            name  : "firmup",
			            confirmDialog : false
		            },{
			            title : "再起動/シャットダウン",
			            name  : "reboot",
			            confirmDialog : false
		            },{
			            title : "ログアウト",
			            name  : "auth",
			            confirmDialog : true
		            }
		        ]
	        } ]
    },

    data_module : {
	    module : '',
	    elem   : ''
    },

    //--------------------------------------------
    // Initialize
    //--------------------------------------------
    init : function(elem) {
	    var auth_data;
	    this.elem = elem;

	    this.render();
    },

    //--------------------------------------------
    // Render HTML
    //--------------------------------------------
    render : function(intf) {
	    var parser, template, html, auth_data;
	    var li_list, li, i;

	    template = this.template;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    auth_data = mod_auth.getAccountInfo();

	    if (auth_data.authorized != 'true')
	        load_module("auth", "content");

	    li_list = $$('dl.sidemenu li');

	    for (i = 0; i < li_list.length; i++) {
	        li = Element.extend(li_list[i]);

	        li.observe('mouseover', this.onMouseOver.bindAsEventListener(li));
	        li.observe('mouseout', this.onMouseOut.bindAsEventListener(li));
	    }
    },

    //==========================================================================
    //
    // Event handlers
    //
    //==========================================================================

    //------------------------------------------------------
    // Logout confirm dialog
    //------------------------------------------------------
    confirmLogout : function(module, elem, flag) {
	    var win, param;

	    if (confirm("ログアウトしてもよろしいですか？")) {
	        this.unselect_all();
	        load_module(module, elem);
	    }
	    return;
    },

    //------------------------------------------------------
    // confirmDialog --> 'OK' button handler
    //------------------------------------------------------
    confirm_OK : function() {
	    //Windows.close('confirmDialog');

	    debug($jq.sprintf("logout OK, module='%s', elem='%s'",
		              this.data_module.module, this.data_module.elem));
	    loadModule(this.data_module.module, this.data_module.elem);
    },

    //------------------------------------------------------
    // confirmDialog --> 'Cancel' button handler
    //------------------------------------------------------
    confirm_Cancel : function() {
	    debug("logout Cancel");

	    Windows.close('confirmDialog');
    },

    //------------------------------------------------------
    // Clear All <li>'s style
    //------------------------------------------------------
    unselect_all : function() {
	    var li_list, li, i;

	    li_list = $$('dl.sidemenu li');

	    for (i = 0; i < li_list.length; i++) {
	        li = li_list[i];
	        li.className = '';
	        li.className_old = '';
	    }
    },

    //------------------------------------------------------
    // load_module() wrapper
    //------------------------------------------------------
    loadModule : function(module, elem) {
	    var li_list, li, id, i, target_li;

	    li_list = $$('dl.sidemenu li');
	    target_li = $jq.sprintf("li_%s", module);

	    for (i = 0; i < li_list.length; i++) {
	        li = li_list[i];
	        id = li.id;

	        if (id == target_li) {
		        li.className = 'selected';
		        li.className_old = 'selected';
	        } else {
		        li.className = '';
		        li.className_old = '';
	        }
	    }

	    load_module(module, elem);
    },

    //------------------------------------------------------
    // <li> mouse over
    //------------------------------------------------------
    onMouseOver : function(elem) {
	    this.className_old = this.className;
	    this.className = 'mouseover';
    },

    onMouseOut : function(elem) {
	    if (this.className_old) {
	        this.className = this.className_old;
	    } else
	        this.className = '';
    }
};
