//==============================================================================
// MA-4xx/8xx/E2xx WebUI Module
//
// Syslog確認
// Author : Takeyoshi Kikuchi <kikuchi@centurysys.co.jp>
// Copyright (C) 2007-2010 Century Systems Co., Ltd.
//
// Last Modified: 2010/05/28 15:01:49 kikuchi
//==============================================================================

mod_syslog = {
    //--------------------------------------------
    // HTML template (Main)
    //--------------------------------------------
    template_main : {
	    HTMLtemplate : [
	        "<h1 class='title'>Syslog確認</h1>",
	        "<table id='tbl_select' class='zebra'>",
	        "<tr>",
	        "  <th class='header' colspan='2'>",
	        "    ログファイル選択",
	        "  </th>",
	        "</tr>",
	        "<tr>",
	        "  <td class='noborder'>",
	        "    <select id='sel_syslog' name='sel_syslog' class='select'",
	        "     style='width:180px;'>",
	        "     <:for i in kinds:>",
	        "      <option value=${i}",
	        "       <:if i==selected:>selected='selected'<:/if:>",
	        "      >${kinds[i][1]}</option>",
	        "     <:/for:>",
	        "    </select>",
	        "  </td>",
	        "  <td class='noborder'>",
	        "    <img id='indicator' src='img/indicator.gif' ",
	        "     style='visibility: hidden;' />",
	        "    <input type='button' id='btn_load' class='button'",
	        "     style='width:60px;' value='更新' />",
	        "  </td>",
	        "</tr>",
	        "</table>",
	        "<br/>",
	        "<table id='tbl_content' class='zebra'>",
	        "<tr>",
	        "  <th colspan='1' class='header'>",
	        "    ログファイル内容",
	        "  </th>",
	        "</tr>",
	        "<tr>",
	        "  <td colspan='1' class='noborder' id='td_textarea'>",
	        "    <textarea id='log_content' class='log' rows='25' cols='80'",
	        "     wrap='off' readonly='readonly' style='font-size: 11px;'>",
	        "${content}",
	        "    </textarea>",
	        "  </td>",
	        "</tr>",
	        "</table>"
	    ].join("\n"),
	    //------------------------------
	    // Event Handlers
	    //------------------------------
	    handlers : [
	        [
		        // SELECT
		        'sel_syslog', 'change', function() {
		            debug("select change");
		        }],
	        [
		        // '更新' button
		        'btn_load', 'click', function() {
		            var sel = parseInt($('sel_syslog').value, 10);
		            debug($jq.sprintf("load: No.%d", sel));
		            mod_syslog.ajax_loadLog(sel);
		        }]
	    ]
    },

    // dummy data
    data : {
	    selected : 0,
	    kinds : [
	        [ 'everything', "全て (everything)" ],
	        [ 'kernel', "カーネル関係 (kernel)" ],
	        [ 'ppp', "PPP関係 (ppp)" ],
	        [ 'sshd', "SSH関係 (sshd)" ]],
	    content : "ログを取得していません。"
    },

    //--------------------------------------------
    // Initialize
    //--------------------------------------------
    init : function(elem) {
	    var auth_data;
	    this.elem = elem;

	    // Auth check
	    auth_data = mod_auth.getAccountInfo();
	    if (auth_data == null || auth_data.authorized != 'true') {
	        load_module("auth", "content", true);

	        return;
	    }

	    this.render();
    },

    //--------------------------------------------
    // Render HTML (Main)
    //--------------------------------------------
    render : function() {
	    var html, parser, template;

	    template = this.template_main;

	    parser = new ZParse(Implementation);
	    parser.parse(template.HTMLtemplate);
	    html = parser.process(this.data);

	    this.elem.innerHTML = html;

	    set_handlers(template);
    },

    //================================================================
    //
    // Ajax functions
    //
    //================================================================

    //--------------------------------------------
    // LogFile load
    //--------------------------------------------
    ajax_loadLog : function(no) {
	    var auth_data;
	    var url, params, wsse_header;

	    auth_data = mod_auth.getAccountInfo();
	    wsse_header = wsseHeader(auth_data.account, auth_data.digest);

	    url = $jq.sprintf("/service/admin/syslog/%s", this.data.kinds[no][0]);
	    debug($jq.sprintf("syslog: url = '%s'", url));

	    params = {
	        method: "GET",
	        requestHeaders: [
		        'If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT',
		        'X-WSSE', wsse_header
	        ],
	        onFailure: function(httpObj) {
		        var status = httpObj.status;

		        this.hide_indicator('indicator');

		        switch (status) {
		        case 401:
		            alert("Authentication failed @ ajax_loadLog. (401)");
		            load_module('auth', 'content', true);
		            break;

		        case 500:
		            alert([ "ログファイルを取得できませんでした。",
			                "パーミッションの問題、もしくはログファイルがありません。"].join('\n'));
		            break;

		        default:
		            debug($jq.sprintf("Error %d.", status));
		            break;
		        }
	        }.bind(this),
	        onSuccess: function(httpObj) {
		        var result, data;

		        this.hide_indicator('indicator');
		        result = eval("(" + httpObj.responseText + ")");

		        // shortcut
		        data = mod_syslog.data;

		        data.selected = no;
		        data.content = result.content;

		        // IE対策
		        mod_syslog.render();
	        }.bind(this)
	    };

	    this.show_indicator('indicator');
	    new Ajax.Request(url, params);
    },

    //================================================================
    //
    // Utility functions
    //
    //================================================================

    // AJAX 処理開始
    show_indicator : function(elem) {
	    $(elem).style.visibility = 'visible';
    },

    // AJAX 処理完了
    hide_indicator : function(elem) {
	    $(elem).style.visibility = 'hidden';
    }

    //================================================================
    //
    // Event Handlers
    //
    //================================================================
};
