#! /usr/bin/env python
# -*- coding: utf-8 -*-

import os
import sys
import re
import signal
import syslog

def read_pidfile(file):
	f = open(file)
	p = f.read()
	f.close()
	return int(p)

if __name__ == '__main__':
	try:
		ppp = sys.argv[1]
	except:
		print "usage: python %s ppp[0-9]+" % sys.argv[0]
		sys.exit(1)

	try:
		unit = int(re.match("ppp([0-9]+)", ppp).groups()[0])
	except AttributeError:
		sys.exit(2)

	syslog.openlog("ppp_off")

	pidfile = "/var/run/ppp_wrapper.ppp%d" % unit
	if os.path.exists(pidfile):
		pid = read_pidfile(pidfile)
		try:
			syslog.syslog("killing ppp_wrapper(i/f=%s, pid=%d)" % (ppp, pid))
			os.kill(pid, signal.SIGTERM)
		except os.error, err:
			syslog.syslog("kill ppp_wrapper(pid=%d) error. '%s'" % (pid, str(err)))

	resultfile = "/var/state/ppp/result.ppp%d" % unit
	if os.path.exists(resultfile):
		syslog.syslog("remove %s" % resultfile)
		os.unlink(resultfile)

	statusfile = "/var/state/ppp/ppp%d" % unit
	if os.path.exists(statusfile):
		syslog.syslog("remove %s" % statusfile)
		os.unlink(statusfile)
