#! /bin/bash

clear_wdt() {
  while true; do
    echo 1 > /dev/watchdog
    sleep 10
  done
}

if lsmod | grep mxc_wdt &> /dev/null; then
  echo "mxc_wdt module is already installed."
  module_ok=1
else
  modprobe mxc_wdt timer_margin=120 &> /dev/null
  if [ "$?" = "0" ]; then
    module_ok=1
  else
    echo "install module 'mxc_wdt' failed."
    module_ok=0
  fi
fi

if [ "$module_ok" = 1 ]; then
  echo "start clearing mxc_wdt..."
  clear_wdt
fi
