#! /bin/bash

WDT_ENABLED=0

clear_wdt() {
  while true; do
    echo 1 > /dev/watchdog
    sleep 10
  done
}

# parse kernel command line.
for x in `cat /proc/cmdline`; do
  case $x in
  early_wdt=*)
    WDT_ENABLED=${x#early_wdt=}
    ;;
  esac
done


if [ "${WDT_ENABLED}" = "1" ]; then
  if lsmod | grep mxc_wdt &> /dev/null; then
    echo "mxc_wdt module is already installed."
    module_ok=1
  else
    modprobe mxc_wdt timer_margin=120 &> /dev/null
    if [ "$?" = "0" ]; then
      module_ok=1
    else
      echo "install module 'mxc_wdt' failed."
      module_ok=0
    fi
  fi

  if [ "$module_ok" = 1 ]; then
    clear_wdt
  fi
else
  echo "early watchdog timer is not enabled."
fi
