#
# iproute2 python module
#

from _tables    import *

import _ipaddr
import _iproute
import _iprule
import _ipmonitor

from _ipmonitor import FILTER

# support modules

#===========================================================
#
# ipaddr class
#
#===========================================================
class ipaddr(_ipaddr.__ipaddr):
	def get_device_list(self):
		all_info = self.get()
		devices = []

		for (idx, info) in all_info.items():
			if 'link' in info and 'name' in info['link']:
				devices.append(info['link']['name'])

		devices.sort()
		return devices

	def get_IPv4address(self, ifname):
		return self.__get_IPaddress(ifname, 'inet')

	def get_IPv6address(self, ifname):
		return self.__get_IPaddress(ifname, 'inet6')

	def get_link_flags(self, ifname):
		all_info = self.list()

		for (idx, info) in all_info.items():
			if 'link' in info and 'name' in info['link']:
				if info['link']['name'] == ifname:
					try:
						return info['link']['flags']
					except:
						return ['UNKNOWN']

		raise IndexError, "No such Interface '%s'." % ifname

	# internal
	def __get_IPaddress(self, ifname, family):
		all_info = self.list()

		for (idx, info) in all_info.items():
			if 'link' in info and 'name' in info['link']:
				if info['link']['name'] == ifname:
					if 'addr' in info:
						address_list = []

						for addr in info['addr']:
							if addr['family'] == family:
								address_list.append(addr)

						return address_list
					else:
						return []

		return None

#===========================================================
#
# iproute class
#
#===========================================================
class iproute(_iproute.__iproute):
	pass

#===========================================================
#
# iprule class
#
#===========================================================
class iprule(_iprule.__iprule):
	pass

#===========================================================
#
# ipmonitor class
#
#===========================================================
class ipmonitor(_ipmonitor.__ipmonitor):
	pass
