#! /bin/bash

echo "backup embedded_glibc"
cp -af embedded_glibc embedded_glibc.dist

echo "cd embedded_glibc.dist"
cd embedded_glibc.dist
ROOTFS_DIR=$PWD

echo "cd usr/lib/python2.6"
cd usr/lib/python2.6

find . -name "*.py[co]" | xargs rm
find . -name "test" | xargs rm -rf
find . -name "tests" | xargs rm -rf
rm -rf idlelib
python2.6 compileall.py .
find . -name "*.py" | xargs rm

cd ../../../
if [ ${ROOTFS_DIR} != $PWD ]; then
  exit 1
fi
rm -rf var/db/pkg
rm -rf var/cache/edb
mv var .var.rom
mkdir var

mksquashfs-lzma usr opt/system/usr.sqfs
#mksquashfs usr opt/system/usr.sqfs -comp xz

mkdir -p ../usr_backup
rm -rf ../usr_backup/*
mv usr/* ../usr_backup
mkdir -p usr/lib/gcc/arm-linux-gnueabi/4.3.4
cp -a ../usr_backup/lib/gcc/arm-linux-gnueabi/4.3.4/libgcc_s.so* usr/lib/gcc/arm-linux-gnueabi/4.3.4/

mkfs.jffs2 -e 0x20000 --pad=0x1c00000 -o ../rootfs.jffs2
